/******************************************************************************
Copyright LSI Logic Ltd 2001
  
abm_tst.h - ABMTEST Header file
******************************************************************************/
#ifndef ABMTEST_MODULE_H
#define ABMTEST_MODULE_H


#ifndef _WIN32
    #ifdef __KERNEL__
        MODULE_AUTHOR ("Stephen Hill <shill@lsil.com>");
        MODULE_DESCRIPTION ("ABM TESTER");
    #else
    #endif
#endif

/* debugging */
#undef PDEBUG
#ifndef _WIN32
#   ifdef ABM_TEST_DEBUG
#       ifdef __KERNEL__
#           define PDEBUG printk
#       else
#           define PDEBUG(args...) fprintf(stderr, ##args)
#       endif
#   else
#       define PDEBUG(args...)
#   endif
#else
#   ifdef ABM_TEST_DEBUG
#       define PDEBUG printf
#   else
#       define PDEBUG()
#   endif
#endif





#endif
/******************************************************************************
End of abm_tst.h
******************************************************************************/
