/****************************************************************************
 *
 *  Copyright (c) 2001 by LSI Logic Corporation, all rights reserved.
 *
 *                         LSI Logic confidential
 *  The information contained herein is proprietary of LSI Logic Corporation.
 *
 *  This software is provided "as is" without any express or implied warranty.
 *  LSI Logic disclaims all representations and warranties with regard to
 *  this software, including all implied warranties of merchantability and
 *  fitness for a particular purpose. In no event shall LSI Logic be liable
 *  for any special, indirect or consequential damages or any damages
 *  whatsoever resulting from loss of use, data or profits, whether in an
 *  action of contract, negligence or other tortious act or omission,
 *  arising out of or in connection with the use or performance of this
 *  software.
 *
 *  File Description:
 *
 *  Header file for flash-specific routines.
 *
 ****************************************************************************/

#ifndef _FLASHMEMCPY_H
#define _FLASHMEMCPY_H

#include "bootloader.h"
#include <linux/linkage.h>

PUBLIC asmlinkage void FlashMemcpy(__u32 dest, __u32 src, __u32 len);

#endif
