#include <sys/errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdarg.h>
#include <fcntl.h>
#include <sys/ioctl.h>

void do_command(char *cmd, ...)
{
        va_list args;
        char *param[40];
        int i=0, background=0;
        pid_t pid;
                
        va_start(args, cmd);
        for (;;) {
                if (!(param[i++] = va_arg(args, char*)))
                        break;
        }
        va_end(args);

        if (!strcmp(param[i-2],"&")) {
                background = 1;
                param[i-2] = 0;
        }

        if (!(pid = vfork())) {
		execvp(cmd, param);
                _exit(0);
        }
        else if (!background && pid > 0)
		waitpid(pid, NULL, 0);
}
