
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <linux/if_ether.h>
#include "cli.h"
#include "ether_cmd.h"



extern void cli_dmt_write_cmd(int cmd, int option);
extern int port_status();
extern int doPortCtrl(int argc, char *argv[], void *p); // KenWang added 2005/11/29

int doipaddr(int argc,char *argv[],void *p)
{
	char *argv_ptr = *(argv+1);
        char buf[80];
        char linebuf[128];
        struct ifreq ifr;
        struct sockaddr_in sai;
        struct sockaddr sa;
        char *tmp;
        int sockfd;  /* socket fd we use to manipulate stuff with */
      
        if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		printf("socket fail");
	      }
        if(argc == 2)
        {
              	strcpy(ifr.ifr_name, "br0");
                
               if(ioctl(sockfd, SIOCGIFFLAGS, &ifr) < 0)
                {
                  printf("Try next -->eth0\n");
                  strcpy(ifr.ifr_name, "eth0");
                  sai.sin_family = AF_INET;
                  sai.sin_port = 0;
                  inet_aton(argv_ptr, &sai.sin_addr);
                  tmp = (char *) &sai;
                  memcpy(((char *)(&ifr.ifr_addr)),tmp, sizeof(struct sockaddr));
                 if (ioctl(sockfd, SIOCSIFADDR, &ifr) < 0) 
                 {
                    printf("Set Lan IPaddr fail\n");	
                      return 0;
                 }
                }else
                 {
                    printf("set br0 as Lan IPaddr\n");
                    sai.sin_family = AF_INET;
                    sai.sin_port = 0;
                    inet_aton(argv_ptr, &sai.sin_addr);
                    tmp = (char *) &sai;
                    memcpy(((char *)(&ifr.ifr_addr)),tmp, sizeof(struct sockaddr));
                    if (ioctl(sockfd, SIOCSIFADDR, &ifr) < 0)
                     {
                       printf("Set Lan IPaddr fail\n"); 
                     }
                  
                 }
	}	
        else
	{
          
          strcpy(ifr.ifr_name, "br0");
          ifr.ifr_addr.sa_family=AF_INET;
           if(ioctl(sockfd, SIOCGIFFLAGS, &ifr) < 0)
           {
               strcpy(ifr.ifr_name, "eth0");
               ifr.ifr_addr.sa_family=AF_INET;
               if( ioctl(sockfd, SIOCGIFADDR, &ifr)<0)
                  {
                   printf("get IP addr fail\n");
                   return 0;
                  }
              tmp = (char *)&ifr.ifr_addr;
              memcpy(((char *)(&sai)),tmp, sizeof(struct sockaddr));
              strcpy(buf,inet_ntoa(sai.sin_addr));
              printf("%s\n",buf);
           }
           else
            {
             if( ioctl(sockfd, SIOCGIFADDR, &ifr)<0)
                  {
                   printf("get IP addr fail\n");
                   return 0;
                  }
            tmp = (char *)&ifr.ifr_addr;
            memcpy(((char *)(&sai)),tmp, sizeof(struct sockaddr));
            strcpy(buf,inet_ntoa(sai.sin_addr));
            printf("%s\n",buf);
          }
       }
                
		return 0;
} /* doHostname */


int doPortstat(int argc, char *argv[], void *p)
{
	if(argc != 1) {
		printf("Usage : lan portstat\n");
		return 0;
	}

	port_status();
	return 0;
}

const cmds_table etherCmds[] = {

	
	
	{"ipaddr",    doipaddr, Normal_Level, 1, "lan ipaddr <ip address>"},
	{"portstat",    doPortstat, Normal_Level, 1, "lan portstat"},
	{"portctrl",  doPortCtrl, Normal_Level, 2, "lan portctrl <num> <auto|force> <10|100> <half|full>"}, // KenWang added 2005/11/29
	{NULL,		NULL,		0,	  0, NULL},

};






