/* INPUT TABLE start */
#define RUNFUNC_C_INPUT_TCP_HTTPSR_PORT_DEST_DROP 7
#define RUNFUNC_C_INPUT_TCP_DEST_ACCEPT 9
#define RUNFUNC_C_INPUT_TCP_SRC_DPORT_ACCEPT 12
#define RUNFUNC_C_INPUT_UDP_SRC_DPORT1900_ACCEPT 13
#define RUNFUNC_C_INPUT_TCP_SRC_DPORT2600_ACCEPT 16
#define RUNFUNC_C_INPUT_UDP_SRC_DPORT520_ACCEPT 17
#define RUNFUNC_C_INPUT_UDP_SRC_DPORT161_ACCEPT 20
#define RUN_IPSEC_C_INPUT_UDP_WAN_IF_RIP_DPORT500_ACCEPT 36
#define RUN_IPSEC_C_INPUT_ESP_WAN_IF_RIP_ACCEPT 37
#define RUN_IPSEC_C_INPUT_AH_WAN_IF_RIP_ACCEPT 38
#define RUN_IPSEC_C_INPUT_IPSEC_ACCEPT 39
#define MACF_C_INPUT_MF_INT 53
#define FW_INIT_SH_INPUT_MF_INT 53
#define FW_INIT_SH_INPUT_BLK_WAN_INT 67
#define FW_INIT_SH_INPUT_HCK_INP 69
#define FW_INIT_SH_INPUT_ICMP_ECHO_REQUEST_BAD_PING 71
#define FW_INIT_SH_INPUT_REMOTE_INT 75
#define FW_INIT_SH_INPUT_LAN_ACCESS 76
#define FW_INIT_SH_INPUT_SIP_INT 78
#define FW_INIT_SH_INPUT_MSS_INT 89
#define FW_INIT_SH_INPUT_UPNP_INT 90
#define FW_INIT_SH_INPUT_SNMP_INT 91
#define FW_INIT_SH_INPUT_RIP_INT 92
#define HACK_IPT_STOP_SH_INPUT_HCK_INP 69
#define HACK_IPT_STOP_SH_INPUT_ICMP_BAD_PING 71
#define SIP_IPT_ADD_SH_VOIP_INPUT_DEST_DROP 93
#define SIP_IPT_ADD_SH_VOIP_INPUT_DEST_ACCEPT 94
#define SIP_IPT_ADD_SH_VOIP_INPUT_DEST_NEW_ACCEPT 95
#define SIP_IPT_ADD_SH_VOIP_INPUT_DEST_LAN_NEW_ACCEPT 96
#define WAN_CONNECT_SH_INPUT_UDP_SRC_DPORT520_ACCEPT 17
#define WAN_CONNECT_SH_INPUT_TCP_SRC_DPORT2600_ACCEPT 16
#define EMBEDDED_SH_INPUT_LAN_IF_TCP_DPORT_ACCEPT 108
#define RIP_SH_INPUT_UDP_SRC_DPORT520_ACCEPT 17
#define RIP_SH_INPUT_TCP_SRC_DPORT2600_ACCEPT 16
#define BLK_WAN_START_IPT_SH_INPUT_ICMP_WAN_IF_DROP 111
#define BLK_WAN_START_IPT_SH_INPUT_ICMP_LOG_WAN_IF_DROP 112
#define CLOSE_WAN_PORT_IPT_ADD_SH_INPUT_TCP_DEST_DROP 123
#define CLOSE_WAN_PORT_IPT_ADD_SH_INPUT_UDP_DEST_DROP 124
#define SIP_IPT_ADD_SH_INPUT_WAN_IP_INVALID_DROP 93
#define SIP_IPT_ADD_SH_INPUT_WAN_IP_ACCEPT 94
#define SIP_IPT_ADD_SH_INPUT_WAN_IP_LO_ACCEPT 95
#define SIP_IPT_ADD_SH_INPUT_WAN_IP_LAN_IF_ACCEPT 96
#define SIP_IPT_ADD_SH_INPUT_WAN_IP_UDP_DPORT_1024_65535_DROP 103
#define HACK_IPT_START_SH_INPUT_WAN_IF_HCK_INP 69
#define HACK_IPT_START_SH_INPUT_ICMP_WAN_IF_BAD_PING 71
#define SNMPD_SH_INPUT_UDP_LAN_DPORT161_ACCEPT 20
/* INPUT TABLE end */
/* FORWARD TABLE start */
#define PF_C_FORWARD_PKT_FLT 31
#define RUN_IPSEC_C_FORWARD_IN_IPSEC_ACCEPT 40
#define RUN_IPSEC_C_FORWARD_OUT_IPSEC_ACCEPT 41
#define RUN_IPSEC_C_FORWARD_OUT_IPSEC_TCPMSS 46
#define RUN_IPSEC_C_FORWARD_IN_IPSEC_TCPMSS 47
#define MACF_C_FORWARD_MF_FWD 52
#define URLFLT_C_FORWARD_TCP_LANIP_DPORT80_URL_FLT 60
#define FW_INIT_SH_FORWARD_TCP80_URL_FLT 60
#define FW_INIT_SH_FORWARD_PKT_FLT 31
#define FW_INIT_SH_FORWARD_MF_FWD 52
#define FW_INIT_SH_FORWARD_BLK_WAN_FWD 66
#define FW_INIT_SH_FORWARD_HCK_FWD 70
#define FW_INIT_SH_FORWARD_DMZ_FWD 81
#define FW_INIT_SH_FORWARD_VS_FWD 82
#define FW_INIT_SH_FORWARD_UPNP_FWD 84
#define FW_INIT_SH_FORWARD_MSS_FWD 85
#define HACK_IPT_STOP_SH_FORWARD_HCK_FWD 70
#define TCPMSS_IPT_SPRAY_ADD_FORWARD_OUT_LAN_IF_TCP_SET_MSS1450 104
#define TCPMSS_IPT_SPRAY_ADD_FORWARD_IN_LAN_IF_TCP_CLAMP_MSS_TO_PMTU 105
#define TCPMSS_IPT_ADD_FORWARD_OUT_LAN_IF_TCP_CLAMP_MSS_TO_PMTU 104
#define TCPMSS_IPT_ADD_FORWARD_IN_LAN_IF_TCP_CLAMP_MSS_TO_PMTU 105
#define TMSS_SH_FORWARD_TCP_SRC_DPORT80_TMSS 122
#define BLK_WAN_START_IPT_SH_FORWARD_ICMP_LAN_IF_DROP 109
#define BLK_WAN_START_IPT_SH_FORWARD_ICMP_LOG_LAN_IF_DROP 110
#define HACK_IPT_START_SH_FORWARD_WAN_IF_HCK_FWD 70
/* FORWARD TABLE end */
/* OUTPUT TABLE start */
#define FW_INIT_SH_OUTPUT_MSS_OUT 88
#define TCPMSS_IPT_SPRAY_ADD_OUTPUT_TCP_CLAMP_MSS_TO_PMTU 107
#define TCPMSS_IPT_ADD_OUTPUT_TCP_CLAMP_MSS_TO_PMTU 107
/* OUTPUT TABLE end */
/* NAT PREROUTING TABLE start */
#define IPT_SH_NAT_PREROUTING_TCP80_REDIRECT_TO10080 4
#define RUNFUNC_C_NAT_PREROUTING_TCP_HTTPSR_PORT_DEST_DROP 8
#define RUNFUNC_C_NAT_PREROUTING_TCP_DEST_ACCEPT 10
#define RUNFUNC_C_NAT_PREROUTING_TCP_SRC_DPORT_ACCEPT 14
#define RUNFUNC_C_NAT_PREROUTING_UDP_SRC_DPORT1900_ACCEPT 15
#define RUNFUNC_C_NAT_PREROUTING_TCP_SRC_DPORT2600_ACCEPT 18
#define RUNFUNC_C_NAT_PREROUTING_UDP_SRC_DPORT520_ACCEPT 19
#define RUNFUNC_C_NAT_PREROUTING_UDP_SRC_DPORT161_ACCEPT 21
#define RUN_IPSEC_C_NAT_PREROUTING_ESP_WAN_IF_RIP_ACCEPT 42
#define RUN_IPSEC_C_NAT_PREROUTING_AH_WAN_IF_RIP_ACCEPT 43
#define RUN_IPSEC_C_NAT_PREROUTING_IN_IPSEC_ACCEPT 44
#define FAKED_DNS_PROXY_STOP_SH_NAT_PREROUTING_UDP_53REDIRECTTO10053 65
#define PPPOE_PROXY_STOP_SH_NAT_PREROUTING_TCP_80REDIRECTTO10080 4
#define FW_INIT_SH_NAT_PREROUTING_HCK_PRT 68
#define FW_INIT_SH_NAT_PREROUTING_DMZ_PRT 50
#define FW_INIT_SH_NAT_PREROUTING_VS_PRT 48
#define SETVS_C_NAT_PREROUTING_VS_PRT 48
#define SETVS_C_NAT_PREROUTING_DMZ_PRT 50
#define FW_INIT_SH_NAT_PREROUTING_UPNP_PRT 83
#define HACK_IPT_STOP_SH_NAT_PREROUTING_HCK_PRT 68
#define SIP_IPT_DEL_SH_VOIP_NAT_PREROUTING_INVALID_DROP 97
#define SIP_IPT_DEL_SH_VOIP_NAT_PREROUTING_ACCEPT 98
#define SIP_IPT_DEL_SH_VOIP_NAT_PREROUTING_LO_NEW_ACCEPT 99
#define SIP_IPT_DEL_SH_VOIP_NAT_PREROUTING_LAN_IF_NEW_ACCEPT 100
#define BLK_WAN_START_IPT_SH1_NAT_PREROUTING_ICMP_WAN_IF_DROP 113
#define BLK_WAN_START_IPT_SH1_NAT_PREROUTING_ICMP_LOG_WAN_IF_DROP 114
#define BLK_WAN_STOP_IPT_SH_NAT_PREROUTING_ICMP_WAN_IF_DROP 113
#define BLK_WAN_STOP_IPT_SH_NAT_PREROUTING_ICMP_LOG_WAN_IF_DROP 114
#define CLOSE_WAN_PORT_IPT_DEL_SH_NAT_PREROUTING_TCP_WAN_IP_DROP 125
#define CLOSE_WAN_PORT_IPT_DEL_SH_NAT_PREROUTING_UDP_WAN_IP_DROP 126
#define SIP_IPT_DEL_SH_NAT_PREROUTING_INVALID_DROP 97
#define SIP_IPT_DEL_SH_NAT_PREROUTING_ACCEPT 98
#define SIP_IPT_DEL_SH_NAT_PREROUTING_LO_ACCEPT 99
#define SIP_IPT_DEL_SH_NAT_PREROUTING_LAN_IF_ACCEPT 100
#define SIP_IPT_DEL_SH_NAT_PREROUTING_UDP_DPORT_1024_65535_DROP 102
#define HACK_IPT_START_SH_NAT_PREROUTING_WAN_IF_HCK_PRT 68
#define SIP_IPT_ADD_SH1_NAT_PREROUTING_WAN_IP_INVALID_DROP 97
#define SIP_IPT_ADD_SH1_NAT_PREROUTING_WAN_IP_ACCEPT 98
#define SIP_IPT_ADD_SH1_NAT_PREROUTING_WAN_IP_LO_NEW_ACCEPT 99
#define SIP_IPT_ADD_SH1_NAT_PREROUTING_WAN_IP_LAN_IF_NEW_ACCEPT 100
#define SIP_IPT_ADD_SH1_NAT_PREROUTING_WAN_IP_UDP_DPORT_1024_65535_DROP 102
#define TMSS_IPT_SH_NAT_PREROUTING_TCP53_REDIRECT_TO10053 65
/* NAT PREROUTING TABLE end */
/* NAT POSTROUTING TABLE start */
#define IPT_SH_NAT_POSTROUTING_MASQUERADE 3
#define RUN_IPSEC_C_NAT_POSTROUTING_OUT_IPSEC_MASQUERADE 45
#define FW_INIT_SH_NAT_POSTROUTING_NAT_POSTRT 77
#define FW_INIT_SH_NAT_POSTROUTING_SIP_POSTRT 79
#define SIP_IPT_ADD_SH1_VOIP_NAT_POSTROUTING_WAN_IF_SRC_DEST_DROP 101
#define NAT_SH_NAT_POSTROUTING_SRC_MASQUERADE_WAN_IF 3
#define CLOSE_WAN_PORT_IPT_DEL_SH_NAT_POSTROUTING_TCP_SPORT_0_1_DROP 127
#define SIP_IPT_DEL_SH_NAT_POSTROUTING_WAN_IF_SRC_DEST_DROP 101
#define NAT_IPT_SH_NAT_POSTROUTING_MASQUERADE_WAN_IF 188
#define NAT_IPT_SH_NAT_POSTROUTING_SRC_MASQUERADE 189
#define SIP_IPT_ADD_SH1_NAT_POSTROUTING_WAN_IF_SRC_DROP 101
#define TCPMSS_IPT_ADD1_NAT_POSTROUTING_TCP_CLAMP_MSS_TO_PMTU 190
/* NAT POSTROUTING TABLE end */
/* MANGLE PREROUTING TABLE start */
#define FW_INIT_SH_MANGLE_PREROUTING_MSS_MG_PRT 86
/* MANGLE PREROUTING TABLE end */
/* MANGLE FORWARD TABLE start */
#define RUN_QOS_C_MANGLE_FORWARD_WAN_IF_MYSHAPER_IN 23
#define RUN_QOS_C_MANGLE_FORWARD_DSCP 27
#define RUN_QOS_C_MANGLE_FORWARD_UDP_DSCP 28
/* MANGLE FORWARD TABLE end */
/* MANGLE POSTROUTING TABLE start */
#define RUN_QOS_C_MANGLE_POSTROUTING_WAN_IF_MYSHAPER_OUT 22
#define FW_INIT_SH_MANGLE_POSTROUTING_MSS_MG_POSTRT 87
#define TCPMSS_IPT_SPRAY_ADD_MANGLE_POSTROUTING_TCP_CLAMP_MSS_TO_PMTU 106
#define TCPMSS_IPT_ADD_MANGLE_POSTROUTING_TCP_CLAMP_MSS_TO_PMTU 106
/* MANGLE POSTROUTING TABLE end */
/* MANGLE MYSHAPER_IN TABLE start */
#define RUN_QOS_C_MANGLE_MYSHAPER_IN_IMQ_TODEV0 24
#define RUN_QOS_C_MANGLE_MYSHAPER_IN_MARK 29
#define RUN_QOS_C_MANGLE_MYSHAPER_IN_UDP_MARK 30
/* MANGLE MYSHAPER_IN TABLE end */
/* MANGLE MYSHAPER_OUT TABLE start */
#define RUN_QOS_C_MANGLE_MYSHAPER_OUT_MARK 25
#define RUN_QOS_C_MANGLE_MYSHAPER_OUT_UDP_MARK 26
/* MANGLE MYSHAPER_OUT TABLE end */
/* MF_INT TABLE start */
#define FACTORYRESET_C_MF_INT_MAC 1
#define MACF_C_MF_INT_TCP_LANIP_ACCEPT 55
#define MACF_C_MF_INT_MAC_LOG 57
#define MACF_C_MF_INT_MAC 1
#define MACF_C_MF_INT_DROP 59
/* MF_INT TABLE end */
/* MF_FWD TABLE start */
#define FACTORYRESET_C_MF_FWD_MAC 2
#define MACF_C_MF_FWD_TCP_LANIP_ACCEPT 54
#define MACF_C_MF_FWD_MAC_LOG 56
#define MACF_C_MF_FWD_MAC 2
#define MACF_C_MF_FWD_DROP 58
/* MF_FWD TABLE end */
/* UPNP_PRT TABLE start */
#define UPNP_LINUX_IGD_C_NAT_UPNP_PRT_WAN_IF_DNAT_TO_LAN 5
/* UPNP_PRT TABLE end */
/* UPNP_FWD TABLE start */
#define UPNP_LINUX_IGD_C_UPNP_FWD_LAN_ACCEPT 6
/* UPNP_FWD TABLE end */
/* HCK_PRT TABLE start */
#define RUNFUNC_C_NAT_HCK_PRT_TCP_DEST_ACCEPT 11
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_WAN_IP_DPORT_0_1055_DROP 128
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_WAN_IP_DPORT_0_1055_DROP 130
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_WAN_IP_DROP 132
#define HACK_IPT_START_SH_NAT_HCK_PRT_HACK16_LOG 135
#define HACK_IPT_START_SH_NAT_HCK_PRT_INVALID_HACK16_DROP 138
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_DPORTS_HACK15_LOG 142
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_DPORTS_HACK15_DROP 144
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_DPORT31337_HACK14_LOG 146
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_DPORT31337_HACK14_DROP 148
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_DPORTS_HACK13_LOG 150
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_DPORTS_HACK13_DROP 152
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_HACK12_LOG 154
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_HACK12_DROP 156
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_HACK10_LOG 158
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_HACK10_DROP 160
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_DEST_DROP 162
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_HACK9_LOG 164
#define HACK_IPT_START_SH_NAT_HCK_PRT_TCP_HACK9_DROP 166
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK6_LOG 168
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK6_DROP 170
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK3_LOG 172
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK3_DROP 174
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK2_7_LOG 176
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK2_7_DROP 178
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK2_17_LOG 176
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK2_17_DROP 178
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK2_19_LOG 176
#define HACK_IPT_START_SH_NAT_HCK_PRT_UDP_HACK2_19_DROP 178
#define HACK_IPT_START_SH_NAT_HCK_PRT_HACK1_LOG 180
#define HACK_IPT_START_SH_NAT_HCK_PRT_HACK1_DROP 182
#define HACK_IPT_START_SH_NAT_HCK_PRT_WAN_IP_WAN_IP_DROP 184
#define HACK_IPT_START_SH_NAT_HCK_PRT_LAN_IP_LAN_IP_DROP 185
/* HCK_PRT TABLE end */
/* PKT_FLT TABLE start */
#define PF_C_PKT_FLT_LOG_PFDROP 32
#define PF_C_PKT_FLT_PFDROP 33
#define PF_C_PKT_FLT_SRC_DST_LOG_PFDROP 34
#define PF_C_PKT_FLT_SRC_DST_PFDROP 35
/* PKT_FLT TABLE end */
/* VS_PRT TABLE start */
#define SETVS_C_VS_PRT_NAT_DEST_DNAT 49
/* VS_PRT TABLE end */
/* DMZ_PRT TABLE start */
#define SETVS_C_DMZ_PRT_NAT_DEST_DNAT 51
/* DMZ_PRT TABLE end */
/* UF_REJ TABLE start */
#define URLFLT_C_UF_REJ_TCP_REJECT 61
/* UF_REJ TABLE end */
/* URL_FLT TABLE start */
#define URLFLT_C_URL_FLT_TCP_WEBSTR_CONTENT_UF_REJ 62
#define URLFLT_C_URL_FLT_TCP_WEBSTR_URL_UF_REJ 63
#define URLFLT_C_URL_FLT_TCP_WEBSTR_HOST_UF_REJ 64
/* URL_FLT TABLE end */
/* BAD_PING TABLE start */
#define HACK_IPT_STOP_SH_BAD_PING_ICMP_RETURN 72
#define HACK_IPT_STOP_SH_BAD_PING_ICMP_LOG 73
#define HACK_IPT_STOP_SH_BAD_PING_ICMP_REJECT 74
#define HACK_IPT_START_SH_BAD_PING_ICMP_WAN_IF_HACK5_RETURN 72
#define HACK_IPT_START_SH_BAD_PING_ICMP_LOG_WAN_IF_HACK5_RETURN 73
#define HACK_IPT_START_SH_BAD_PING_ICMP_WAN_IF_HACK5_REJECT 74
/* BAD_PING TABLE end */
/* TMSS TABLE start */
#define TMSS_SH_TMSS_TCP_1RETURN 115
#define TMSS_SH_TMSS_TCP_TMSS_AVE 116
#define TMSS_SH_TMSS_TCP_4RETURN 117
#define TMSS_SH_TMSS_TCP_TMSS_BLK 118
#define TMSS_SH_TMSS_TCP_DROP 119
#define TMSS_SH_TMSS_AVE_TCP_REJECT_WITH_ICMP_ADMIN_PROHIBITED 120
#define TMSS_SH_TMSS_BLK_TCP_REJECT_WITH_ICMP_HOST_PROHIBITED 121
/* TMSS TABLE end */
/* HCK_FWD TABLE start */
#define HACK_IPT_START_SH_HCK_FWD_HACK16_LOG 136
#define HACK_IPT_START_SH_HCK_FWD_INVALID_HACK16_DROP 139
#define HACK_IPT_START_SH_HCK_FWD_ICMP_LAN_IF_DROP 141
/* HCK_FWD TABLE end */
/* HCK_INP TABLE start */
#define HACK_IPT_START_SH_HCK_INP_TCP_WAN_IP_DPORT_0_65535_DROP 129
#define HACK_IPT_START_SH_HCK_INP_UDP_WAN_IP_DPORT_0_1055_DROP 131
#define HACK_IPT_START_SH_HCK_INP_TCP_WAN_IP_DROP 133
#define HACK_IPT_START_SH_HCK_INP_HACK16_LOG 134
#define HACK_IPT_START_SH_HCK_INP_INVALID_HACK16_DROP 137
#define HACK_IPT_START_SH_HCK_INP_DEST_LO_8_REJECT 140
#define HACK_IPT_START_SH_HCK_INP_TCP_DPORTS_HACK15_LOG 143
#define HACK_IPT_START_SH_HCK_INP_TCP_DPORTS_HACK15_DROP 145
#define HACK_IPT_START_SH_HCK_INP_UDP_DPORT31337_HACK14_LOG 147
#define HACK_IPT_START_SH_HCK_INP_UDP_DPORT31337_HACK14_DROP 149
#define HACK_IPT_START_SH_HCK_INP_TCP_DPORTS_HACK13_LOG 151
#define HACK_IPT_START_SH_HCK_INP_TCP_DPORTS_HACK13_DROP 153
#define HACK_IPT_START_SH_HCK_INP_TCP_HACK12_LOG 155
#define HACK_IPT_START_SH_HCK_INP_TCP_HACK12_DROP 157
#define HACK_IPT_START_SH_HCK_INP_TCP_HACK10_LOG 159
#define HACK_IPT_START_SH_HCK_INP_TCP_HACK10_DROP 161
#define HACK_IPT_START_SH_HCK_INP_TCP_DEST_DROP 163
#define HACK_IPT_START_SH_HCK_INP_TCP_HACK9_LOG 165
#define HACK_IPT_START_SH_HCK_INP_TCP_HACK9_DROP 167
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK6_LOG 169
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK6_DROP 171
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK3_LOG 173
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK3_DROP 175
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK2_7_LOG 177
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK2_7_DROP 179
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK2_17_LOG 177
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK2_17_DROP 179
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK2_19_LOG 177
#define HACK_IPT_START_SH_HCK_INP_UDP_HACK2_19_DROP 179
#define HACK_IPT_START_SH_HCK_INP_HACK1_LOG 181
#define HACK_IPT_START_SH_HCK_INP_HACK1_DROP 183
#define HACK_IPT_START_SH_HCK_INP_WAN_IP_WAN_IP_DROP 186
#define HACK_IPT_START_SH_HCK_INP_LAN_IP_LAN_IP_DROP 187
/* HCK_INP TABLE end */

