/*
 * IPSEC
 */
#ifndef __RUN_FUNC_H__
#define __RUN_FUNC_H__
#define FIREWALL_FUNCTIONS 0
#define FUNCTION_NUM_TIME_ZONE 1   
#define FUNCTION_NUM_DDNS 2   
#define FUNCTION_NUM_STATIC_ROUTE_LAN 3   
#define FUNCTION_NUM_STATIC_ROUTE_WAN 4   
#define FUNCTION_NUM_BLOCK_HACK 5
#define FUNCTION_NUM_ALERT_MAIL_ONLY 6  
#define FUNCTION_NUM_URL_FILTER 7
#define FUNCTION_NUM_MAC_FILTER 8
#define FUNCTION_NUM_BLOCK_WAN 9
#define FUNCTION_NUM_EMBEDED_WEB_SERVER 10
#define FUNCTION_NUM_REMOTE_CONFIG 11
#define FUNCTION_NUM_UPNP 12
#define FUNCTION_NUM_RIP 13
#define FUNCTION_NUM_SNMP 14
#define FUNCTION_NUM_VIRTUAL_SERVER_DMZ 15
#define FUNCTION_NUM_PACKET_FILTER 16
#define FUNCTION_NUM_QOS 17
#define FUNCTION_NUM_TMSS 18
#define FUNCTION_NUM_SIP_PROXY 19
#define FUNCTION_NUM_IPSEC_MANUAL_CONNECT 20
#define FUNCTION_NUM_IPSEC_START 21
#define FUNCTION_NUM_IPSEC_PLUTO 22
#define FUNCTION_NUM_IGMP_PROXY 23
#define FUNCTION_NUM_IGMP_SNOOPING 24
#define FUNCTION_NUM_ADSL 25
#define FUNCTION_NUM_WIRELESS 26
#define FUNCTION_NUM_WIRELESS_SEC 27
#define FUNCTION_NUM_PPPOE 28
#define FUNCTION_NUM_CLOSE_WAN_PORT 29
#define FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT 30
#define FUNCTION_NUM_ACT 31
#define FUNCTION_NUM_ACTACT 32
// KenWang added 2005/06/10
#define FUNCTION_NUM_WIRELESS_MAC_FILTER 33
/* KenWang added 2005/12/23 -- begin -- */
#define FUNCTION_NUM_OTHER_WAN_BRIDGE 34
#define FUNCTION_NUM_VLAN 35
/* KenWang added 2005/12/23 -- end -- */
#define FUNCTION_NUM_TELNET_CONFIG 40
#define FUNCTION_NUM_PORT_CTRL 41 // KenWang added 2005/11/21

#define BLANK_SYMBOL "&"
#define VAR_ETC_STATUS_FILE "/var/etc/status"

#define HACK_IPTBALE_START_SHELL "/etc/scripts/hack_ipt_start.sh"                                                                                                            
#define HACK_IPTBALE_STOP_SHELL "/etc/scripts/hack_ipt_stop.sh"                                                                                                            

#define INIT_IPTBALE_SHELL "/etc/scripts/init_ipt.sh"                                                                                                            

#define NAT_IPTBALE_SHELL "/etc/scripts/nat_ipt.sh"                                                                                                            

//#define STATIC_ROUTE_CONF_RULE_ADD_IPTBALE_SHELL "/var/etc/route.conf.rule.add"                                                                                                            

#define URL_FILTER_CONF_RULE_ADD_IPTBALE_SHELL "/var/etc/uf.conf.rule.add"                                                                                                            
#define URL_FILTER_CONF_RULE_DEL_IPTBALE_SHELL "/var/etc/uf.conf.rule.del"                                                                                                            

#define PACKET_FILTER_CONF_RULE_ADD_IPTBALE_SHELL "/var/etc/pfilter.conf.rule.add"                                                                                                            
#define PACKET_FILTER_CONF_RULE_DEL_IPTBALE_SHELL "/var/etc/pfilter.conf.rule.del"                                                                                                            

#define MAC_FILTER_CONF_RULE_ADD_IPTBALE_SHELL "/var/etc/macf.conf.rule.add"                                                                                                            
#define MAC_FILTER_CONF_RULE_DEL_IPTBALE_SHELL "/var/etc/macf.conf.rule.del"                                                                                                            

#define BLOCK_WAN_START_IPTBALE_SHELL "/etc/scripts/blk_wan_start_ipt.sh"                                                                                                            
#define BLOCK_WAN_START_IPTBALE_SHELL1 "/etc/scripts/blk_wan_start_ipt.sh1"                                                                                                            
#define BLOCK_WAN_STOP_IPTBALE_SHELL "/etc/scripts/blk_wan_stop_ipt.sh"                                                                                                            

#define REMOTE_CONFIG_ADD_IPTBALE_SHELL "/var/etc/remote_config.add"                                                                                                            
#define REMOTE_CONFIG_DEL_IPTBALE_SHELL "/var/etc/remote_config.del"                                                                                                            

#define DMZ_CONF_RULE_ADD_IPTBALE_SHELL "/var/etc/dmz.conf.add"                                                                                                            
#define DMZ_CONF_RULE_DEL_IPTBALE_SHELL "/var/etc/dmz.conf.del"                                                                                                            

#define VIRTUAL_SERVER_CONF_RULE_ADD_IPTBALE_SHELL "/var/etc/vs.conf.add"  
#define VIRTUAL_SERVER_CONF_RULE_DEL_IPTBALE_SHELL "/var/etc/vs.conf.del"  

#define TMSS_IPTBALE_SHELL "/etc/scripts/tmss_ipt.sh"                                                                                                                                                                                                                     

#define TCPMSS_ADD_IPTBALE_SHELL "/etc/scripts/tcpmss_ipt.add"                                                                                                            
#define TCPMSS_ADD_IPTBALE_SHELL1 "/etc/scripts/tcpmss_ipt.add1"                                                                                                            
#ifdef _sso_spary
// only for Spray old F-secure
#define TCPMSS_ADD_IPTBALE_SHELL_SPRAY "/etc/scripts/tcpmss_ipt_spray.add"                                                                                                            
#endif
#define TCPMSS_DEL_IPTBALE_SHELL "/etc/scripts/tcpmss_ipt.del"                                                                                                            

#define UPNP_ADD_IPTBALE_SHELL "/var/etc/pnp_ipt.add"                                                                                                            
#define UPNP_DEL_IPTBALE_SHELL "/var/etc/pnp_ipt.del"                                                                                                            

#define RIP_ADD_IPTBALE_SHELL "/var/etc/rip_ipt.add"                                                                                                            
#define RIP_DEL_IPTBALE_SHELL "/var/etc/rip_ipt.del"                                                                                                            

#define SNMP_ADD_IPTBALE_SHELL "/var/etc/snmp_ipt.add"                                                                                                            
#define SNMP_DEL_IPTBALE_SHELL "/var/etc/snmp_ipt.del"                                                                                                            

#define QOS_CONF_FN_RULE_IPT_ADD    "/var/etc/qos.conf.rule.ipt.add"
#define QOS_CONF_FN_RULE_IPT_DEL    "/var/etc/qos.conf.rule.ipt.del"
#define QOS_CONF_FN_RULE_SHELL_ADD    "/var/etc/qos.conf.rule.add.sh"
#define QOS_CONF_FN_RULE_SHELL_DEL    "/var/etc/qos.conf.rule.del.sh"
#define QOS_CONF_FN_TC_BATCH    "/var/etc/qos.conf.tc.batch"

#define SIP_IPTBALE_ADD_SHELL "/etc/scripts/sip_ipt_add.sh"
#define SIP_IPTBALE_ADD_SHELL1 "/etc/scripts/sip_ipt_add.sh1"
#define SIP_IPTBALE_DEL_SHELL "/etc/scripts/sip_ipt_del.sh"
#define SIP_RUN_IPTBALE_ADD_SHELL "/var/etc/sip_ipt_add.sh"
#define SIP_RUN_IPTBALE_ADD_SHELL1 "/var/etc/sip_ipt_add.sh1"
#define SIP_RUN_IPTBALE_DEL_SHELL "/var/etc/sip_ipt_del.sh"

#define CLOSE_WAN_PORT_IPTBALE_ADD_SHELL "/etc/scripts/close_wan_port_ipt_add.sh"
#define CLOSE_WAN_PORT_IPTBALE_ADD_SHELL1 "/etc/scripts/close_wan_port_ipt_add.sh1"
#define CLOSE_WAN_PORT_IPTBALE_DEL_SHELL "/etc/scripts/close_wan_port_ipt_del.sh"

#define PORT_CTRL_CONF "/flash/port_ctrl.conf" // KenWang added 2005/11/21

/*  not used because we have lot of rules
#define IPSEC_ADD_IPTABLES_SHELL "/var/etc/ipsec_ipt.add"                                                                                                            
#define IPSEC_DEL_IPTABLES_SHELL "/var/etc/ipsec_ipt.del"                                                                                                            
#define IPSEC_CREATE_SCRIPT "/var/etc/ipsec_creat.sh"                                                                                                            
#define IPSEC_TERMINATE_SCRIPT "/var/etc/ipsec_term.sh"                                                                                                            
#define IPSEC_DESTROY_SCRIPT "/var/etc/ipsec_dstry.sh"      
*/

#endif /* end of __RUN_FUNC_H__ */
