#include <stdio.h>
#include <stdlib.h>
#define DPRINTF printf
//#define NULL 0

#ifdef LIBVER
#define MAINFUNC splitsiplines_main
#else
#define MAINFUNC main
#endif

#define W_LINE1 "/tmp/line1"
#define W_LINE2 "/tmp/line2"

int
MAINFUNC (int argc, char *argv[])
{
  FILE *fp;
  FILE *fp1;
  FILE *fp2;
  char buf[64];
  char buf1[64];
  char buf2[64];
  char *tmpbuf = NULL;
  int i = 0;
  int j = 0;
  /*assume start from xconfig.cfg */
  int sip_registrar1 = 1;
  int sip_registrar2 = 0;
  int sip_line1 = 1;
  int sip_line2 = 0;
  fp = fopen (argv[1], "r");
  if (fp == 0)
    {
      DPRINTF ("read siplines.asp failed!\n");
      exit(1);
    }
  unlink (W_LINE1);
  unlink (W_LINE2);
  fp1 = fopen (W_LINE1, "w");
  fp2 = fopen (W_LINE2, "w");
  if (fp1 == 0)
    {
      DPRINTF ("write line1 failed!\n");
      exit(1);
    }
  if (fp2 == 0)
    {
      DPRINTF ("write line2 failed!\n");
      exit(1);
    }
  do
    {
      tmpbuf = fgets (buf, 64, fp);
      /*
         <td class="title" width=35%>Line Status</td>
         <td colSpan=2>IDLE</td>
       */
      if (strstr (buf, "Line Status") != 0)
	{
	 // DPRINTF ("line status in\n");
	  tmpbuf = fgets (buf, 64, fp);
	  j = sscanf (buf, "%64[^<]<td colSpan=2>%64[^<]</td>\n", buf2, buf1);
	  if (sip_line1)
	    {
	      sip_line1 = 0;
	      sip_line2 = 1;
	      if (buf1 != NULL)
		fprintf (fp1, "#%s#\n", buf1);
	      else
		fprintf (fp1, "##\n");
	      continue;
	    }
	  if (sip_line2)
	    {
	      sip_line1 = 0;
	      sip_line2 = 0;
	      if (buf1 != NULL)
		fprintf (fp2, "#%s#\n", buf1);
	      else
		fprintf (fp2, "##\n");
	      continue;
	    }
	}

      /*
         <td class="title" width=35%>Register Status</td>
         <td colSpan=2></td>
       */
      if (strstr (buf, "Register Status") != 0)
	{
	  //DPRINTF ("register status\n");
	  tmpbuf = fgets (buf, 64, fp);
	  memset (buf1, 0, 64);
	  j =
	    sscanf (buf, "%64[^%<]<td colSpan=2>%64[^<]</td>\n", buf2, buf1);
	  if (sip_registrar1)
	    {
	      sip_registrar1 = 0;
	      sip_registrar2 = 1;
	      if (buf1 != NULL)
		fprintf (fp1, "#%s#\n", buf1);
	      else
		fprintf (fp1, "##\n");
	      continue;
	    }
	  if (sip_registrar2)
	    {
	      sip_registrar1 = 0;
	      sip_registrar2 = 0;
	      if (buf1 != NULL)
		fprintf (fp2, "#%s#\n", buf1);
	      else
		fprintf (fp2, "##\n");
	      continue;
	    }
	}

    }
  while (tmpbuf != NULL);
  fclose (fp);
  fclose (fp1);
  fclose (fp2);

  exit(0);
}
