#include <stdio.h>
#define DPRINTF printf
//#define NULL 0

#ifdef LIBVER
#define MAINFUNC splitxconfig_main
#else
#define MAINFUNC main
#endif

#define W_XCONFIG "/flash/xconfig.cfg"
#define W_DIALPLAN "/flash/dialplan.cfg"

int MAINFUNC(int argc, char* argv[])
{
FILE* fp;
FILE* fp1;
FILE* fp2;
  char buf[64];
  char buf1[64];
  char *tmpbuf= NULL;
  int i = 0;
  int j = 1;
  /*assume start from xconfig.cfg*/
  int sip=1;
  int dialplan=0;
fp = fopen(argv[1],"r");
if(fp == 0)
{
	DPRINTF("read sip config failed!\n");
	return 1;
}
unlink (W_XCONFIG);
unlink (W_DIALPLAN);
fp1 = fopen(W_XCONFIG,"w");
fp2 = fopen(W_DIALPLAN,"w");
if(fp1 == 0)
{
	DPRINTF("write xconfig.cfg failed!\n");
	return 1;
}
if(fp2 == 0)
{
	DPRINTF("write dialplan.cfg failed!\n");
	return 1;
}
      do
	{
	  tmpbuf = fgets (buf, 64, fp);
#if 0
	  if (strcmp (buf, "[sip]\n") == 0)
	    {
	      sip = 1;
	      dialplan = 0;
	    }
	  else if (strcmp (buf, "[dialplan]\n") == 0)
#else
	  if (strcmp (buf, "[dialplan]\n") == 0)
#endif
	    {
	      sip = 0;
	      dialplan = 1;
	    }
	  if(sip)
	  {
		  fputs(buf,fp1);
	  }
	  else if (dialplan && (tmpbuf != NULL))
	  {
		  if (strcmp (buf, "[dialplan]\n") == 0)
			  continue;
		  fputs(buf,fp2);
	  }
	}
      while (tmpbuf != NULL);
      fclose(fp);
      fclose(fp1);
      fclose(fp2);

      return 0;
}
