/* 
 * There will be two fork while execute the program. It is for thvaluee kackground execution purpose.
 *
*/


#include <sys/errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdarg.h>
#include <fcntl.h>
#include <linux/tc3162dmtctrl.h>
#include "runFunc.h"
#include "../websconfig/wireless.h"
#include "../websconfig/adsl.h"
#include "../websconfig/misc.h"
#include "../websconfig/vlan.h"
#include "../websconfig/wan_vod.h" // KenWang added 2006/01/03
#include <sys/ioctl.h>  /* ioctl */

#define CONFIG_FILE		"/flash/config"
#define DEFAULT_CONFIG_FILE	"/etc/default/config"
#define SYSDEF_FILE		"/etc/scripts/sysdef"
#define MAX_CONFIG_ITEM		40
#define MAX_STRING_LEN 		20

#define VAR_ETC_STATUS_FILE "/var/etc/status"

#ifdef _DPRINTF_
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
#else
	#define DPRINTF(args...)  
#endif /* _DPRINTF_ */

#ifdef _RALINK_WIRELESS_DRIVER_
#else
#endif /* _RALINK_WIRELESS_DRIVER_ */


char configName [MAX_CONFIG_ITEM][MAX_STRING_LEN+1];
char configValue[MAX_CONFIG_ITEM][MAX_STRING_LEN+1];
int configItem;	
void do_command(char *cmd, ...);


/* variable */
char TxPower[MAX_STRING_LEN+1]; /* tmp */
char value[MAX_STRING_LEN+1]; /* tmp */
char lan_if[MAX_STRING_LEN+1];
char lan_ip[MAX_STRING_LEN+1];
char lan_mask[MAX_STRING_LEN+1];
char eth0_mac[MAX_STRING_LEN+1];
char gateway_name[MAX_STRING_LEN+1];
char wireless_enable[MAX_STRING_LEN+1];
char wan_type[MAX_STRING_LEN+1];
//char eth0[MAX_STRING_LEN+1];
int save_globe_config(char *filename, char *arg1, char *arg2);
void CopyFile(char *filename1,char *filename2);
/* KenWang added 2006/01/03 -- begin -- */
void OtherWanBridgeSetting();
void VLANsetting();
/* KenWang added 2006/01/03 -- end -- */
static void Load_Wireless_Txpower_Config (void)
{
	FILE *fp;
#ifdef _RALINK_WIRELESS_DRIVER_
	fp=fopen("/flash/ralink_txpower.conf","r");
#else
	fp=fopen("/flash/txpower.conf","r");
#endif /* _RALINK_WIRELESS_DRIVER_ */


	if(fp) {
		fscanf(fp,"%s\n",TxPower);
		fclose(fp);
	}
}
char* read_file_para_value(char *filename, char *arg1 ,char *buf)
{
	FILE *fp;
	char tmp_line[255];
	char str_return[50];
	//char_t *str_return=NULL;
	char str_temp[50];
	memset(tmp_line,0,sizeof(tmp_line));
	*buf='\0';
	if ((fp=fopen(filename,"r"))!=NULL)
        {
        	while(fgets(tmp_line,sizeof(tmp_line),fp)){
		        if (strncmp(tmp_line,arg1,strlen(arg1)) == 0){
       				sscanf(tmp_line,"%50[^=]=\"%50[^\"]\"\n",str_temp,str_return);
	        		fclose(fp);
				strcpy(buf,str_return);
			//	DPRINTF("1.%s:%s\n",str_temp,buf);
				return buf;	
			}
		}
	       	fclose(fp);
	}
	return buf;
}
int ParseNameValue(char *buf, char **name, char **value)
{
	char *tmp;
	char in_quote=0;

        /* skip the leading space */
        for (; *buf && (*buf == '\t' || *buf == ' '); buf++) ;

        if (!(*buf) || *buf == '\n' || // empty line
            *buf == '#')  // comment
                return -1;

	/* find name */
	*name = buf;
	for (; *buf && *buf != ' ' && *buf != '\t' &&
		   *buf != '=' && *buf != '\n'; buf++);
	tmp = buf;

	/* find the operator */
        /* skip the leading space */
        for (; *buf && (*buf == '\t' || *buf == ' '); buf++);
	if (*buf != '=')
		return -1;
	*tmp = '\0';
                          
	/* find the value */
        /* skip the leading space */
        for (buf++; *buf && (*buf == '\t' || *buf == ' '); buf++);
	if (*buf == '"') {
		in_quote = 1;
	}
	if (in_quote) {
	        for (*value=++buf; *buf && *buf != '"' && *buf != '\n'; buf++);
	}
	else {
                for (*value=buf; *buf && *buf != ' ' && *buf != '\t' && *buf != '\n'; buf++);

	}
        *buf = '\0';
	return 0;
}

int GetValue(char *name, char *value)
{
	int i;
	for (i=0; i<configItem; i++) {
                if (!strcmp(configName[i],name)) 
                        break;
	}
	if (i>=configItem) {
printf("can not found :%s \n", name);
		*value = '\0';
		return -1;
	}
	else {
		strncpy(value, configValue[i], MAX_STRING_LEN);
		return i;
	}
	
}

void SetValue(char *name, char *value)
{
	int i;

        for (i=0; i<configItem; i++) {
		if (!strcmp(configName[i],name))
			break; 
        }
        if (i>=configItem) { /* add it */
		strncpy(configName[configItem], name, MAX_STRING_LEN);
		strncpy(configValue[configItem], value, MAX_STRING_LEN);
		configItem++;
        }
        else {
                strncpy(configValue[i], value, MAX_STRING_LEN);
        }
                                                                                                                                               

}

void GetParam(char *buf, char num, char deli, char *field)
{
        char i, *ptr;
                                                                                                                                               
        for (ptr=buf, i=0; *ptr && i<num; ++ptr) {
                if (*ptr==deli)
                        ++i;
        }
        while (*ptr && *ptr != deli) {
                *(field++) = *(ptr++);
        }
        *field = '\0';
}
                                                                                                                                              
void errorRecoverToDefaultFlash(void)
{
	printf("FLASH ERROR:  Doing error recovery to default for FLASH\n");
        do_command("profile", "profile",  "put", "/etc/default", 0);
        do_command("profile", "profile",  "get", "/flash", 0);
}
int ReadFlashConf(void)
{
	FILE	*in;
	char 	buffer[80];
	char 	*name, *value;
	
	//printf("In Selfinit:Get Config from flash ...start\n");
	in = fopen(CONFIG_FILE, "r");
        if (!in) { // file does not exist
                printf("Can not read %s.  We need to do error recovery to default\n",CONFIG_FILE);
                errorRecoverToDefaultFlash();
                in = fopen(CONFIG_FILE, "r");
        }
                                                                                                                                
        while (fgets(buffer, sizeof(buffer), in)) {
		if (!ParseNameValue(buffer, &name, &value))
			SetValue(name,value);
	}
	
        printf("In Selfinit:Get Config from flash ...done\n");

	fclose(in);
	return 0;
}

void ReadSysDef()
{
        FILE    *in;
        char    buffer[80];
	char 	*name, *value;

	//printf("Read Sysdef file ...\n");
        in = fopen(SYSDEF_FILE, "r");
	if(in){
        while (fgets(buffer, sizeof(buffer), in)) {
                if (!ParseNameValue(buffer, &name, &value)) {
			SetValue(name, value);
		}
        }
        fclose(in);
	}

/*	GetValue("ADSLInfOK", buffer);
	if (!strcmp(buffer, "no"))
		SetValue("VLAN", "yes"); */
}

void ReadSysStatus()
{
        FILE    *in;
        char    buffer[80];
        char    *name, *value;
                                                                                                                                               
        //printf("Read SysStatus ...\n");
        in = fopen(VAR_ETC_STATUS_FILE, "r");
	if(in){
        while (fgets(buffer, sizeof(buffer), in)) {
                if (!ParseNameValue(buffer, &name, &value))
                        SetValue(name,value);
        }
        fclose(in);
	}

}

void do_command(char *cmd, ...)
{
        va_list args;
        char *param[40];
        int i=0, background=0;
        pid_t pid;
                
        va_start(args, cmd);
        for (;;) {
                if (!(param[i++] = va_arg(args, char*)))
                        break;
        }
        va_end(args);
                                                                                                                                               
        if (!strcmp(param[i-2],"&")) {
                background = 1;
                param[i-2] = 0;
        }
#if 0
{
 int  j;
 for (j=0; param[j]; ++j)
    printf("%s ", param[j]);
 printf("\n");
}
#endif

        if (!(pid = vfork())) {
		execvp(cmd, param);
                _exit(0);
        }
        else if (!background && pid > 0)
		waitpid(pid, NULL, 0);
}
static void resetCurrentTmssCfg(void)
{
        TMSS_CONFIG_DATA *d = &tmss_config;
	memset(d,0,sizeof(TMSS_CONFIG_DATA));
}
static void Load_TMSS_Config ()
{
	FILE *fp;
	
	resetCurrentTmssCfg();

	if((fp=fopen(TMSS_CONFIG_FILE,"r"))!=NULL){
	fscanf(fp,"%d\n",&tmss_config.enable); 
	fclose(fp);
	}
}                                                                                                                                      
int wireless_present_fn(void)
{
	char wireless_buf[8];
	char wireless_present=0;

	strcpy(wireless_buf, read_file_para_value(DEFAULT_CONFIG_FILE,"WIRELESS=", wireless_buf));
	if (!strcmp(wireless_buf, "yes")) 
		wireless_present=1;
	return wireless_present;
}

int  InitStatusFile(void)
{
	FILE *out;
	// get it from /flash configuration and put into /var/etc/status
	//GetValue("sys_status", VAR_ETC_STATUS_FILE);
	//printf("write system status to disk (%s)\n", VAR_ETC_STATUS_FILE);
	out = fopen(VAR_ETC_STATUS_FILE, "w");
	if(out){
	// For some critical parameters, ere wehave to validate the values are allowed or not. If not, then we have to do error recovery
	GetValue("WAN", value);
        fprintf(out, "WAN=\"%s\"\n", value);
	//GetValue("EXT_IF", value);
	//fprintf(out, "EXT_IF=%s\n", value);
        GetValue("WAN_IP", value);
        fprintf(out, "WAN_IP=\"%s\"\n", value);
        GetValue("WAN_MASK", value);
        fprintf(out, "WAN_MASK=\"%s\"\n", value);
        if(GetValue("LAN_IP", value)==-1)
		{
			fclose(out);
			return -1;//error recovery the flash
        }
        fprintf(out, "LAN_IP=\"%s\"\n", value);
        if(GetValue("LAN_MASK", value)==-1)
		{
			fclose(out);
			return -1;//error recovery the flash
        }
       fprintf(out, "LAN_MASK=\"%s\"\n", value);
        GetValue("GATEWAY_NAME", value);
        fprintf(out, "GATEWAY_NAME=\"%s\"\n", value);
        GetValue("GATEWAY", value);
        fprintf(out, "GATEWAY=\"%s\"\n", value);
	/*
        GetValue("SOFTWARE_VER", value);
        fprintf(out, "SOFTWARE_VER=\"%s\"\n", value);
        GetValue("HARDWARE_VER", value);
        fprintf(out, "HARDWARE_VER=\"%s\"\n", value);
        GetValue("BLK_HACK", value);
        fprintf(out, "BLK_HACK=\"%s\"\n", value);
        GetValue("FIREWALL", value);
        fprintf(out, "FIREWALL=\"%s\"\n", value);
	*/
        GetValue("ROUTER", value);
        fprintf(out, "ROUTER=\"%s\"\n", value);
	/*
        GetValue("PORT_FORWARD", value);
        fprintf(out, "PORT_FORWARD=\"%s\"\n", value);
        GetValue("MAC_FILTER_ENABLE", value);
        fprintf(out, "MAC_FILTER_ENABLE=\"%s\"\n", value);
        GetValue("FILTER_ENABLE", value);
        fprintf(out, "FILTER_ENABLE=\"%s\"\n", value);
	*/
        if(GetValue("default_mac0", value)==-1) {
			fclose(out);
			return -1;//error recovery the flash
        }
        fprintf(out, "ETH0_MAC=\"%s\"\n", value);
        GetValue("default_mac1", value);
        fprintf(out, "ETH1_MAC=\"%s\"\n", value);
		
        if(GetValue("WAN_IF", value)==-1) {
			fclose(out);
			return -1;//error recovery the flash
        }
		fprintf(out, "WAN_IF=\"%s\"\n", value);
	/*	
      	if(GetValue("LAN_IF", value)==-1) {
			fclose(out);
			return -1;//error recovery the flash
        }
         fprintf(out, "LAN_IF=\"%s\"\n", value);
	 */
  		printf("TMSS=\"no\"\n");
        	fprintf(out, "TMSS=\"no\"\n");
//      GetValue("IPSEC", value);
 //       fprintf(out, "IPSEC=\"%s\"\n", value);
 //       GetValue("QOS", value);
 //       fprintf(out, "QOS=\"%s\"\n", value);
#if 0
	DMTCTRL_DMT_INFO ArgStatus;
 	int nFd = open( "/dev/dmtdev", O_RDWR );
	if( nFd != -1  )
	{
		ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &ArgStatus );
		close(nFd);
	}
	if (ArgStatus.tc_processor_type==1){  /* TC_3162_P wireless */
		DPRINTF("tc_processor_type: TC_3162P for wireless\n");
	        fprintf(out, "WIRELESS=\"yes\"\n");
	}else{  /* TC_3162_L Non wireless */
		DPRINTF("tc_processor_type: TC_3162L for Non wireless\n");
	        fprintf(out, "WIRELESS=\"no\"\n");
	}
#else
	char buf1[64];
	strcpy(value,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"WIRELESS=",buf1));
      //GetValue("WIRELESS", value);
	//DPRINTF("Julian WIRELESS=%s\n",value);
      fprintf(out, "WIRELESS=\"%s\"\n", value);
#endif
        GetValue("AUTOSCAN", value);
        fprintf(out, "AUTOSCAN=\"%s\"\n", value);
//       GetValue("PPPoELogin", value);
//        fprintf(out, "PPPoELogin=\"%s\"\n", value);
	fclose(out);
	}
	return 0;
}


void WLANsetting()
{
	FILE *out;

	//printf("WLAN Setting ..\n");
	ReadSysStatus();

        out = fopen(VAR_ETC_STATUS_FILE, "a");
	if(out){
		fprintf(out, "LAN_IF=\"br0\"\n");
#ifdef _RALINK_WIRELESS_DRIVER_
		fprintf(out, "WLAN_IF=\"ra0\"\n");
#else
		fprintf(out, "WLAN_IF=\"wlan0\"\n");
#endif
	fclose(out);
	}
}
void resetCurrentWirelessCfg(void)
{
	WIRELESS_CONFIG_DATA *d=&wireless_config;
	memset(d,0,sizeof(WIRELESS_CONFIG_DATA));
}
static int Load_Wireless_Config (void)
{
	FILE *fp;
	resetCurrentWirelessCfg();
#ifdef _RALINK_WIRELESS_DRIVER_
	fp=fopen(WIRELESS_CONFIG_FILE,"r");
	if(fp) {
		// KenWang modified 2005/06/14
		//fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%32[^|]|\n",
		fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|\n",
			&wireless_config.Enable,
			&wireless_config.Mode,
			wireless_config.Essid,
			&wireless_config.HideEssid,
			&wireless_config.RegulationDomain,
			&wireless_config.ChannelID,
			&wireless_config.WDSEnable,
			wireless_config.WDSMAC1,
			wireless_config.WDSMAC2,
			wireless_config.WDSMAC3,
			wireless_config.WDSMAC4
			);
		//fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|%d|\n",
		fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|\n",
			wireless_config.Sec_Mode,
			wireless_config.WPA_Algorithm,
			wireless_config.WPA_Shared_Key,
			&wireless_config.WPA_Group_Key_Renewal,
			wireless_config.WPA2_Algorithm,
			wireless_config.WPA2_Shared_Key,
			&wireless_config.WPA2_Group_Key_Renewal,
//			&wireless_config.WPA_Hide_Essid,
			&wireless_config.WEP_Encryption,
			&wireless_config.WEP_Authentication,
			&wireless_config.WEP_Phrase_Type,
			&wireless_config.WEP_Keyid,
			wireless_config.WEP_Key1,
			wireless_config.WEP_Key2,
			wireless_config.WEP_Key3,
			wireless_config.WEP_Key4,
			wireless_config.WEP_Passphrase);
//			&wireless_config.WEP_Hide_Essid);
/*			
	print_blank_string(&wireless_config.Essid);
	print_blank_string(&wireless_config.WDSMAC);
	print_blank_string(&wireless_config.Sec_Mode);
	print_blank_string(&wireless_config.WPA_Algorithm);
	print_blank_string(&wireless_config.WPA_Shared_Key);
	print_blank_string(&wireless_config.WEP_Key1);
	print_blank_string(&wireless_config.WEP_Key2);
	print_blank_string(&wireless_config.WEP_Key3);
	print_blank_string(&wireless_config.WEP_Key4);
	print_blank_string(&wireless_config.WEP_Passphrase);
	*/
	fclose(fp);
	}

#else
	fp=fopen(WIRELESS_CONFIG_FILE,"r");
	if(fp) {
		// KenWang modified 2005/06/14
		//fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%32[^|]|\n",
		fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%d|%32[^|]|\n",
			&wireless_config.Enable,
			&wireless_config.Mode,
			wireless_config.Essid,
			&wireless_config.HideEssid,
			&wireless_config.RegulationDomain,
			&wireless_config.ChannelID,
			&wireless_config.WDSEnable,
			wireless_config.WDSMAC);
		//fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|%d|\n",
		fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|\n",
			wireless_config.Sec_Mode,
			wireless_config.WPA_Algorithm,
			wireless_config.WPA_Shared_Key,
			&wireless_config.WPA_Group_Key_Renewal,
//			&wireless_config.WPA_Hide_Essid,
			&wireless_config.WEP_Encryption,
			&wireless_config.WEP_Authentication,
			&wireless_config.WEP_Phrase_Type,
			&wireless_config.WEP_Keyid,
			wireless_config.WEP_Key1,
			wireless_config.WEP_Key2,
			wireless_config.WEP_Key3,
			wireless_config.WEP_Key4,
			wireless_config.WEP_Passphrase);
//			&wireless_config.WEP_Hide_Essid);
/*			
	print_blank_string(&wireless_config.Essid);
	print_blank_string(&wireless_config.WDSMAC);
	print_blank_string(&wireless_config.Sec_Mode);
	print_blank_string(&wireless_config.WPA_Algorithm);
	print_blank_string(&wireless_config.WPA_Shared_Key);
	print_blank_string(&wireless_config.WEP_Key1);
	print_blank_string(&wireless_config.WEP_Key2);
	print_blank_string(&wireless_config.WEP_Key3);
	print_blank_string(&wireless_config.WEP_Key4);
	print_blank_string(&wireless_config.WEP_Passphrase);
	*/
	fclose(fp);
	}
#endif /* _RALINK_WIRELESS_DRIVER_ */	
	return 0;
}
void do_wireless();
void do_wireless_security();
void do_wireless_security(){
	char funcNum_wireless_sec[2];
	Load_Wireless_Config();
	memset(funcNum_wireless_sec,0,sizeof(funcNum_wireless_sec));
	sprintf(funcNum_wireless_sec,"%d",FUNCTION_NUM_WIRELESS_SEC);
	do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum_wireless_sec,0);
}
void do_wireless(){
	
	char wlan_if[10];
	char funcNum_wireless[2];
	char funcNum_igmpsnoop[2];
	FILE *in;
	
	Load_Wireless_Config();
	
	memset(wlan_if,0,sizeof(wlan_if));
	memset(funcNum_wireless,0,sizeof(funcNum_wireless));
	memset(funcNum_igmpsnoop,0,sizeof(funcNum_igmpsnoop));
	
	
	#ifdef _RALINK_WIRELESS_DRIVER_
		strcpy(wlan_if,"ra0");	
	#else
	strcpy(wlan_if,"wlan0");	
	#endif /* _RALINK_WIRELESS_DRIVER_ */
	
	DPRINTF("ifconfig %s up\n",wlan_if);
	do_command("ifconfig","ifconfig",wlan_if,"up",NULL);
	
	DPRINTF("brctl addif br0 %s \n",wlan_if);
	do_command("brctl","brctl","addif","br0",wlan_if,NULL);

	#define support_txpower
	
	#ifdef _RALINK_WIRELESS_DRIVER_
		if (wireless_config.Enable){
			#ifdef support_txpower
				Load_Wireless_Txpower_Config();
	
				//Sam add fix tx power issue 20050518
				char real_txpower[10];
				memset(real_txpower,0,sizeof(real_txpower));
				sprintf(real_txpower,"TxPower=%s",TxPower);	
				do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"set",real_txpower,NULL);
				DPRINTF("/usr/sbin/iwpriv %s set %s\n",wlan_if,real_txpower);
			#else
				do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"set","TxPower=100",NULL);
				DPRINTF("/usr/sbin/iwpriv %s set TxPower=100\n",wlan_if);
			#endif
				//Sam end
				//
//Piero add TxBurst=Enable for speeding up 09292005
				//do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"set","TxBurst=1",NULL);
				//DPRINTF("/usr/sbin/iwpriv %s set TxBurst=1\n",wlan_if);
				//do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"set","WmmCapable=1",NULL);
				//DPRINTF("/usr/sbin/iwpriv %s set WmmCapable=1\n",wlan_if);
//				do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"set","PktAggregate=1",NULL);
//				DPRINTF("/usr/sbin/iwpriv %s set PktAggregate=1\n",wlan_if);
//Piero end				
			
/* WDS Start */		
/*				
				if (wireless_config.WDSEnable){
					if (strncmp(wireless_config.WDSMAC1,"&",1)){
						Add_WDSMAC(1,wireless_config.WDSMAC1);
					}
					if (strncmp(wireless_config.WDSMAC2,"&",1)){
						Add_WDSMAC(2,wireless_config.WDSMAC2);
					}
					if (strncmp(wireless_config.WDSMAC3,"&",1)){
						Add_WDSMAC(3,wireless_config.WDSMAC3);
					}
					if (strncmp(wireless_config.WDSMAC4,"&",1)){
						Add_WDSMAC(4,wireless_config.WDSMAC4);
					}
					
					if ((in = fopen("/var/state/wlanwds.reboot.lock", "w")) != NULL) {
						fclose(in);
					}
				}
*/				
/* WDS End */		
		}
	

	#else
	if (wireless_config.Enable){
#ifdef support_txpower
		char real_txpower[10];
		Load_Wireless_Txpower_Config();
	
		//Sam add fix tx power issue 20050518
				memset(real_txpower,0,sizeof(real_txpower));
		sprintf(real_txpower,"0x%s",TxPower);	
		do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"rftest_power",real_txpower,NULL);
		DPRINTF("/usr/sbin/iwpriv %s rftest_power %s\n",wlan_if,real_txpower);
#else
		do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"rftest_power","0x75",NULL);
				DPRINTF("/usr/sbin/iwpriv %s rftest_power 0x71\n",wlan_if);
#endif
		//Sam end

	if (wireless_config.WDSEnable){
		char wlan_wds_if[20];
					memset(wlan_wds_if,0,sizeof(wlan_wds_if));
		strcpy(wlan_wds_if,"wlan0wds0");
		do_command("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wdsaddmac",wireless_config.WDSMAC,NULL);
					DPRINTF("iwpriv %s wdsaddmac %s\n",wlan_if,wireless_config.WDSMAC);
		do_command("ifconfig","ifconfig",wlan_wds_if,"up",NULL);
					DPRINTF("ifconfig %s up\n",wlan_wds_if);
		do_command("brctl","brctl","addif","br0",wlan_wds_if,NULL);
					DPRINTF("brctl addif br0 %s\n",wlan_wds_if);
		if ((in = fopen("/var/state/wlanwds.reboot.lock", "w")) != NULL) {
			fclose(in);
		}
		if ((in = fopen("/var/state/wlanwds.lock", "w")) != NULL) {
			fprintf(in,"%s\n",wireless_config.WDSMAC);
			fclose(in);
		}
	}
	}

	#endif /* _RALINK_WIRELESS_DRIVER_ */
	
	sprintf(funcNum_wireless,"%d",FUNCTION_NUM_WIRELESS);
	do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum_wireless,0);

#if 0
// shall not just for wireless, move to below
	// if wireless=yes then run igmp_snooping
	sprintf(funcNum_igmpsnoop,"%d",FUNCTION_NUM_IGMP_SNOOPING);
	do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum_igmpsnoop,0);
#endif
}

/* KenWang added 2006/01/02 -- begin -- */
void resetCurrentWanVodCfg(OTHER_WAN_BRIDGE_DATA *d)
{
     memset(d,0,sizeof(OTHER_WAN_BRIDGE_DATA));
}

void Load_Other_Wan_Bridge_Config (OTHER_WAN_BRIDGE_DATA *d)
{
	FILE *fp;
	char line[1024];
	int i;
	
	//DPRINTF("Load_Other_Wan_Bridge_Config is called\n");
	resetCurrentWanVodCfg(d);
	if ((fp=fopen(OTHER_WAN_BRGIDE_CONFIG_FILE, "r"))==NULL) 
		return;
	//1483 Bridged only for current stage
	fscanf(fp,"%d\n",&d->wan_bridge_no);
	if(!d->wan_bridge_no)
	{
		fclose(fp);
		return;
	}
	for(i=0;i<d->wan_bridge_no;i++)
	{
		if (fgets(line, 1024, fp))
		{
			sscanf(line,
			"|%50[^|]|%d|%hu|%hu|%d|%d|%d|%d|\n",
			 d->Bridged_Description[i],
			 &d->usingSamePVCFromExistingWanConnection[i],
			 &d->Bridged_VPI[i],
			 &d->Bridged_VCI[i],
			 (int *)&d->Bridged_ATM_Class[i],
			 (int *)&d->Bridged_Encapsulation_Method[i],
			 (int *)&d->Bridged_Ether_Filter_Type[i],
			 (int *)&d->Bridged_Spanning_Bridge_Interface[i]
		       );
			if(strcmp(d->Bridged_Description[i], "&") == 0)
				strcpy(d->Bridged_Description[i], "");
		}
		else
			break;
	}
	fclose(fp);
}

void resetCurrentVlanCfg(VLAN_CONFIG_DATA *d)
{
	memset(d,0,sizeof(VLAN_CONFIG_DATA));
}

int Load_Vlan_Config (VLAN_CONFIG_DATA *d)
{
	int i;
	FILE *fp;

	resetCurrentVlanCfg(d);
	fp=fopen(VLAN_CONFIG_FILE,"r");
	if(!fp) {
		return 0;
	}
	//fscanf(fp,"%d\n",&d->management_vlan_group);
	for(i=0;i<MAX_RULE;i++)
			fscanf(fp,"|%24[^|]|%d|%d|%d|%d|%d|%d|%d|%d|%d|\n",
				d->Rule[i].Name, 
				&d->Rule[i].VLAN_ID, 
				&d->Rule[i].LAN_TAGGING_enable, 
				&d->Rule[i].lan_port_enabled[0], 
				&d->Rule[i].lan_port_enabled[1], 
				&d->Rule[i].lan_port_enabled[2], 
				&d->Rule[i].lan_port_enabled[3], 
				&d->Rule[i].lan_port_enabled[4], 
				&d->Rule[i].WAN_connection_index, 
				&d->Rule[i].WAN_TAGGING_enable);	
	fclose(fp);
	return 0;
}

void vlan_link_wanbr(VLAN_CONFIG_DATA *d, int vlan_index)
{
	char wan_if[32], vlan_if[32], lan_if[32], wan_type[32], wlan_if[32], w_vlan_if[32];
	OTHER_WAN_BRIDGE_DATA wanbr;
	int wan_conn_index = 0, lan_enabled = 0, wlan_enabled = 0;

	if(d->Rule[vlan_index].WAN_connection_index <= 0 ||
	   d->Rule[vlan_index].WAN_connection_index >= MAX_RULE)
		return;

	Load_Other_Wan_Bridge_Config(&wanbr);
	wan_conn_index = d->Rule[vlan_index].WAN_connection_index;
	read_file_para_value("/var/etc/status", "WAN_IF=", wan_if);
	read_file_para_value("/var/etc/status", "LAN_IF=", lan_if);
	read_file_para_value("/var/etc/status", "WAN=", wan_type);
#ifdef _RALINK_WIRELESS_DRIVER_
	sprintf(wlan_if, "ra0");
#else
	sprintf(wlan_if, "wlan0");
#endif

	/* WLAN tag is not ready yet */
	//sprintf(w_vlan_if, "%s.%d", wlan_if, d->Rule[vlan_index].VLAN_ID);
	strcpy(w_vlan_if, wlan_if);
	sprintf(vlan_if, "vlan%d", d->Rule[vlan_index].VLAN_ID);

	if(d->Rule[vlan_index].lan_port_enabled[0] ||
	   d->Rule[vlan_index].lan_port_enabled[1] ||
	   d->Rule[vlan_index].lan_port_enabled[2] ||
	   d->Rule[vlan_index].lan_port_enabled[3])
		lan_enabled = 1;
	if(d->Rule[vlan_index].lan_port_enabled[4])
		wlan_enabled = 1;

	if(wan_conn_index == 1) {
		/* connect to main wan, it is a management port */
		if(lan_enabled)
			do_command("brctl", "brctl", "addif", "br0", vlan_if, NULL);
		if(wlan_enabled)
			do_command("brctl", "brctl", "addif", "br0", w_vlan_if, NULL);
	}
	else {
		if(wanbr.usingSamePVCFromExistingWanConnection[wan_conn_index-2] == 1) {
			if(!strncmp(wan_if, "br", 2)) {
				if(lan_enabled)
					do_command("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
				if(wlan_enabled)
					do_command("brctl", "brctl", "addif", wan_if, w_vlan_if, NULL);
			}
		}
		else {
			sprintf(wan_if, "br%d", wan_conn_index);
			if(lan_enabled)
				do_command("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
			if(wlan_enabled)
				do_command("brctl", "brctl", "addif", wan_if, w_vlan_if, NULL);
		}
	}
}

/* Check if any LAN port is enabled */
int isActiveVlanGroup(VLAN_CONFIG_DATA *d, int vlan_index)
{
	/* wlan is not considered now */
	if(d->Rule[vlan_index].lan_port_enabled[0] ||
	   d->Rule[vlan_index].lan_port_enabled[1] ||
	   d->Rule[vlan_index].lan_port_enabled[2] ||
	   d->Rule[vlan_index].lan_port_enabled[3] ||
	   d->Rule[vlan_index].lan_port_enabled[4])
		return 1;
	else return 0;
}
/* KenWang added 2006/01/02 -- end -- */

void LANsetting()
{
	FILE *in,*out,*st;
	char a[MAX_STRING_LEN+1]="", e[MAX_STRING_LEN+1]="";
	char wan[MAX_STRING_LEN+1];
	char eth1_mac[MAX_STRING_LEN+1];
	char vpi[5], vci[5], enca[5];
	char line[255];
	char funcNum_igmpsnoop[2];
	memset(funcNum_igmpsnoop,0,sizeof(funcNum_igmpsnoop));
	
	ReadSysStatus();
	GetValue("LAN_IF", lan_if);
	GetValue("LAN_IP", lan_ip);
	GetValue("LAN_MASK", lan_mask);
	GetValue("ETH0_MAC", eth0_mac);
	GetValue("ETH1_MAC", eth1_mac);
	GetValue("GATEWAY_NAME", gateway_name);
	GetValue("WIRELESS", wireless_enable);
	GetValue("WAN", wan_type);
          
	DPRINTF("WIRELESS:%s\n",wireless_enable);
	DPRINTF("WAN:%s\n",wan_type);
	//printf("LAN start\n");
	//printf("LAN initial interface is %s\n", lan_if);
	//printf("LAN IP %s MASK %s MAC %s\n", lan_ip, lan_mask, eth0_mac);
	//printf("Hostname %s\n", gateway_name);
	sethostname(gateway_name, strlen(gateway_name));
 	
	//check if it is bridge mode
	GetValue("WAN", wan);

	DPRINTF("brctl addbr br0\n");
	do_command("brctl","brctl", "addbr", "br0", 0);
	DPRINTF("brctl stp br0 disable\n");
	do_command("brctl", "brctl", "stp", "br0", "disable", 0);
	DPRINTF("brctl setfd br0 0\n");
	do_command("brctl","brctl", "setfd", "br0", "0", 0);
	/* KenWang marked 2006/01/03 -- begin -- */
	/* we will decide wether to add eth0 to br0 or not in VLANsetting */
	// do_command("brctl", "brctl", "addif", "br0", "eth0", 0);
	/* KenWang marked 2006/01/03 -- end -- */
	DPRINTF("ifconfig eth0 hw ether %s\n",eth0_mac);
	do_command("ifconfig", "ifconfig", "eth0","hw","ether",eth0_mac,0);
	DPRINTF("ifconfig eth0 multicast up\n");
	do_command("ifconfig", "ifconfig", "eth0","multicast","up",0);


	if(!strcmp(wan, "bridge"))
	{
		//ifconfig eth0 hw ether $ETH0_MAC 
	
		//ifconfig eth0 multicast $LAN_IP netmask $LAN_MASK up
        
        	st = fopen("/tmp/ppp/wan_connect_status", "w");
		if(st){
        	fprintf(st, "2\n");
        	fclose(st);
		}
		/* get the parameter */
		out = fopen("/flash/wan.conf", "r");
		if(out){
		fgets(line, 80, out);  //wantypeline
		fgets(line, 80, out);  //routedline
		fgets(line, 80, out);  //bridgedline
		fclose(out);
		}
		GetParam(line, 2, '|', vpi);
		GetParam(line, 3, '|', vci);
		GetParam(line, 5, '|', enca);
		printf("bridge_vpi:%s\n",vpi);
		printf("bridge_vci:%s\n",vci);
		printf("bridge_enca:%s\n",enca);
		sprintf(line,"0.%s.%s",vpi,vci);
		printf("bridge_line:%s\n",line);
		do_command("ifconfig", "ifconfig", "eth0", "0.0.0.0", 0);
		do_command("ifconfig", "ifconfig", "br0", lan_ip, "up", 0);
		do_command("br2684ctl","br2684ctl", "-c", "0", "-e", enca,"-a", line, "&", 0);
		sleep(1);
		//ifconfig nas0 hw ether $ETH1_MAC 	

		do_command("ifconfig","ifconfig", "nas0", "hw","ether",eth1_mac, 0);
		// ifconfig nas0 up
		do_command("ifconfig","ifconfig", "nas0", "up", 0);
                // brctl addif br0 nas0
		do_command("brctl","brctl", "addif", "br0", "nas0", 0);

#ifndef _RALINK_WIRELESS_DRIVER_
		if (!(strcmp("yes",wireless_enable))){
			Load_Wireless_Config();
			if (wireless_config.Enable){
/* Julian: do_wireless works after security setting */
				do_wireless_security();
				do_wireless();
			}
			else
				do_command("iwpriv","iwpriv","wlan0","nostation","1",NULL);
			
		}
#endif
		
		/*
 		st = fopen("/tmp/ppp/wan_status", "w");
        	fprintf(st, "WAN_IP=\n");
        	fprintf(st, "WAN_MASK=\n");
        	fprintf(st, "GATEWAY= \n");
//        	fprintf(st, "LAN_IF=br0\n");
//        	fprintf(st, "DNS1=\n");
//        	fprintf(st, "DNS2=\n");
		fclose(st);
		*/
		//unlink("/etc/resolv.conf");
        	// route del default gw 0.0.0.0
        	//do_command("route","route", "del", "default", "gw", "0.0.0.0", 0);
		//DPRINTF("route del default gw 0.0.0.0");
        	st = fopen("/tmp/ppp/wan_connect_status", "w");
		if(st){
        	fprintf(st, "1\n");
        	fclose(st);
		}
	}
	else
	{
		//Julian br0 don't set MAC address 20050426
		//do_command("ifconfig", "ifconfig", lan_if,"hw","ether",eth0_mac,0);
		do_command("ifconfig", "ifconfig", lan_if,"multicast", lan_ip, "netmask", lan_mask, "up",0);
		DPRINTF("ifconfig %s multicast %s netmask %s up\n",lan_if,lan_ip,lan_mask);
	}

	// Not just for wireless. FOr VOD,there are 2 interfaces and shall be able to enable.
	sprintf(funcNum_igmpsnoop,"%d",FUNCTION_NUM_IGMP_SNOOPING);
	do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum_igmpsnoop,0);

	if (!(strcmp("yes",wireless_enable))){
			Load_Wireless_Config();
			if (wireless_config.Enable){
#ifdef _RALINK_WIRELESS_DRIVER_				
				do_wireless();
				do_wireless_security();
#else
				do_wireless_security();
				do_wireless();
#endif /* _RALINK_WIRELESS_DRIVER_ */								
			}
			else{
#ifdef _RALINK_WIRELESS_DRIVER_				
				do_command("ifconfig","ifconfig","ra0","down",NULL);
#else
				do_command("iwpriv","iwpriv","wlan0","nostation","1",NULL);
#endif /* _RALINK_WIRELESS_DRIVER_ */				
			}

	}
			
	in = fopen("/flash/myhosts", "r");
	if (in) {
		fscanf (in, "%s %s %s %s %s", a, a, a, a, e);
		fclose(in);
		if (e[0] != '\0') 
		{
			sprintf(a, "%s:SecondaryIP", lan_if);
			do_command("ifconfig","ifconfig", a, e, "netmask", lan_mask, 0);
		}
	}
	else {
		out = fopen("/flash/myhosts", "w");
		if(out){
		fprintf(out, "%s %s %s 0\n", lan_ip, gateway_name, lan_mask);
		fclose(out);
		}
	}

	in = fopen("/etc/hosts", "a");
	if(in){
	fprintf(in, "%s %s\n", lan_ip, gateway_name);
	fclose(in);
	}
}

void DHCPsetting()
{
	FILE *in;
	char dhcpd=0;
	char wan[MAX_STRING_LEN+1];
	
	ReadSysStatus();
 	
	//check if it is bridge mode
	GetValue("WAN", wan);

	in = fopen("/flash/dhcpd.conf", "r");
	fgets(value, sizeof(value), in);
	fclose(in);
	if (!strncmp(value, "#:1", 3))
		dhcpd = 1;
	else if (!strncmp(value, "#:2", 3))
		dhcpd = 2;

	if (dhcpd==1) { /* dhcpd server */

		//printf("DHCP Server start in %s\n".lan_if);
		in = fopen("/var/dhcp/dhcpd.leases", "w");
		if(in){
			fclose(in);
		}
		// KenWang modified 2005/05/13
		/*
		if ((in=fopen("/proc/driver/br0", "r")) != NULL) {
			fclose(in);
			// /bin/dhcpd -d -cf /flash/dhcpd.conf -lf /var/dhcp/dhcpd.leases br0 &
	                do_command("/bin/dhcpd", "/bin/dhcpd", "-d", 
				"-cf", "/flash/dhcpd.conf", "-lf", "/var/dhcp/dhcpd.leases", "br0", "&", 0);
		} else {
			// /bin/dhcpd -d -cf /flash/dhcpd.conf -lf /var/dhcp/dhcpd.leases $LAN_IF &
			do_command("/bin/dhcpd", "/bin/dhcpd",lan_if, "-d", 
				"-cf", "/flash/dhcpd.conf", "-lf", "/var/dhcp/dhcpd.leases", "&", 0);
		}
		*/
		// /bin/dhcpd -d -cf /flash/dhcpd.conf -lf /var/dhcp/dhcpd.leases $LAN_IF &
		if(strcmp(wan,"bridge")){
		do_command("/bin/dhcpd", "/bin/dhcpd", lan_if, "-d",
				"-cf", "/flash/dhcpd.conf", "-lf", "/var/dhcp/dhcpd.leases", "&", 0);
		}

        } else if (dhcpd==2) { /* dhcp Relay server */
                                                                                                                                               
                //printf("DHCP Relay Server start\n");
                in=fopen("/flash/dhcprelay.conf", "r");
		if(in){
                fgets(value, MAX_STRING_LEN, in);
                fclose(in);
		}

		// KenWang modified 2005/05/13
		/*
                if ((in=fopen("/proc/driver/br0", "r")) != NULL) {
                     	fclose(in);
			// /bin/dhcrelay -d -i br0 `cat /flash/dhcprelay.conf` &
                        do_command("/bin/dhcrelay", "/bin/dhcrelay", "-d", "-i", "br0", value, "&", 0);
                } else {
			// /bin/dhcrelay -d -i $LAN_IF `cat /flash/dhcprelay.conf`&
                        do_command("/bin/dhcrelay", "/bin/dhcrelay", "-d", "-i", lan_if, value, "&", 0);
                }
		*/
		// /sbin/dhcrelay -d -i $LAN_IF `cat /flash/dhcprelay.conf` &
		if(strcmp(wan,"bridge")){
		do_command("/bin/dhcrelay", "/sbin/dhcrelay", "-d", "-i", lan_if, value, "&", 0);
                }
	} else {
		printf("DHCP Server stop\n");                                                                                                          }
}

// KenWang marked 2006/01/03 unused code
#if 0
static void Modify_Vlan_Config_For_Wireless_Missed(void)
{
	int i;
	FILE *fp;
	VLAN_CONFIG_DATA vlan_config,*d=&vlan_config;;

	fp=fopen(VLAN_CONFIG_FILE,"r");
	if(!fp) {
		return;
	}
	//fscanf(fp,"%d\n",&d->management_vlan_group);
	for(i=0;i<MAX_RULE;i++)
	{
		fscanf(fp,"|%24[^|]|%d|%d|%d|%d|%d|%d|%d|%d|%d|\n",
				d->Rule[i].Name, 
				&d->Rule[i].VLAN_ID, 
				&d->Rule[i].LAN_TAGGING_enable, 
				&d->Rule[i].lan_port_enabled[0], 
				&d->Rule[i].lan_port_enabled[1], 
				&d->Rule[i].lan_port_enabled[2], 
				&d->Rule[i].lan_port_enabled[3], 
				&d->Rule[i].lan_port_enabled[4], 
				&d->Rule[i].WAN_connection_index, 
				&d->Rule[i].WAN_TAGGING_enable);
		d->Rule[i].lan_port_enabled[4]=0;
	}
	fclose(fp);
	fp=fopen(VLAN_CONFIG_FILE,"w");
	if(!fp) {
		return;
	}
	//fprintf(fp,"%d\n",d->management_vlan_group);
	for(i=0;i<MAX_RULE;i++)
		fprintf(fp,"|%s|%d|%d|%d|%d|%d|%d|%d|%d|%d|\n",
				d->Rule[i].Name, 
				d->Rule[i].VLAN_ID, 
				d->Rule[i].LAN_TAGGING_enable, 
				d->Rule[i].lan_port_enabled[0], 
				d->Rule[i].lan_port_enabled[1], 
				d->Rule[i].lan_port_enabled[2], 
				d->Rule[i].lan_port_enabled[3], 
				d->Rule[i].lan_port_enabled[4], 
				d->Rule[i].WAN_connection_index, 
				d->Rule[i].WAN_TAGGING_enable);	
	fclose(fp);
	return;
}

void VLANPortSetting()
{
	FILE *in;
	char buffer[128]="";
	char vlan_type[2];
	int i;
	char mask[4];

	
	//Aki, before this, we need to adjust the vlan.conf for wireless port setting if wireless is not present
	if(!wireless_present_fn())
	{
		Modify_Vlan_Config_For_Wireless_Missed();
	}
	if ((in = fopen("/flash/vlan.conf", "r")) != NULL) {
		if (fgets(buffer,128,in)){
			fclose(in);
			GetParam(buffer, 1, '|', vlan_type);
			if (!strcmp(vlan_type,"1")) { // enable
				printf("vlan port setting support\n");
				for (i=0; i<4; i++) {
					memset(mask,0,sizeof(mask));
					GetParam(buffer, 18+i, '|', mask);
					
					if (strcmp(mask, "0")) {
						printf("vlan port setting %d - mask %s\n", (i+1),mask);
						do_command("vpctrl","vpctrl","vlan", mask, 0);
					}
				}
				do_command("vpctrl","vpctrl", "rst", "lan", 0);
				if ((in = fopen("/var/state/vlan.lock", "w")) != NULL) {
					fclose(in);
				}
			}
			else
			{
			//	do_command("vpctrl","vpctrl", "active", "no", 0);
			}
		}
	}

}
#endif

/* KenWang added 2006/01/03 -- begin -- */
void OtherWanBridgeSetting()
{
	char line[8];

	sprintf(line, "%d", FUNCTION_NUM_OTHER_WAN_BRIDGE);
	do_command("runFunc", "runFunc", "start", line, NULL);
}

void VLANsetting()
{
	int i, j, k;
	char line[8]; //, wlan_if[32];
	VLAN_CONFIG_DATA d;

	Load_Vlan_Config(&d);

	do_command("vpctrl", "vpctrl", "active", "no", NULL);
	sprintf(line, "%d", FUNCTION_NUM_VLAN);
	do_command("runFunc", "runFunc", "start", line, NULL);

	j = k = 0;
	for(i=0; i<MAX_RULE; i++) {
		if(isActiveVlanGroup(&d, i)) {
			if(d.Rule[i].lan_port_enabled[0] ||
			   d.Rule[i].lan_port_enabled[1] ||
			   d.Rule[i].lan_port_enabled[2] ||
			   d.Rule[i].lan_port_enabled[3]) {
				if(j == 0) {
					do_command("brctl", "brctl", "delif", "br0", "eth0", NULL);
					j = 1;
				}
			}
			if(d.Rule[i].lan_port_enabled[4]) {
#if 0 /* WLAN tag is not ready yet */
#ifdef _RALINK_WIRELESS_DRIVER_
				sprintf(wlan_if, "ra0.%d", d.Rule[i].VLAN_ID);
#else
				sprintf(wlan_if, "wlan0.%d", d.Rule[i].VLAN_ID);
#endif /* _RALINK_WIRELESS_DRIVER_ */
				sprintf(wlan_if, "%s.%d", wlan_if, d.Rule[i].VLAN_ID);
				save_globe_config(VAR_SYS_STATUS_FILE, "WLAN_IF=", wlan_if);
#endif /* if 0 */
				if(k == 0) {
#ifdef _RALINK_WIRELESS_DRIVER_				       
					do_command("brctl", "brctl", "delif", "ra0", NULL);
#else
					do_command("brctl", "brctl", "delif", "wlan0", NULL);
#endif
					k = 1;
				}
			}
			vlan_link_wanbr(&d, i);
		}
	}
	if(j == 0)
		do_command("brctl", "brctl", "addif", "br0", "eth0", NULL);
	if(k == 0) {
#ifdef _RALINK_WIRELESS_DRIVER_
		do_command("brctl", "brctl", "addif", "br0", "ra0", NULL);
#else
		do_command("brctl", "brctl", "addif", "br0", "wlan0", NULL);
#endif
	}
}
/* KenWang added 2006/01/03 -- end -- */

char line[1024];
typedef struct {
    char PPPOE_Description[50];
	unsigned short PPPOE_VPI;
    unsigned short PPPOE_VCI;
    int PPPOE_ATM_Class;
	int PPPOE_Encapsulation_Method;
	int PPPOE_NAT;
	char PPPOE_Username[257];
    char PPPOE_Password[257];
	char PPPOE_Service_Name[32];
	char PPPOE_IP[20];
	int PPPOE_Authentication_Protocol;
	int PPPOE_Connection;
	unsigned short PPPOE_Idle_Timeout;
    int PPPOE_RIP;
	unsigned short PPPOE_MTU;
    int PPPOE_RELAY;
} PPPOE_CONFIG_DATA;	
PPPOE_CONFIG_DATA pppoe_config;

void WANsetting ()
{
	//char line[80];
	char wan_if[MAX_STRING_LEN+1];
	char eth1_mac[MAX_STRING_LEN+1];
	char wan[MAX_STRING_LEN+1];
	char vpi[5], vci[5], enca[5], ip[20], netmask[20];
	char gateway[40];//, username[40], password[40], auth[40], ondemand[5], idletime[5], mtu[5];
	FILE *out;

	GetValue("WAN_IF", wan_if);
	/*
	out = fopen(VAR_ETC_STATUS_FILE, "a");
	if(out){
	fprintf(out, "WAN_IF=\"%s\"\n",wan_if);
	fflush(out);
	fclose(out);
	}
	*/
	ReadSysStatus(); 

// TO Avoid PPPoE/DHCPC Backgound call runFunc background, we do it in rcS
	GetValue("WAN", wan);
	//if( (!strcmp(wan, "bridge"))|| (!strcmp(wan, "dynamic"))||(!strcmp(wan, "pppoe")) )
	//Aki modify 04/03/2005 to simply the pppoe login time
	if( (!strcmp(wan, "bridge"))|| (!strcmp(wan, "dynamic")) )
		return;
	
	GetValue("ETH1_MAC", eth1_mac);
	//printf("WAN start\n");
	//printf("WAN initial interface is %s\n", wan_if);
	//printf("WAN MAC is %s\n", eth1_mac);

	/* get the parameter */
	out = fopen("/flash/wan.conf", "r");
	if (out){
	fgets(line, sizeof(line), out);  //wantypeline
	fgets(line, sizeof(line), out);  //routedline
	        if ((!strcmp(wan, "routed")) || (!strcmp(wan,"fixed"))) {
			GetParam(line, 2, '|', vpi);
			GetParam(line, 3, '|', vci);
			GetParam(line, 6, '|', enca);
			GetParam(line, 8, '|', ip);
			GetParam(line, 9, '|', netmask);
			GetParam(line, 10, '|', gateway);
			//DPRINTF("routed_vpi:%s\n",vpi);
			//DPRINTF("routed_vci:%s\n",vci);
			//DPRINTF("routed_enca:%s\n",enca);
			//DPRINTF("routed_ip:%s\n",ip);
			//DPRINTF("routed_netmask:%s\n",netmask);
			//DPRINTF("routed_gateway:%s\n",gateway);
		}
	fgets(line, sizeof(line), out);  //bridgedline
        if (!strcmp(wan, "bridge")) {
        	        GetParam(line, 2, '|', vpi);
	                GetParam(line, 3, '|', vci);
			GetParam(line, 5, '|', enca);
        }
	fgets(line, sizeof(line), out);  //pppoaline
	fgets(line, sizeof(line), out);  //ipoaline
#if 0
	fgets(line, 80, out);  //pppoeline
	if (!strcmp(wan, "pppoe")) {
		        GetParam(line, 2, '|', vpi);
	        	GetParam(line, 3, '|', vci);
			GetParam(line, 6, '|', username);
			GetParam(line, 7, '|', password);
			GetParam(line, 9, '|', ip);
			GetParam(line, 10, '|', auth);
			GetParam(line, 11, '|', ondemand);
			GetParam(line, 12, '|', idletime);
			GetParam(line, 13, '|', mtu);
	}
#else
	fgets(line, sizeof(line), out);
	if (!strcmp(wan, "pppoe")) {
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%32[^|]|%20[^|]|%d|%d|%hu|%d|%hu|%d|\n",
		pppoe_config.PPPOE_Description,
		&pppoe_config.PPPOE_VPI,
		&pppoe_config.PPPOE_VCI,
		(int *)&pppoe_config.PPPOE_ATM_Class,
		(int *)&pppoe_config.PPPOE_Encapsulation_Method,
		(int *)&pppoe_config.PPPOE_NAT,
		pppoe_config.PPPOE_Username,
		pppoe_config.PPPOE_Password,
		pppoe_config.PPPOE_Service_Name,
		pppoe_config.PPPOE_IP,
	        (int *)&pppoe_config.PPPOE_Authentication_Protocol,
	        (int *)&pppoe_config.PPPOE_Connection,
	     &pppoe_config.PPPOE_Idle_Timeout,
		(int *)&pppoe_config.PPPOE_RIP,
		&pppoe_config.PPPOE_MTU,
		(int *)&pppoe_config.PPPOE_RELAY
		);
		sprintf(vpi,"%d",pppoe_config.PPPOE_VPI);
		sprintf(vci,"%d",pppoe_config.PPPOE_VCI);
		/*
		printf("read data:vpi=%s, vci=%s,un=%s,pwd=%s,sn=%s ip=%s auth=%d connect=%d idle=%d rip=%d mtu=%d relay=%d\n",              vpi,
		vci,
		pppoe_config.PPPOE_Username,
		pppoe_config.PPPOE_Password,
		pppoe_config.PPPOE_Service_Name,
		pppoe_config.PPPOE_IP,
		pppoe_config.PPPOE_Authentication_Protocol,
		pppoe_config.PPPOE_Connection,
		pppoe_config.PPPOE_Idle_Timeout,
		pppoe_config.PPPOE_RIP,
		pppoe_config.PPPOE_MTU,
		pppoe_config.PPPOE_RELAY);
	*/
	}
#endif
	fclose(out);
	}                                                                                                                              
	/* determine the WAN type */
	sprintf(line, "0.%s.%s", vpi, vci);
	if (!strcmp(wan, "routed")) {
                FILE *in;
                char name1[40]="", name2[40]="";

		//printf("routed start\n");
                out = fopen("/tmp/ppp/wan_connect_status", "w");
		if (out){
                fprintf(out, "2\n");
	                fclose(out);
		}
		/*
                out = fopen("/tmp/ppp/wan_status", "w");
		if (out){
                	fprintf(out, "WAN_IP=\"%s\"\n", ip);
	                fprintf(out, "WAN_MASK=\"%s\"\n", netmask);
        	        fprintf(out, "GATEWAY=\"%s\"\n", gateway);
	                fclose(out);
		}
		*/
//                fprintf(out, "WAN_IF=atm0\n");
                in = fopen("/flash/resolv.conf", "r");
                if (in) {
                        fscanf(in, "%s %s\n", value, name1);
                        fscanf(in, "%s %s\n", value, name2);
                        fclose(in);
                                                                                                                                               
                                                                                                                                               
                        in = fopen("/etc/resolv.conf", "w");
			if (in){
                        if (name1[0]) {
                                fprintf(in, "nameserver %s\n", name1);
                        }
                        if (name2[0]) {
                                fprintf(in, "nameserver %s\n", name2);
                        }
                        fclose(in);
                }
                }

		if (enca[0] == '2') {
			//printf("rt2684d LLC start\n");
                        //rt2684d -i 0 -o $IP -t $Netmask -e -a 0.$VPI.$VCI -r ubr -p 0 &
			do_command("rt2684d", "rt2684d", "-i", "0", "-o", ip, "-t",
				netmask, "-e", "-a", line, "-r", "ubr", "-p", "0", "&", 0);
                } else {
                        //printf("rt2684d Vc-Mux start\n");
                        //rt2684d -i 0 -o $IP -t $Netmask -a 0.$VPI.$VCI -r ubr -p 0 &
			do_command("rt2684d", "rt2684d", "-i", "0", "-o",
				ip, "-t", netmask, "-a", line, "-r",  "ubr", "-p", "0", "&", 0); 
                }
		sleep(2);
                // ifconfig atm0 up
//		do_command("ifconfig", "ifconfig", wan_if, "0");
		if(strcmp(gateway,"0.0.0.0"))
                {
                	// route add default gw $Gateway
			do_command("route","route", "add", "default", "gw", gateway, 0);
                }
                
                // /etc/scripts/fw.sh start
		do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start","firewall", 0);
		//connection status = 1 can show  ip status page

                out = fopen("/tmp/ppp/wan_connect_status", "w");
		if (out){
                fprintf(out, "1\n");
                fflush(out);
                fclose(out);
		}


/* TO Avoid PPPoE/DHCPC Backgound call runFunc background, we do it in rcS
	} else if (!strcmp(wan, "dynamic")) {
		printf("dhcp client start\n");
                out = fopen("/tmp/ppp/wan_connect_status", "w");
                fprintf(out, "2\n");
                fclose(out);

		//  br2684ctl -c 0 -e $Enca -a 0.$VPI.$VCI &
                do_command("br2684ctl", "br2684ctl", "-c", "0", "-e", enca, "-a", line, "&", 0);
		sleep(1);
		// ifconfig nas0 hw ether $ETH1_MAC up
		//ifconfig $WAN_IF up

		//do_command("ifconfig", "ifconfig", "nas0", "hw", "ether", eth1_mac, "up", 0);
		// dhclient -d -lf /var/dhcp/dhclient.leases nas0 &
                do_command("dhcpclient","dhcpclient", "-d", "-lf", "/var/dhcp/dhclient.leases", "nas0", "&", 0);
		sleep(1);

*/
#if 1
	} else if (!strcmp(wan, "pppoe")) {
		char idleTime[20]="";
		char serviceName[80]="";
		char PPPoE_Encap[2]="";
		FILE *outfp;
                
#if 1
		// br2684ctl -c 0 -a 0.$VPI.$VCI & 
		sprintf(PPPoE_Encap,"%d",pppoe_config.PPPOE_Encapsulation_Method);
                do_command("br2684ctl", "br2684ctl", "-c", "0" ,"-e" ,PPPoE_Encap ,"-a", line, "&", 0);
		//DPRINTF("br2684ctl -c 0 -e %s -a %s &\n",PPPoE_Encap,line);
		sleep(1);
 		//ifconfig $WAN_IF hw ether $ETH1_MAC 
        do_command("ifconfig", "ifconfig", wan_if, "hw", "ether", eth1_mac, 0);
		//ifconfig $WAN_IF up
        do_command("ifconfig", "ifconfig", wan_if, "up", 0);
#endif
		if((!strcmp(pppoe_config.PPPOE_Username,"&"))&&(!strcmp(pppoe_config.PPPOE_Password,"&")))
		{// No need to start PPPoE since both are empty.
		// check if PPPoe Login page is on: Must PPPoELogin enable and the username password is &
			GetValue("PPPoELogin", value);
			if (!strcmp(value, "yes")) 
			{	
				FILE *out;
				out = fopen("/tmp/pppoe_login_on", "w");
				fclose(out);
                }
		        out = fopen("/tmp/ppp/wan_connect_status", "w");
			if(out){
		        	fprintf(out, "0\n");//DISCONNECTED
			        fclose(out);
			}
			return;
		}
        out = fopen("/tmp/ppp/wan_connect_status", "w");
	if(out){
        	fprintf(out, "2\n");//CONNECTING
	        fclose(out);
	}
#define PPPOE_RUN_PPPOECD "/var/etc/run_pppoecd.sh"
		// open a shell script files and run it.
		outfp = fopen (PPPOE_RUN_PPPOECD, "w");
		if (!outfp)
		{
			printf("open file %s for write error!\n",PPPOE_RUN_PPPOECD);
			return;
		}
		if (pppoe_config.PPPOE_Connection !=0 )
			sprintf(idleTime,"-i %d",pppoe_config.PPPOE_Idle_Timeout);
		if (strcmp(pppoe_config.PPPOE_Service_Name,"&") !=0 )
			sprintf(serviceName,"-s \"%s\"",pppoe_config.PPPOE_Service_Name);
		fprintf(outfp,"#!/bin/sh\n");
		
		if (pppoe_config.PPPOE_RELAY){
			do_command("brctl","brctl","addif","br0","nas0",0);
			strcpy(wan_if,"br0");
		}
		
		fprintf(outfp,"pppoecd %s -d -k -u \"%s\" -p \"%s\" %s -A %d -L %s %s -t %d -I 30 -T 30 -N 10 &\n",
			wan_if,
			pppoe_config.PPPOE_Username,
			pppoe_config.PPPOE_Password,
			serviceName,
			pppoe_config.PPPOE_Authentication_Protocol,
			pppoe_config.PPPOE_IP,
			idleTime,
			pppoe_config.PPPOE_MTU);
		fprintf(outfp,"PID=`pidof pppoecd`\n");
		fprintf(outfp,"dmt setpppoe 1\n");
		fprintf(outfp,"dmt setpid $PID\n");
		fclose(outfp);
		chmod (PPPOE_RUN_PPPOECD,S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH |S_IWOTH | S_IXOTH);
#endif
	} else if (!strcmp(wan, "fixed")) {
		FILE *in;
		char name1[40]="", name2[40]="";
		//printf("Fixed IP start\n");
                out = fopen("/tmp/ppp/wan_connect_status", "w");
		if (out){
                fprintf(out, "2\n");
                fclose(out);
		}
		/*
                out = fopen("/tmp/ppp/wan_status", "w");
		if (out){
                	fprintf(out, "WAN_IP=\"%s\"\n", ip);
	                fprintf(out, "WAN_MASK=\"%s\"\n",netmask);
	                fprintf(out, "GATEWAY=\"%s\"\n",gateway);
	                fclose(out);
		}
		*/
//                fprintf(out, "WAN_IF=nas0\n");
		
		in = fopen("/flash/resolv.conf", "r");
		if (in) {
			fscanf(in, "%s %s\n", value, name1);
			fscanf(in, "%s %s\n", value, name2);
			fclose(in);


			in = fopen("/etc/resolv.conf", "w");
			if (name1[0]) {
				fprintf(in, "nameserver %s\n", name1);
			}
			if (name2[0]) {
                                fprintf(in, "nameserver %s\n", name2);
			}
			fclose(in);
		} 
		

                // br2684ctl -c 0 -e $Enca -a 0.$VPI.$VCI &
		do_command("br2684ctl","br2684ctl", "-c", "0", "-e", enca, "-a", line, "&", 0);
		sleep(1);
 		//ifconfig $WAN_IF hw ether $ETH1_MAC 	

 		//ifconfig $WAN_IF $IP netmask $Netmask up	

		/* KenWang modified 2006/03/01 set wan ip if WAN_IF=brwan -- begin -- */
		//do_command("ifconfig", "ifconfig", wan_if, "hw","ether", eth1_mac, 0);
		//do_command("ifconfig", "ifconfig", wan_if, ip, "netmask", netmask,"up", 0);
		do_command("ifconfig", "ifconfig", "nas0", "hw","ether", eth1_mac, 0);
		do_command("ifconfig", "ifconfig", "nas0", "up", 0);
		do_command("ifconfig", "ifconfig", wan_if, ip, "netmask", netmask, "up", 0);
		if(!strncmp(wan_if, "br", 2)) {
			do_command("brctl", "brctl", "addif", wan_if, "nas0", 0);
		}
		/* KenWang modified 2006/03/01 set wan ip if WAN_IF=brwan -- end -- */
                // route add default gw $Gateway
		if(strcmp(gateway,"0.0.0.0"))
                {
                	// route add default gw $Gateway
			do_command("route","route", "add", "default", "gw", gateway, 0);
                }
		save_globe_config(VAR_ETC_STATUS_FILE,"WAN_IP=",ip);
		save_globe_config(VAR_ETC_STATUS_FILE,"WAN_MASK=",netmask);
		save_globe_config(VAR_ETC_STATUS_FILE,"GATEWAY=",gateway);
                // /etc/scripts/fw.sh start
		do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start","firewall", 0);
		//connection status = 1 can show  ip status page

                out = fopen("/tmp/ppp/wan_connect_status", "w");
		if(out){
                fprintf(out, "1\n");
                fflush(out);
                fclose(out);
		}
	} else if (!strcmp(wan, "no")) {

                printf("WAN stop\n");
		out = fopen("/tmp/ppp/wan_connect_status", "w");
		if(out){
		fprintf(out, "0\n");
		fclose(out);
		}

	}
}


/*cat /flash/adsl.conf|
read ADSLRATE;
case $ADSLRATE in
	\0)
		echo auto 
		echo 4 4098 > /proc/dmtctrl/dmtwrite
	;;
	\2)
		echo adsl2   
		echo 4 4100 > /proc/dmtctrl/dmtwrite
	;;
	\3)
		echo adsl2+   
		echo 4 4101 > /proc/dmtctrl/dmtwrite
	;;
	*)
		echo adsl1 G.Dmt 
		echo 4 4096 > /proc/dmtctrl/dmtwrite
	;;
#esac
#echo 6 > /proc/dmtctrl/dmtwrite 
*/

void initADSLDMT(int argc)
{
	int ADSLMODE=0;//open annex type and follow DSLAM's setting 
	int ADSLRATE=1;//ADSL1 
	FILE *fp;
	unsigned int Arg;
	unsigned char Arg2;
	int nFd = open( "/dev/dmtdev", O_RDWR );

	if( nFd == -1  )
	{
		printf("severe error for open /dev/dmtdev for ADSL device\n");
		return;
	}
	
	fp=fopen(ADSL_CONFIG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d\n",&ADSLMODE,&ADSLRATE);
		fclose(fp);
	}
    //ioctl( nFd, DMTIOCTL_SET_DMTRESET, &Arg );
	switch(ADSLRATE)
	{
		case 0:
			Arg=Multi;
			break;
		case 2:
			Arg=ADSL2;
			break;
		case 3:
			Arg=ADSL2Plus;
			break;
		case 4:
			Arg=GLite;
			break;
		case 5:
			Arg=ANSI;
			break;
		case 6:
			Arg=GDMT;
			break;
		default:
			Arg=ADSL1_MultiMode;
			//brad modify 20050509
			//Arg=GDMT;
	}
	if (argc==0){
		ioctl( nFd, DMTIOCTL_SET_LINE_OPMODE , &Arg );
	
	} else if (argc==1){
		DMTCTRL_DMT_INFO Arg1;
		ioctl( nFd, DMTIOCTL_GET_DMT_INFO , &Arg1 );
		if(Arg1.dmt_status!=ADSL_UP)
			ioctl( nFd, DMTIOCTL_SET_DMTRESET, &Arg );
	}else if(argc==2){
		//set annex 20050509 julian
		char buf1[64];
		char str_annex[64];
		strcpy(str_annex,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"ANNEX=",buf1));
		if(!strncmp(str_annex,"B",1)){
			Arg2=ANNEX_B;
		}else{
			switch(ADSLMODE)
			{
			case 0:
				Arg2=ANNEX_AIJLM;
				break;
			case 2:
				Arg2=ANNEX_L;
				break;
			case 3:
				Arg2=ANNEX_M;
				break;
			case 4:
				Arg2=ANNEX_J;
				break;
			default:
				Arg2=ANNEX_A;
			}
		}
		//do_command("wan","wan","ghs","set","annex",str_annex,NULL);
		ioctl( nFd, DMTIOCTL_SET_ANNEX , &Arg2);
	}
	close(nFd);
}	

int init_static_arp()
{
#define ARP_CONF_FILE_PATH "/flash/arp.conf"
	FILE *op=NULL;
	int total=0;
	char now_ip[20]={0}, now_mac[20]={0}, buf[80]={0};

	op = fopen(ARP_CONF_FILE_PATH, "rb");
	if(op) {
		while(fgets(buf, sizeof(buf), op)){
			sscanf(buf, "|%20[^|]|%20[^|]|", now_ip, now_mac);
			do_command("arp", "arp", "-i", "br0", "-s", now_ip, now_mac, 0);
			//strncpy(items[total].ip, now_ip, 20);
			//strncpy(items[total].mac, now_mac, 20);
			total++;
			if(total>9)
				break;
		}
		fclose(op);
	}
	return 1;
}

int main(int argc, char* argv[])
{
	char funcNum_lan[4];
	FILE *out;
	int phase=atoi(argv[1]);
	int iptv=0;
	
	configItem = 0;
/*	//echo "log start"
	//#enable the syslog early
       do_command("syslogd", "-D3", "-n", "&", 0);
      do_command("klogd", "-n", "&", 0);
	out = fopen("/var/state/klogd.pid", "w");
	fprintf(out,"$!\n");
	fclose(out); */

	ReadSysDef();
	if(ReadFlashConf()==-1)
	{
		printf("Error recovery to default flash\n");
		if(ReadFlashConf()==-1)
		{
			printf("flash failed\n");
			return 0;// again, if still error !!! Shall we turn on some LED??????
		}
	}
	
	if(phase==2)//Yes, we have different phase 2 for WAN Settings for static IPs.
	{
		WANsetting();
		return 0;
	}	

	if(InitStatusFile()==-1)
	{
		errorRecoverToDefaultFlash();	
		ReadFlashConf();
		InitStatusFile();// Note reset to default shall be OK.....
	}
	
	ReadSysStatus();
	GetValue("TMSS", value);
	if (!strcmp(value, "yes")) 
	{	
		out = fopen("/tmp/tmss_stat", "w");
		if(out){
		fprintf(out,"NO\n");
		fclose(out);
		}
	}
	
	/* ifconfig lo 127.0.0.1 */
        do_command("ifconfig", "ifconfig", "lo", "127.0.0.1", 0);
	
	// KenWang marked 2006/01/03
	//VLANPortSetting();
	WLANsetting();
	LANsetting();
	DHCPsetting();
	/* KenWang added 2006/01/03 -- begin -- */
	OtherWanBridgeSetting();
	VLANsetting();
	/* KenWang added 2006/01/03 -- end -- */
	
	//static routing for lan start
	
	sprintf(funcNum_lan,"%d",FUNCTION_NUM_STATIC_ROUTE_LAN);

	do_command("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum_lan,0);
/*
        do_command("telnetd", "telnetd", "-l", "/usr/sbin/login","&", 0);
        do_command("webs", "webs", "&", 0);
        do_command("dnsmasq", "dnsmasq", "&", 0);
	*/
//	if(phase!=1)//Yes, we have different phase 2 for WAN Settings.
//		WANsetting();



	initADSLDMT(1); //dmt reset
	initADSLDMT(0); //set dmt mode 
	initADSLDMT(1); //dmt reset
	initADSLDMT(2); //set dmt annex 
	// albert 2005.06.20 after 3.3.0.6 dmt
	//do_command("w","w", "ghs", "set","std", "adsl2plus_multi_ansioff", NULL);
	//do_command("w","w", "hwdmt", "afe", "set", "ecpause", "4000", NULL);
	// albert 2005.07.11
	// wan tcif set olswitch off
	// wan hwdmt afe ec off
	// w ghs set nakefpause 7000
	do_command("w","w", "tcif", "set", "olswitch", "off", NULL);

// Set Noise Margin for IPTV application will follow DSLAM settings.
	out=fopen("/flash/iptv.conf","r");
	if(out) {// 0: -512 for Markku, 1:IPTV for Markku, 2:Max line rate for Markku.  3. Other customers.
		fscanf(out,"%d\n",&iptv);
		if(iptv==0)
		{// set snrmoffset to -512 , -512 for normal user.  For IPTV user. it will depend on DSLAM
			do_command("w","w", "dmt2", "set", "snrmoffset", "-512", "-512", NULL);
		} else if(iptv==2) // set to 768 for max line rate.
			do_command("w","w", "dmt2", "set", "snrmoffset", "768", "0", NULL);
		fclose(out);
	}

	do_command("w","w", "dmt2", "set", "snrmcnt", "1", NULL);
	do_command("w","w", "hwdmt", "afe", "ec", "off", NULL);
	//do_command("w","w", "ghs", "set", "nakefpause", "7000", NULL);
	
	if(iptv<3)// only for Markku
	do_command("w","w", "dmt2", "db", "tlb", "15", NULL);
//	do_command("w","w", "dmt2", "set", "updatesync", "on",NULL);// it has been written it in source code. For DMT 3.5.12.2

	// --- end markku

	init_static_arp();
// watch dog done here.
	out=fopen("/flash/tcwd.conf","r");
	if(out) {
		int TC_WD=0;
		fscanf(out,"%d\n",&TC_WD);
		if(TC_WD)
		{
			do_command("tcwdog","tcwdog", "-t", "1", "/dev/wdt", "&", NULL);			
		}
		fclose(out);
	}

	return 0;
}
char tmp_line[1024];
int save_globe_config(char *filename, char *arg1, char *arg2)
{
//	char line[256];
//	int i,j;
	FILE *fp,*fp1;
//	i=0;
	memset(tmp_line,0,sizeof(tmp_line));	
	if((fp=fopen(filename,"r"))!=NULL){
		if((fp1=fopen("/var/tmp/tmpfile","w"))!=NULL){
			while(fgets(tmp_line,sizeof(tmp_line),fp))
			{
				if ((strncmp(arg1,tmp_line,strlen(arg1))) == 0){
				//	sprintf(config_line[i],"%s\"%s\"\n",arg1,arg2);
					fprintf(fp1,"%s\"%s\"\n",arg1,arg2);
				}
				else{
				//	sprintf(config_line[i],"%s",line);
					fprintf(fp1,"%s",tmp_line);
				}
	//		i++;
			}
	
		fclose(fp1);
	}
	fclose(fp);
	}
	/*
	if ((fp=fopen(filename,"w"))!=NULL){
	for(j=0;j<i;j++)
		fprintf(fp,"%s",config_line[j]);
	fclose(fp);
	}
	*/
	CopyFile("/var/tmp/tmpfile1",filename);
	unlink("/var/tmp/tmpfile1");
	return 1;	
}
void CopyFile(char *filename1,char *filename2){
	FILE *fp,*fp1;
	memset(tmp_line,0,sizeof(tmp_line));
	/* from filename1 to filename2 */ 
	if ((fp = fopen(filename1, "r"))!=NULL){
	  	if ((fp1 = fopen(filename2, "w"))!=NULL){
			while (fgets(tmp_line,sizeof(tmp_line),fp))
				fprintf(fp1,"%s",tmp_line);
			fclose(fp1);
		}
	fclose(fp);
	}
}
