#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

void reverse(int length, char a[])
{
  int i;
  char t;
  for (i = 0; i < length / 2; i++)
    {
      t = a[i];
      a[i] = a[length - i - 1];
      a[length - i - 1] = t;
    }
}

int main(int argc, char *argv[])
{
  int i;
  int rc;
  int len;
  char buf[255];

  setlinebuf(stdin);
  setlinebuf(stdout);

  /* dump any command line params */
  for (i = 0; i < argc; i++)
    {
      printf("argv[%d]=%s\n", i, argv[i]);
    }

#if 1
  while (1)
    {
      printf("dummy_app> ");

      buf[0] = '\0';
      if (fgets(buf, 100, stdin) == NULL)
	{
	  perror("fgets");
	  return -1;
	}

      if (strncmp(buf, "dump", 4) == 0)
	{
	  int i;
	  printf("dummy_app> Loop 0 to 9:\n");
	  for (i = 0;i < 10; i++)
	    {
	      printf("dummy_app> %d\n", i);
	    }
	}
      else
	{
	  reverse(strlen(buf), buf);
	  /* write the same thing back. */
	  printf("dummy_app> %s\n", buf);
	}
    }

#else
  /* write - only */
  {
    int i = 0;
    while(1)
      {
	len = sprintf(buf, "hello %d\n", i++);
	printf(buf);
	sleep (1);
      }
  }
#endif
  return 0;
}
