#!/bin/sh
. /var/etc/status

case "$1" in
	start)
		cat /flash/wan.conf|
		read wantypeline;
		read routedline;
		read bridgedline;
		read pppoaline;
		read ipoaline;
		read pppoeline;
		VPI=`echo $pppoeline | cut -f3 -d"|"`
		VCI=`echo $pppoeline | cut -f4 -d"|"`
		Username=`echo $pppoeline | cut -f7 -d"|"`
		Password=`echo $pppoeline | cut -f8 -d"|"`
		ServiceName=`echo $pppoeline | cut -f9 -d"|"`
		Auth=`echo $pppoeline | cut -f11 -d"|"`
		Ondemand=`echo $pppoeline | cut -f12 -d"|"`
		IP=`echo $pppoeline | cut -f10 -d"|"`
		Idletime=`echo $pppoeline | cut -f13 -d"|"`
		MTU=`echo $pppoeline | cut -f15 -d"|"`
		if [ "$Ondemand" = "0" ] ; then
			if [ "$ServiceName" = "&" ] ; then
				pppoecd $WAN_IF -d -k -u $Username -p $Password -A $Auth -L $IP -t $MTU -I 30 -T 30 -N 10 &
			else
				pppoecd $WAN_IF -d -k -u $Username -p $Password -s $ServiceName -A $Auth -L $IP -t $MTU -I 30 -T 30 -N 10 &
			fi
		else
			if [ "$ServiceName" = "&" ] ; then
				pppoecd $WAN_IF -d -k -u $Username -p $Password -A $Auth -L $IP -i $Idletime -t $MTU -I 30 -T 30 -N 10 &
			else
				pppoecd $WAN_IF -d -k -u $Username -p $Password -s $ServiceName -A $Auth -L $IP -i $Idletime -t $MTU -I 30 -T 30 -N 10 &
			fi
		fi
		;;	
	stop)
		kill -15 `pidof pppoecd`
		sleep 2
		kill -9 `pidof pppoecd`
		#ifconfig $WAN_IF 0.0.0.0
		route del default gw 0.0.0.0
		;;	
	restart)
		$0 stop
		$0 start 
		;;
esac
