iptables  -N TMSS
iptables  -N TMSS_AVE
iptables  -N TMSS_BLK
iptables -A TMSS  -p tcp -m webstr --tmss 1 -j RETURN
iptables -A TMSS  -p tcp -m webstr --tmss 2 -j TMSS_AVE
iptables -A TMSS  -p tcp -m webstr --tmss 4 -j RETURN
iptables -A TMSS  -p tcp -m webstr --tmss 8 -j TMSS_BLK
iptables -A TMSS  -p tcp -j DROP
#We take icmp-admin-prohibited as to send a TMSS REDIRECT page to client
iptables  -A TMSS_AVE -p tcp -j REJECT --reject-with icmp-admin-prohibited
#check  in blocked cache  in REJECT.
iptables  -A TMSS_BLK -p tcp -j REJECT --reject-with icmp-host-prohibited
iptables  -A FORWARD -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP -m multiport --dports 80,8080 -j TMSS	 
