iptables  -N TMSS
iptables  -N TMSS_AVE
iptables  -N TMSS_BLK
iptables -A TMSS -z 115 -p tcp -m webstr --tmss 1 -j RETURN
iptables -A TMSS -z 116 -p tcp -m webstr --tmss 2 -j TMSS_AVE
iptables -A TMSS -z 117 -p tcp -m webstr --tmss 4 -j RETURN
iptables -A TMSS -z 118 -p tcp -m webstr --tmss 8 -j TMSS_BLK
iptables -A TMSS -z 119 -p tcp -j DROP
#We take icmp-admin-prohibited as to send a TMSS REDIRECT page to client
iptables  -A TMSS_AVE -z 120 -p tcp -j REJECT --reject-with icmp-admin-prohibited
#check  in blocked cache  in REJECT.
iptables  -A TMSS_BLK -z 121 -p tcp -j REJECT --reject-with icmp-host-prohibited
iptables  -A FORWARD -z 122 -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP -m multiport --dports 80,8080 -j TMSS	 
