#!/bin/sh

echo -n "What is your relative path for tmss.sh, testaushm, and testclientinfo? "
read BIN_PATH

echo "Step 1. Stop starting script, tmss.sh stop"
$BIN_PATH/tmss.sh stop

echo "Step 2. Dump current AU information from shared memory"
$BIN_PATH/testaushm
sleep 3

# Add two fake clients with Pattern 1.743.00
# Status value: 0=Pending, 1=Windows no AV, 2=UNIX, 3=Outdated AV, 4=Current AV
# Type values: 0=Invalid, 1=Valid
# Vendor values: 0=None, 1=Trend 
#    (The product information can print out after specifying the Vendor values)
# Pattern values: any decimal integer
echo "Step 3. Add two fake clients with VSAPI pattern number 1.743.00.  Please focus on [status=] line"

$BIN_PATH/testclientinfo -add ip 192.168.1.103 status 4 type 1 vendor 1 product 83 pattern 174300
$BIN_PATH/testclientinfo -add ip 192.168.1.101 status 4 type 1 vendor 1 product 83 pattern 174300

echo "Step 4. Launch starting script, tmss.sh start"
$BIN_PATH/tmss.sh start

echo "Step 5. Wait 10 second for AU connection and trigger client information library"
sleep 10
$BIN_PATH/testaushm
echo "Step 6. Please focus on [status=] line"
$BIN_PATH/testclientinfo -get 192.168.1.103
$BIN_PATH/testclientinfo -get 192.168.1.101

