#if !defined(AFX_OPTIONLISTBOX_H__ED7E3015_515F_11D6_9C1E_00B0D0452EEC__INCLUDED_)
#define AFX_OPTIONLISTBOX_H__ED7E3015_515F_11D6_9C1E_00B0D0452EEC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionListBox.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COptionListBox window
#include "OptionSheet.h"

class COptionListBox : public CListBox, public COptionSheet::COptionList
{
public:
	COptionListBox();

	virtual BOOL Create(COptionSheet *pParentWnd, UINT nID);
	virtual BOOL AddGroup(COptionPage *pPage);
	virtual BOOL AddPage(COptionPage *page, COptionPage *pGroupPage);
	virtual BOOL SetSelection(COptionPage *page);
	virtual COptionPage *GetSelection();
	virtual CWnd *GetControlWnd();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionListBox)
	public:
	virtual void DeleteItem(LPDELETEITEMSTRUCT lpDeleteItemStruct);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COptionListBox();

	// Generated message map functions
protected:
	//{{AFX_MSG(COptionListBox)
	afx_msg void OnSelectionChange();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
private:
	CImageList	m_ImageList;
	COptionPage* GetItemPage(int nIndex);
	COptionPage* GetItemGroup(int nIndex);
	BOOL AddItem(COptionPage *pPage, COptionPage *pGroup = NULL, int nIndex = -1, BOOL bGroup = FALSE);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONLISTBOX_H__ED7E3015_515F_11D6_9C1E_00B0D0452EEC__INCLUDED_)
