#if !defined(AFX_OPTIONPAGE_H__05EA0916_4E3E_11D6_9C1E_00B0D0452EEC__INCLUDED_)
#define AFX_OPTIONPAGE_H__05EA0916_4E3E_11D6_9C1E_00B0D0452EEC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionPage.h : header file
//

#define TRDLG_BKCLR_RGB	RGB(255, 255, 255)

/////////////////////////////////////////////////////////////////////////////
// COptionPage dialog

class COptionPage : public CDialog
{
	DECLARE_DYNAMIC(COptionPage);

private:
	CString	m_Caption;	//!<	Caption of the option page
	COptionPage();
	BOOL Create(LPCTSTR lpszTemplateName, CWnd* pParentWnd = NULL);
	BOOL Create(UINT nIDTemplate, CWnd* pParentWnd = NULL);

	BOOL CreateIndirect(LPCDLGTEMPLATE lpDialogTemplate, CWnd* pParentWnd = NULL, void* lpDialogInit = NULL);
	BOOL CreateIndirect(HGLOBAL hDialogTemplate, CWnd* pParentWnd = NULL);

public:
	UINT GetIconID();
	COptionPage(UINT nIDTemplate, UINT nIDCaption = 0);
	COptionPage(LPCTSTR lpszTemplateName, UINT nIDCaption = 0);
	BOOL Create(CRect &rect, CWnd *pParentWnd);
	void GetCaption(CString &str);
	virtual void SetModified(BOOL bChanged = TRUE);
	virtual BOOL OnApply();
	virtual void OnReset();
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnSetActive();
	virtual BOOL OnKillActive();
	virtual BOOL OnQueryCancel();
	LPCSTR GetTemplateName() {
		return m_lpszTemplateName;
	}
	UINT GetTemplateID() {
		return (UINT)(m_lpszTemplateName);
	}

private:
	void CommonConstruct(UINT nIDCaption);

	CBrush	m_brush;

// Dialog Data
	//{{AFX_DATA(COptionPage)
	//enum { IDD = IDR_MAINFRAME };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COptionPage)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONPAGE_H__05EA0916_4E3E_11D6_9C1E_00B0D0452EEC__INCLUDED_)
