/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @thpd.h
 *  @
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */


#ifndef THPD_HEADER
#define THPD_HEADER

#ifdef __cplusplus
extern "C"
{
#endif

#define KERNEL_TO_THPD_CMD_URL_REQ 1
#define KERNEL_TO_THPD_CMD_UPDATE_CLIENT_INFO 2
#define KERNEL_TO_THPD_CMD_UPDATE_CLIENT_PTRN 3
#define KERNEL_TO_THPD_CMD_INCREASE_BLOCK_CAT 4
 typedef struct 
{	
	long mtype;         /* type of message: MUST BE 1 */
	unsigned int commandType;
    unsigned int   clientIP;	
	char host[MAX_URL_BUF+2];// We make more room.
 }URL_REQUEST_MESSAGE_ITEM;

#define URL_REQUEST_SHARE_KEY	0x1975
#define URL_REQUEST_REQUEST_QUEUE_SEMLOCK_KEY 0x1976
#ifdef URL_RATING
#define URL_REQUEST_REQUEST_QUEUE_SIZE 40 
#else
#define URL_REQUEST_REQUEST_QUEUE_SIZE 200 
#endif

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* THPD_HEADER */
