/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file   tmGetAUInfo.h
 *  @brief  TMOG AcitveUpdate Information Query Module 
 */

/*
 *  Change Log
 *  2004-03-19  Jeremy  initial version
 */
#ifndef __TM_GET_AU_INFO_H__
#define __TM_GET_AU_INFO_H__

#include "tmauIniParser.h"

#ifdef __cplusplus
extern "C" {
#endif

void tmau_GetNewestAUInfo(TmuAUVersion_t *pTmuVer);

void tmau_ResetAUInfo(void);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif

