/******************************************************************************
*
*  (C) Copyright 2004 Trend Micro, Inc.
*
*  All Rights Reserved.
*  This program is an unpublished copyrighted work which is proprietary
*  to Trend Micro, Inc. and contains confidential information that is not
*  to be reproduced or disclosed to any other person or entity without
*  prior written consent from Trend Micro, Inc. in each and every instance.
*
*  WARNING:  Unauthorized reproduction of this program as well as
*  unauthorized preparation of derivative works based upon the
*  program or distribution of copies by sale, rental, lease or
*  lending are violations of federal copyright laws and state trade
*  secret laws, punishable by civil and criminal penalties.
*
*****************************************************************************/

/**
*  @file tmGetReport.h
*  @brief TMOG Get Report CGI
*/

/*
*  Change Log
*  2004-03-01 Henry Lin    Initialization version
*/

#ifndef __TMGETFILTERSTATISTICINFO_H__
#define __TMGETFILTERSTATISTICINFO_H__

#define MODULE_URL_FILTER_STATISTIC "URL_FILTER_STATISTIC"
#define MODULE_URL_FILTER_STATISTIC_CATEGORY_ "URL_FILTER_STATISTIC_CATEGORY_"

#define PARAM_CATEGORY_COUNT        "CategoryCount"
#define PARAM_START_COUNT_SYNCE     "StartCountSince"
#define PARAM_CATEGORY_NAME         "CategoryName"
#define PARAM_ACCESS_TIMES          "AccessTimes"
#define PARAM_LAST_ACCESS_TIME      "LastAccessTime"
#define PARAM_BLOCK_TIMES           "BlockTimes"
#define PARAM_LAST_BLOCK_TIME       "LastBlockTime"

#define CGI_PARAM_ACTION_NAME       "action"
#define CGI_PARAM_ACTION_VALUE_GET  "get"
#define CGI_PARAM_ACTION_VALUE_PUT  "put"
#define CGI_PARAM_ACTION_VALUE_CHK  "chk"

#endif
