/******************************************************************************
*
*  (C) Copyright 2004 Trend Micro, Inc.
*
*  All Rights Reserved.
*  This program is an unpublished copyrighted work which is proprietary
*  to Trend Micro, Inc. and contains confidential information that is not
*  to be reproduced or disclosed to any other person or entity without
*  prior written consent from Trend Micro, Inc. in each and every instance.
*
*  WARNING:  Unauthorized reproduction of this program as well as
*  unauthorized preparation of derivative works based upon the
*  program or distribution of copies by sale, rental, lease or
*  lending are violations of federal copyright laws and state trade
*  secret laws, punishable by civil and criminal penalties.
*
*****************************************************************************/

/**
*  @tmSemaphoreTest.c
*  @TMSS semaphore module testing
*/

/*
*  Change Log
*  2004-02-20 Henry Lin    Initialization version
*/

#include <stdio.h>
#include "tmURLFilter.h"
#include "tmURLFilterConf.h"

int main(int argc, char *argv[])
{
    if (argc != 2)
    {
        printf("Usage: testUrlConfReLoad [config_file_path]\n");
        return -1;
    }

    tmLoadUrlFilterConf(argv[1]);

    return 0;
}

