/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     QS = 258,
     MODULE = 259,
     PARAM = 260,
     NAME = 261,
     VALUE = 262,
     OPTION = 263
   };
#endif
#define QS 258
#define MODULE 259
#define PARAM 260
#define NAME 261
#define VALUE 262
#define OPTION 263




/* Copy the first part of user declarations.  */
#line 1 "tmcfg_yacc.y"

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include "tmcfg.h"
#include "tmcfg_impl.h"
#include "log.h"
#include "tmcfg_st.h"
  static const char ModuleName[]="libtmcfg";

#define YYPARSE_PARAM parse_arg

static void yyerror(char *s) {
  fprintf(stderr, "%s\n", s);
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 35 "tmcfg_yacc.y"
typedef union YYSTYPE {
  char                 *charval;
  struct tag_module_st *moduleval;
  struct tag_param_st  *paramval;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 118 "tmcfg_yacc.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 130 "tmcfg_yacc.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   31

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  13
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  8
/* YYNRULES -- Number of rules. */
#define YYNRULES  13
/* YYNRULES -- Number of states. */
#define YYNSTATES  36

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   263

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    11,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       9,    10,    12,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    22,    36,    38,
      41,    44,    48,    55
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      14,     0,    -1,    -1,    17,    -1,    16,    -1,    15,    16,
      -1,     9,     5,     6,    10,     3,     7,    10,     3,    11,
      12,    -1,     9,     5,     6,    10,     3,     7,    10,     3,
       8,    10,     3,    11,    12,    -1,    18,    -1,    17,    18,
      -1,    19,    20,    -1,    19,    15,    20,    -1,     9,     4,
       6,    10,     3,    12,    -1,     9,    11,     4,    12,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    43,    43,    46,    57,    60,    69,    76,    85,    88,
      97,   103,   113,   116
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "QS", "MODULE", "PARAM", "NAME", "VALUE", 
  "OPTION", "'<'", "'='", "'/'", "'>'", "$accept", "config", "param_list", 
  "param", "module_list", "module", "module_s", "module_e", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,    60,
      61,    47,    62
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    13,    14,    14,    15,    15,    16,    16,    17,    17,
      18,    18,    19,    20
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     1,     2,    10,    13,     1,     2,
       2,     3,     6,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     0,     3,     8,     0,     0,     1,     9,     0,
       0,     4,    10,     0,     0,     0,     5,    11,     0,     0,
       0,     0,     0,    13,    12,     0,     0,     0,     0,     0,
       0,     0,     6,     0,     0,     7
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     2,    10,    11,     3,     4,     5,    12
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -8
static const yysigned_char yypact[] =
{
      -6,    -2,     5,    -6,    -8,    -1,     1,    -8,    -8,    -5,
      -1,    -8,    -8,     0,     3,     7,    -8,    -8,     9,     4,
       6,     8,    10,    -8,    -8,    12,    11,    13,    -7,    14,
      15,    19,    -8,    17,    18,    -8
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
      -8,    -8,    -8,    16,    -8,    20,    -8,    21
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      14,    29,     6,     1,    30,     7,    15,    13,     9,    19,
      18,    20,    21,    25,    22,     0,    28,     0,    23,    26,
      24,    27,    33,     8,    31,     0,    16,    32,    34,     0,
      35,    17
};

static const yysigned_char yycheck[] =
{
       5,     8,     4,     9,    11,     0,    11,     6,     9,     6,
      10,     4,     3,     3,    10,    -1,     3,    -1,    12,     7,
      12,    10,     3,     3,    10,    -1,    10,    12,    11,    -1,
      12,    10
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     9,    14,    17,    18,    19,     4,     0,    18,     9,
      15,    16,    20,     6,     5,    11,    16,    20,    10,     6,
       4,     3,    10,    12,    12,     3,     7,    10,     3,     8,
      11,    10,    12,     3,    11,    12
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 43 "tmcfg_yacc.y"
    {
  yyval.moduleval=NULL;
;}
    break;

  case 3:
#line 46 "tmcfg_yacc.y"
    {
  yyval.moduleval=yyvsp[0].moduleval;
  yyval.moduleval->prev->next=NULL;
  yyval.moduleval->prev=NULL;
  {
    struct tag_module_st **ppconfig=(struct tag_module_st **)parse_arg;
    *ppconfig=yyval.moduleval;
  }
;}
    break;

  case 4:
#line 57 "tmcfg_yacc.y"
    {
  yyval.paramval=yyvsp[0].paramval;
;}
    break;

  case 5:
#line 60 "tmcfg_yacc.y"
    {
  yyval.paramval=yyvsp[-1].paramval;
  yyvsp[0].paramval->next=yyval.paramval;
  yyvsp[0].paramval->prev=yyval.paramval->prev;
  yyval.paramval->prev->next=yyvsp[0].paramval;
  yyval.paramval->prev=yyvsp[0].paramval;
;}
    break;

  case 6:
#line 69 "tmcfg_yacc.y"
    {
  yyval.paramval=(struct tag_param_st*)malloc(sizeof(struct tag_param_st));
  yyval.paramval->name=yyvsp[-5].charval;
  yyval.paramval->value=yyvsp[-2].charval;
  yyval.paramval->option=NULL;
  yyval.paramval->prev=yyval.paramval->next=yyval.paramval;
;}
    break;

  case 7:
#line 76 "tmcfg_yacc.y"
    {
  yyval.paramval=(struct tag_param_st*)malloc(sizeof(struct tag_param_st));
  yyval.paramval->name=yyvsp[-8].charval;
  yyval.paramval->value=yyvsp[-5].charval;
  yyval.paramval->option=yyvsp[-2].charval;
  yyval.paramval->prev=yyval.paramval->next=yyval.paramval;
;}
    break;

  case 8:
#line 85 "tmcfg_yacc.y"
    {
  yyval.moduleval=yyvsp[0].moduleval;
;}
    break;

  case 9:
#line 88 "tmcfg_yacc.y"
    {
  yyval.moduleval=yyvsp[-1].moduleval;
  yyvsp[0].moduleval->next=yyval.moduleval;
  yyvsp[0].moduleval->prev=yyval.moduleval->prev;
  yyval.moduleval->prev->next=yyvsp[0].moduleval;
  yyval.moduleval->prev=yyvsp[0].moduleval;
;}
    break;

  case 10:
#line 97 "tmcfg_yacc.y"
    {
  yyval.moduleval=(struct tag_module_st*)malloc(sizeof(struct tag_module_st));
  yyval.moduleval->name=yyvsp[-1].charval;
  yyval.moduleval->params=NULL;
  yyval.moduleval->prev=yyval.moduleval->next=yyval.moduleval;
;}
    break;

  case 11:
#line 103 "tmcfg_yacc.y"
    {
  yyval.moduleval=(struct tag_module_st*)malloc(sizeof(struct tag_module_st));
  yyval.moduleval->name=yyvsp[-2].charval;
  yyval.moduleval->params=yyvsp[-1].paramval;
  yyvsp[-1].paramval->prev->next=NULL;
  yyvsp[-1].paramval->prev=NULL;
  yyval.moduleval->prev=yyval.moduleval->next=yyval.moduleval;
;}
    break;

  case 12:
#line 113 "tmcfg_yacc.y"
    { yyval.charval=yyvsp[-1].charval; ;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 1122 "tmcfg_yacc.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 119 "tmcfg_yacc.y"


int tmcfg_close(tmcfg_t config) {
  if(config==NULL) {
    return -1;
  }

  if(config->filename) free(config->filename);
  if(config->file) {
    /* unlock it first */
    if(config->file_lock!=0) {
      struct flock lock;
      lock.l_whence=SEEK_SET;
      lock.l_start=0;
      lock.l_len=0;
      lock.l_type=F_UNLCK;
      while(-1==fcntl(fileno(config->file), F_SETLKW, &lock) && errno==EINTR);
      config->file_lock=0;
    }
    fclose(config->file);
  }
  if(config->modules) {
    /* free config->modules */
    struct tag_module_st *pm, *pmn;
    struct tag_param_st *pp, *ppn;
    for(pm=config->modules; pm!=NULL; pm=pmn) {
      pmn=pm->next;
      for(pp=pm->params; pp!=NULL; pp=ppn) {
	ppn=pp->next;
	if(pp->name) {
	  free(pp->name);
	}
	if(pp->value) {
	  free(pp->value);
	}
	if(pp->option) {
	  free(pp->option);
	}
	free(pp);
      }
      if(pm->name) {
	free(pm->name);
      }
      free(pm);
    }
  }
  free(config);
  return 0;
}

tmcfg_t tmcfg_open(const char *filename, tmcfg_open_mode_t mode) {
  int parse_ret;
  struct tmcfg_st *config=NULL;
  config=(struct tmcfg_st*)malloc(sizeof(struct tmcfg_st));
  if(config==NULL) {
    LOGERROR("tmcfg_open: malloc: %m");
    goto error;
  }

  memset(config, 0, sizeof(struct tmcfg_st));

  config->mode=mode;
  config->file_lock=0;
  config->modified=0;

  config->filename=strdup(filename);
  if(config->filename==NULL) {
    LOGERROR("tmcfg_open: strdup(%s): %m", filename);
    goto error;
  }

  if(mode==TMCFG_MODE_UPDATE) {
    config->file=fopen(filename, "a+");
    if(config->file==NULL) {
      LOGERROR("tmcfg_open: open %s for \"a+\": %m", filename);
      goto error;
    }
  } else {
    config->file=fopen(filename, "r");
    if(config->file==NULL) {
      LOGERROR("tmcfg_open: open %s for \"r\": %m", filename);
      goto error;
    }
  }

  rewind(config->file);

  {
    struct flock lock;
    lock.l_whence=SEEK_SET;
    lock.l_start=0;
    lock.l_len=0;
    if(mode==TMCFG_MODE_UPDATE) {
      /* get write lock during the whole process */
      lock.l_type=F_WRLCK;
    } else {
      /* get read lock during parsing */
      lock.l_type=F_RDLCK;
    }
    while(-1==fcntl(fileno(config->file), F_SETLKW, &lock) && errno==EINTR);
    config->file_lock=1;
  }
  __cfg_set_yyin(config->file);
  parse_ret=yyparse(&(config->modules));


  /* not TMCFG_MODE_UPDATE */
  if(mode!=TMCFG_MODE_UPDATE) {
    /* release read lock */
    struct flock lock;
    lock.l_whence=SEEK_SET;
    lock.l_start=0;
    lock.l_len=0;
    lock.l_type=F_UNLCK;
    while(-1==fcntl(fileno(config->file), F_SETLKW, &lock) && errno==EINTR);
    config->file_lock=0;

    /* close file */
    fclose(config->file);
    config->file=NULL;
  }

  if(0==parse_ret) {
    return config;
  }

error:

  if(config) tmcfg_close(config);

  return NULL;

};

const char *tmcfg_get_param_value(tmcfg_t config, 
			     const char *module_name, 
			     const char *param_name,
			     const char **param_option) {
  struct tag_module_st *pm;
  struct tag_param_st *pp;

  if(config!=NULL) {
    for(pm=config->modules; pm!=NULL; pm=pm->next) {
      if(strcmp(pm->name, module_name)==0) {
	for(pp=pm->params; pp!=NULL; pp=pp->next) {
	  if(strcmp(pp->name, param_name)==0) {
	    if(param_option!=NULL) {
	      *param_option=pp->option;
	    }
	    return pp->value;
	  }
	}
      }
    }
  }
  return NULL;
}

int tmcfg_set_param_value(tmcfg_t config,
			   const char *module_name,
			   const char *param_name,
			   const char *param_value,
			   const char *param_option) {
  struct tag_module_st *pm, *nm;
  struct tag_param_st *pp, *np;
  char *mn, *pn, *pv, *po;

  nm=NULL;
  np=NULL;
  mn=pn=pv=po=NULL;

  if(config==NULL) {
    return -1;
  }

  config->modified=1;
  for(pm=config->modules; pm!=NULL; pm=pm->next) {
    if(strcmp(pm->name, module_name)==0) {
      for(pp=pm->params; pp!=NULL; pp=pp->next) {
	if(strcmp(pp->name, param_name)==0) {
	  /* modify pp->value, pp->option */
	  if((NULL!=param_value && NULL==(pv=strdup(param_value))) ||
	     (NULL!=param_option && NULL==(po=strdup(param_option)))) {
	    goto error;
	  }
	  
	  if(pp->value) free(pp->value);
	  if(pp->option) free(pp->option);

	  pp->value=pv;
	  pp->option=po;
	  return 0;
	}
      }
      /* insert new param to pm->params */
      if((NULL==(np=(struct tag_param_st*)malloc(sizeof(struct tag_param_st)))) ||
	 (NULL!=param_name && NULL==(pn=strdup(param_name))) ||
	 (NULL!=param_value && NULL==(pv=strdup(param_value))) ||
	 (NULL!=param_option && NULL==(po=strdup(param_option)))) {
	goto error;
	}

	np->name=pn;
	np->value=pv;
	np->option=po;
	
	np->next=pm->params;
	np->prev=NULL;
	if(pm->params != NULL)
		pm->params->prev=np;
	pm->params=np;
	return 0;
      }
  }
  /* insert new module to config->modules, new param to new module*/
  
  if((NULL==(nm=(struct tag_module_st*)malloc(sizeof(struct tag_module_st)))) || 
     (NULL==(np=(struct tag_param_st*)malloc(sizeof(struct tag_param_st)))) ||
     (NULL!=module_name && NULL==(mn=strdup(module_name))) ||
     (NULL!=param_name && NULL==(pn=strdup(param_name))) ||
     (NULL!=param_value && NULL==(pv=strdup(param_value))) ||
     (NULL!=param_option && NULL==(po=strdup(param_option)))) {
    goto error;
  }
  np->name=pn;
  np->value=pv;
  np->option=po;
  np->next=np->prev=NULL;
  nm->name=mn;
  nm->params=np;
  
  nm->next=config->modules;
  nm->prev=NULL;
  if(config->modules!=NULL) {
    config->modules->prev=nm;
  }
  config->modules=nm;
  return 0;

 error:

  LOGERROR("tmcfg_set_param_value: %m");
  if(nm) free(nm);
  if(np) free(np);
  if(mn) free(mn);
  if(pn) free(pn);
  if(pv) free(pv);
  if(po) free(po);
  return -1;
}

int	tmcfg_del_module(tmcfg_t config, const char *module_name) {
	struct tag_module_st	*pm;
	int	mlen;
	if(config == NULL)
		return -1;

	pm = config->modules;
	mlen = strlen(module_name);
	while(pm != NULL) {
		if(pm->name == NULL) {
			pm = pm->next;
			continue;
		}
		if(strncmp(pm->name, module_name, mlen) == 0) {
			struct tag_param_st	*pp, *tp;

			/* If it is the head of chain, chain it up */
			if(pm == config->modules)
				config->modules = pm->next;

			/* re-chain list */
			if(pm->prev != NULL)
				pm->prev->next = pm->next;
			if(pm->next != NULL)
				pm->next->prev = pm->prev;

			/* Free all parameter */
			pp = pm->params;
			if(pp!=NULL) {
				while(pp!=NULL) {
					tp = pp;
					pp = pp->next;
					if(tp->name!=NULL) free(tp->name);
					if(tp->value!=NULL) free(tp->value);
					if(tp->option!=NULL) free(tp->option);
					free(tp);
					config->modified=1;
				}
			}

			/* free memory */
			free(pm->name);
			free(pm);
			return 1;
		}
		pm = pm->next;
	}
	return 0;
}

int	tmcfg_del_param(tmcfg_t config, const char *module_name, const char *param_name) {
	struct tag_module_st    *pm;
	int	mlen, plen;
	if(config == NULL)
		return -1;
	pm = config->modules;
	mlen = strlen(module_name);
	plen = strlen(param_name);
	while(pm!=NULL) {
		if(pm->name == NULL) {
			pm = pm->next;
			continue;
		}
		if(strncmp(pm->name, module_name, mlen) == 0) {
			struct tag_param_st     *pp;
			pp = pm->params;
			if(pp==NULL) 
				return 0;

			while(pp!=NULL) {
				if(pp->name==NULL) {
					pp = pp->next;
					continue;
				}
				
				/* find the parameter, free it */
				if(strncmp(pp->name, param_name, plen) == 0) {
					free(pp->name);
					if(pp->value!=NULL)free(pp->value);
					if(pp->option!=NULL) free(pp->option);

					/* re-chain list */
					if(pp->prev==NULL)
						pm->params = pp->next;
					if(pp->prev!=NULL)
						pp->prev->next = pp->next;
					if(pp->next!=NULL)
						pp->next->prev = pp->prev;
					free(pp);
					config->modified=1;
					return 1;
				} // strncmp param
				pp = pp->next;
			} // while pp
		} // strncmp module
		pm = pm->next;
	}
	return 0;
}

static void __tmcfg_qs_write(FILE *out, const char *p) {
  const char *q;
  for(q=p; *p!='\0'; p++) {
    if(*p=='\"') {
      fwrite(q, 1, p-q+1, out);
      q=p;
    }
  }
  if(p>q) {
    fwrite(q, 1, p-q, out);
  }
}

int tmcfg_flush(tmcfg_t config) {
  struct tag_module_st *pm;
  struct tag_param_st *pp;
  if(config==NULL || config->file==NULL || config->file_lock==0) {
    return -1;
  }

  if(config->modified==0) {
    return 0;
  }

  if(0!=ftruncate(fileno(config->file), 0)) {
    LOGERROR("tmcfg_flush: ftruncate(%d): %m", fileno(config->file));
    return -1;
  }
  rewind(config->file);

  for(pm=config->modules; pm!=NULL; pm=pm->next) {
    fwrite("<module name=\"", 1, 14, config->file);
    if(pm->name) {
      __tmcfg_qs_write(config->file, pm->name);
    }
    fwrite("\">\n", 1, 3, config->file);

    for(pp=pm->params; pp!=NULL; pp=pp->next) {

      fwrite("  <param name=\"", 1, 15, config->file);
      if(pp->name) {
	__tmcfg_qs_write(config->file, pp->name);
      }
      fputc('\"', config->file);

      fwrite(" value=\"", 1, 8, config->file);
      if(pp->value) {
      __tmcfg_qs_write(config->file, pp->value);
      }
      fputc('\"', config->file);

      if(pp->option) {
	fwrite(" option=\"", 1, 9, config->file);
	__tmcfg_qs_write(config->file, pp->option);
	fputc('\"', config->file);
      }

      fwrite("/>\n", 1, 3, config->file);
    }
    fwrite("</module>\n\n", 1, 11, config->file);
  }

  fflush(config->file);
  sync();
  config->modified=0;

  return 0;
}

