#include <stdio.h>
#include <string.h>

#define INPUT_FILE_END ".asp"
#define OUTPUT_FILE_END ".html\0"
#define ASP_LEFT "<%"
#define ASP_RIGHT "%>"
#define MARK_LEFT "<!---- CGI SCRIPT, PLEASE DON'T REMOVE THIS LINE! ----"
#define MARK_RIGHT "---->\n"
#define DEBUGP printf

int main(int argc, char* args[])
{
	FILE* fin=NULL;
	FILE* fout=NULL;

	char *ptr=NULL;
	char *ptr1=NULL;
	char fname[256];
	char buf[1024];
	char buf1[1024];
	int fret=1;

	fin = fopen(args[1],"r");
	if (fin == NULL)
	{
		printf("wrong input file: %s\n",args[1]);
		exit(1);
	}
	ptr = (char*)(args[1] + strlen(args[1]) - 4);

	/* check if it is .asp file */
	if ( !strncmp( ptr, INPUT_FILE_END, 4 ) )
	{
	/* get file name */
		strcpy(ptr,OUTPUT_FILE_END);
//		strncpy(fname,args[1],strlen(args[1])-4);
//		DEBUGP("fname= %s\n",fname);
//		strcat(fname,OUTPUT_FILE_END);
//		DEBUGP("output filename = %s\n",fname);
		DEBUGP("output filename = %s\n",args[1]);
		strcpy(fname,args[1]);
	}
	else
	{
		fclose(fin);
		exit(1);
	}

	/* create output file for write */
	fout = fopen(fname,"w");
	if (fout == NULL)
	{
		printf("can not create output html file:%s\n",fname);
		exit(1);
	}
	/* parse input file and write to output file in the loop */
	ptr = ptr1 = NULL;
	while(fret != NULL)
	{

		fret = fgets(buf,1024,fin);
		/* if scan file and get <% or %> */
		ptr = strstr(buf,ASP_LEFT);
		ptr1= strstr(buf,ASP_RIGHT);
		if(ptr == NULL && ptr1 == NULL)
		{
			fprintf(fout,"%s",buf);
			continue;
		}
		if(ptr != NULL && ptr1 != NULL)
		{
			memset(buf1,0,1024);
			strcat(buf1,MARK_LEFT);
			strcat(buf1,buf);
			/* remove 0x0d and 0x0a */
			buf1[strlen(buf1)-1]=0;
			buf1[strlen(buf1)-1]=0;
			strcat(buf1,MARK_RIGHT);
			printf("%s",buf1);
			fprintf(fout,"%s",buf1);
			/* empty stuff between <% and %> */
//			printf("left = %s\n",ptr);
//			printf("right = %s\n",ptr1);
			memset(buf1,0,1024);
			strncpy(buf1,buf,strlen(buf)-strlen(ptr));
			strcat(buf1,(ptr1+2));
			printf("%s",buf1);
			fprintf(fout,"%s",buf1);
		}
		else
		{
			printf("%s",buf);
			fprintf(fout,"%s",buf);
		}
		ptr = ptr1 = NULL;
	}
	
	fclose(fout);	
	fclose(fin);


}
