/*
 *  misc.htm: Misc Configuration
 */
#ifndef __WEBS_MISC_H__
#define __WEBS_MISC_H__

void DefineWebFunctions_misc(); 
#define VAR_SYS_STATUS_FILE             "/var/etc/status"
typedef struct {
        char Http_Port[10];
        char IP[20];
        char logouttime[10];
}EMBEDDED_CONFIG_DATA;

typedef struct {
        int enable;;
        int upnpport;
} UPNP1_CONFIG_DATA;
typedef struct {
        int enable;;
} TMSS_CONFIG_DATA;
TMSS_CONFIG_DATA tmss_config;

typedef struct {
        int enable;;
} TELNET_CONFIG_DATA;
TELNET_CONFIG_DATA telnet_config;

UPNP1_CONFIG_DATA upnp1_config;
EMBEDDED_CONFIG_DATA embedded_config;
 int run_script(char *filename, char *arg1, char *arg2, char *arg3);


// SNMP
#define SNMP_COMM_LENG 20
#define SNMP_IP_LENG   20

typedef struct {
	int enable;
	char rcomm[SNMP_COMM_LENG];
	char wcomm[SNMP_COMM_LENG];
	char tcomm[SNMP_COMM_LENG];
	char rip[SNMP_IP_LENG];
	char wip[SNMP_IP_LENG];
	char tip[SNMP_IP_LENG];
        char v3user[SNMP_COMM_LENG]; // v3
	char v3pass[SNMP_COMM_LENG]; // v3
	int  v3accessRW; // v3
	char v3accessIP[SNMP_IP_LENG]; // v3
} SNMP_DESC_DATA;
/*************************************************/
/*    Misc_Config Files                          */
/*************************************************/
#define TELNET_CONFIG_FILE "/flash/telnet.conf"
#define TMSS_CONFIG_FILE "/flash/tmss.conf"
#define EMBEDDED_CONFIG_FILE "/flash/embedded.conf"
#define EMBEDDED_SCRIPT_FILE "/etc/scripts/embedded.sh"

#define SNMPD_DESC_FN             "/flash/snmpd.desc"
#define SNMPD_CONF_FN             "/var/etc/snmpd.conf"
#define SNMPD_SCRIPT_FILE           "/etc/scripts/snmpd.sh"

#define UPNP1_CONFIG_FILE           "/flash/upnpcfg.conf"

	
#endif /* __WEBS_MISC_H__ */
