/*
 *  pwdadmin.htm: Admin Password Configuration
 */
#include "webs.h"
#include "pwdadmin.h"
#include "um.h"
#define R_ADMIN_LOGIN "admin"

extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
static int get_admin_pwd (int ejid, webs_t wp, int argc, char_t **argv);
void form_pwdadmin_conf(webs_t wp, char_t * path,char_t * query);
static int get_admin_pwd (int ejid, webs_t wp, int argc, char_t **argv)
{
	return	websWrite(wp, T("%s"),umGetUserPassword(R_ADMIN_LOGIN));
}
void form_pwdadmin_conf(webs_t wp, char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char_t pwdadmin[256];
	int nCheck;
	buf=websGetVar(wp, T("AdminPassword"), "");
        strcpy(pwdadmin,buf);
	nCheck = umSetUserPassword(T(R_ADMIN_LOGIN), pwdadmin);
	if (nCheck==0)
	{
			if ( umCommit(T("webuser.txt")) != 0) 
				websWrite(wp, T("ERROR: Unable to save user configuration."));
			else{ 
				//Julian add for restart telnetd 07262005
				run_script("/etc/scripts/telnetd.sh",0,0,0);
				websRedirect(wp, "pwdadmin.asp");
			}
	}

}

void DefineWebFunctions_pwdadmin()
{
	websAspDefine(T("get_admin_pwd"), get_admin_pwd);  
	websFormDefine(T("pwdadmin"), form_pwdadmin_conf);
}	
