/*
 *  route.htm: Static Routing Configuration
 */
 /****************************************************************************
 * includes
 ****************************************************************************/

/****************************************************************************
 * definitions (macros)
 ****************************************************************************/
#define ROUTE_CONFIG_FILE "/flash/routes.conf"
#define TMP_ROUTE_CONFIG_FILE "/var/etc/routes.conf"
#define ROUTE_SCRIPT_FILE "/etc/scripts/route"
#define SYS_ROUTE_CONF   "/proc/net/route"

#define MAX_ROUTES 20

/****************************************************************************
 * definitions (types)
 ****************************************************************************/

typedef struct {
    int valid;
    char destination[20];
    char netmask[20];
    char gateway[20];
    int interface;
    int cost;
}ROUTE_CONFIG_DATA;

typedef struct {
	char	Iface[20];
	char	Destination[20];
   	char	Gateway[20];
	char	Flags[20];
     	char	RefCnt[20];
      	char	Use[20];
   	char	Metric[20];
      	char	Mask[20];
	char	MTU[20];
   	char	Window[20];
   	char	IRTT[20];
}ROUTE_CONFIG_DATA1;

extern void CopyFile(char *filename1,char *filename2);
extern int route_main(int argc, char **argv);
extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
extern int print_blank_string(void *d);
extern int load_blank_string(void *d);
extern char *HextoDec_ip(char *ip_value,char *buf); 
void DefineWebFunctions_route();
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
