/*
 * wan.htm: WAN status
 */
#ifndef __WAN_VOD_H__
#define __WAN_VOD_H__
#define OTHER_WAN_BRGIDE_CONFIG_FILE    "/flash/wanbr.conf"
#define KNOWN_VOD_TYPE_LIST_CONFIG_FILE    "/flash/vod_type.conf"

#define MAX_OTHER_WAN_BRIDGE 7
typedef struct {	
	//1483 Bridge
	int wan_bridge_no;
        char Bridged_Description[MAX_OTHER_WAN_BRIDGE][50];
	int usingSamePVCFromExistingWanConnection[MAX_OTHER_WAN_BRIDGE];
	unsigned short Bridged_VPI[MAX_OTHER_WAN_BRIDGE];
        unsigned short Bridged_VCI[MAX_OTHER_WAN_BRIDGE];
	int Bridged_ATM_Class[MAX_OTHER_WAN_BRIDGE];
	int Bridged_Encapsulation_Method[MAX_OTHER_WAN_BRIDGE];
	int Bridged_Ether_Filter_Type[MAX_OTHER_WAN_BRIDGE];
	int Bridged_Spanning_Bridge_Interface[MAX_OTHER_WAN_BRIDGE];

} OTHER_WAN_BRIDGE_DATA;
#define MAX_KNOW_VOD_TYPE_NO 10

typedef struct {	
	//1483 Bridge
	int previous_selected_vod_type_no;
	int known_vod_type_no;
	int  pvc_no[MAX_KNOW_VOD_TYPE_NO];// numof PVCs
        char description[MAX_KNOW_VOD_TYPE_NO][128];
	int indexToWanConfigFile[MAX_KNOW_VOD_TYPE_NO];// the profile is wanx.conf wanbrx.conf and vlanx.conf. x is the index here.
	char WAN[MAX_KNOW_VOD_TYPE_NO][10];// the WAN parameter in the /flash/config
	char WAN_IF[MAX_KNOW_VOD_TYPE_NO][10];// the WAN_IF parameter in the /flash/config
	int tcwd[MAX_KNOW_VOD_TYPE_NO];// watch dog enabled or disabled.
	int autoScanNeed[MAX_KNOW_VOD_TYPE_NO];// want to autoScan
} KNOWN_VOD_TYPE_LIST;

void Load_Other_Wan_Bridge_Config (OTHER_WAN_BRIDGE_DATA *d); // KenWang added 2006/01/02

extern OTHER_WAN_BRIDGE_DATA other_wan_bridge_data;
// KenWang added 2006/01/04
int mainWanHasOtherWanBridgeUseTheSamePVC(void);
#endif


