/*
 *  wireless.asp: Wireless Configuration
 */
void DefineWebFunctions_wireless();
void DefineWLANTestFunctions(); // KenWang added 2005/06/03
void DefineWirelessMacFilterConfig(); // KenWang added 2005/06/08
extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
typedef struct {
	int Enable;/* 1 for enabled, 0 for disabled */
	int Mode; /* 0 for 802.11b+g, 1 for 802.11g, 2 for 802.11b */
	char Essid[32];
	int HideEssid; // KenWang added 2005/06/14
	int RegulationDomain;
	int ChannelID;
	int WMM_QOS_Enable;
	int QMM_Power_Saving_Enable;
	int WDSEnable;
#ifdef _RALINK_WIRELESS_DRIVER_
	char WDSMAC1[32];
	char WDSMAC2[32];
	char WDSMAC3[32];
	char WDSMAC4[32];
#else
	char WDSMAC[32];
#endif
	
	char Sec_Mode[8]; /* 0 for disable, 1 for WPA Pre-Shared Key, 2 WEP */
	/* WPA START */
	char WPA_Algorithm[16];
	char WPA_Shared_Key[65];
	int WPA_Group_Key_Renewal;
#ifdef _RALINK_WIRELESS_DRIVER_
	/* WPA2 START */
	char WPA2_Algorithm[16];
	char WPA2_Shared_Key[65];
	int WPA2_Group_Key_Renewal;
#endif
// KenWang marked 2005/06/14	int WPA_Hide_Essid; /* 0 for disable, 1 for enable */
	/* WPA END */
	/* WEP START  */
	int WEP_Encryption; /* 1 for WEP64, 5 for WEP128 */
	int WEP_Authentication; /* 0 for open, 2 for shared, 3 for both */ // KenWang added 2005/06/14
	int WEP_Phrase_Type; /* 0 for Hex, 1 for ASCII */
	int WEP_Keyid;
	char WEP_Key1[32];
	char WEP_Key2[32];
	char WEP_Key3[32];
	char WEP_Key4[32];
	char WEP_Passphrase[128];
// KenWang markded 2005/06/14	int WEP_Hide_Essid;

} WIRELESS_CONFIG_DATA;
WIRELESS_CONFIG_DATA wireless_config;

extern char* read_file_para_value(char *filename, char *arg1,char *buf);
/*************************************************************/
/*   		Wireless Config File                             */
/*************************************************************/
#define WIRELESS_CONFIG_FILE "/flash/wireless.conf"
