/*
 * Board Support Package header file
 */

#ifndef _DVD_UART_H_
#define _DVD_UART_H_

#define BAUDC(f)        ((unsigned int)(SYSCLK / (16.0*(f)) + 0.5)-1)
#define UART_BAUD_2400          BAUDC(2400)
#define UART_BAUD_115200        BAUDC(115200)
#define UART0_set_baudrate(x)   do {                            \
                                  dvd_regs->uart0_div_h = (x>>8);  \
                                  dvd_regs->uart0_div_l = (x);     \
                                } while (0)                     \

#define UART1_set_baudrate(x)   do {                            \
                                  dvd_regs->uart1_div_h = (x>>8);  \
                                  dvd_regs->uart1_div_l = (x);     \
                                } while (0)                     \

#define TX_READY		0x01

extern void uart_put_char(unsigned char ch);
extern void uart_prints(unsigned char *s);

#endif
