/*  
 * Definitions used to for bus arbitrator module.
 *
 * Copyright (C) 2002 Viosoft Corp.
 * Support for TrendChip TC3160
 */

#ifndef __TC3160_ARB_H__ 
#define __TC3160_ARB_H__ 

#include <asm/addrspace.h>

#define TC3160_ARB_BASE		(KSEG1 + 0x12000700)
#define TC3160_HPMSR_REG	(TC3160_ARB_BASE + 0x0)
#define TC3160_BER_REG		(TC3160_ARB_BASE + 0x4)
#define TC3160_BEAR_REG		(TC3160_ARB_BASE + 0x8)

#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3160_ARB_H__ */

