
/*  
 * Definitions used to for GPIO module.
 *
 * Copyright (C) 2002 Viosoft Corp.
 * Support for TrendChip TC3160
 */

#ifndef __TC3160_GPIO_H__ 
#define __TC3160_GPIO_H__ 

#include <asm/addrspace.h>

#define TC3160_GPIO_BASE	(KSEG1 + 0x12000500)
#define TC3160_GPVAL_REG	(TC3160_GPIO_BASE + 0x0)
#define TC3160_GPOEN_REG	(TC3160_GPIO_BASE + 0x4)
#define TC3160_GPINT1_REG	(TC3160_GPIO_BASE + 0x8)
#define TC3160_GPINT2_REG	(TC3160_GPIO_BASE + 0xc)
#define TC3160_GPINT3_REG	(TC3160_GPIO_BASE + 0x10)
#define TC3160_GPINT4_REG	(TC3160_GPIO_BASE + 0x14)
#define TC3160_GPIMR_REG	(TC3160_GPIO_BASE + 0x18)
#define TC3160_GPSEL_REG	(TC3160_GPIO_BASE + 0x1c)
#define TC3160_GPIMS_REG	(TC3160_GPIO_BASE + 0x20)
#define TC3160_BISTMD_REG	(TC3160_GPIO_BASE + 0x24)
#define TC3160_PLLSP_REG	(TC3160_GPIO_BASE + 0x28)

#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3160_GPIO_H__ */

