/*
 * Definitions used to for PCI Host Bridge  Operation register.
 *
 * Written by Billion Co.
 * Support for TrendChip TC3162
 */
                                                                                                                                               
                                                                                                                                               
#ifndef __TC3162_PCI_H__
#define __TC3162_PCI_H__
                                                                                                                                               
#include <asm/addrspace.h>
                                                                                                                                               
/* PCI operation registers */
#define TC3162_PCI_CONFIG_ADDR                  (KSEG1 + 0x1FB80CF8)
#define TC3162_PCI_CONFIG_DATA                  (KSEG1 + 0x1FB80CFC)

#define TC3162_PCI_HOST_CONFIG_MEM_ADDR         0x80000000
#define TC3162_PCI_SLOT1_CONFIG_MEM_ADDR        0x80000800
#define TC3162_PCI_SLOT2_CONFIG_MEM_ADDR        0x80001000
						
#define TC3162_PCI_DEVICE_IO_START           	0x1FB90000
#define TC3162_PCI_DEVICE_IO_END             	0x1FB9FFFF
#define TC3162_PCI_DEVICE_MEM_START          	0x1FBA0000
#define TC3162_PCI_DEVICE1_MEM_START         	0x1FBA0000
#define TC3162_PCI_DEVICE2_MEM_START         	0x1FBB0000
#define TC3162_PCI_DEVICE_MEM_SIZE           	0x0000FFFF
#define TC3162_PCI_DEVICE_MEM_END            	0x1FBCFFFF







#endif

