#ifndef __sar_h__
#define __sar_h__



#define	HS_GCF0			0xb2001000
#define HS_GISR			0xb200100c
#define HS_VC0CFG		0xb2001010
#define HS_CCTCONTROL	0xb2001100
#define HS_VC0TCONTROL	0xb2001104

#define HS_CCRCONTROL	0xb2001200
#define HS_VC0RCONTROL	0xb2001204
#define HS_VCERRORC		0xb2001254
#define HS_IRQLO		0xb2001258
#define HS_IRQHI		0xb200125c
#define HS_IRQHEAD		0xb2001260
#define HS_IRQTAIL		0xb2001264
#define HS_IRQSTATUS	0xb2001268
#define HS_IRQCONTROL	0xb200126c
#define HS_IRQAAL5MAX	0xb2001270


#define HS_CCTRAFFIC	0xb2001600
#define HS_VC0TRAFFIC1	0xb2001610
#define HS_VC0TRAFFIC2	0xb2001618
#define HS_CCTDP		0xb2001750
#define HS_VC0TDP		0xb2001754
#define HS_VC0MMP		0xb20017b0
#define HS_VC0TDPI		0xb2001800
#define HS_VC0UDTTS		0xb2001940
#define HS_VC0AAL5E		0xb2001990
#define HS_VC0TCRC		0xb20019e0
#define HS_VC0AAL5TC	0xb2001a30

#define HS_CCRDP		0xb2001c00
#define HS_VC0RDP		0xb2001c04
#define HS_VC0RDPI		0xb2001c70
#define HS_VC0UDRTS		0xb2001db0
#define HS_VC0RCRC		0xb2001e00
#define HS_MAXAAL5NUM	0xb2001270


#define SARBIG			1
#define SARLITTLE		0
#define SARLOOPBACK		1
#define SARNOLOOPBACK	0
#define MASTERENABLE	1
#define MASTERDISABLE	0
#define AAL5ENABLE		1
#define AAL5DISABLE		0
#define SARIRQENABLE	1
#define SARIRQRESET		0

#endif


