
#ifdef TC_RT61AP_PROC
#include "linux/proc_fs.h"
#include "rt_config.h"
#include "linux/netdevice.h"

struct proc_dir_entry *rt61ap_dir = NULL;

#if 0
static int proc_version_read(char *buf, char **start,
                        off_t off, int count, int *eof, void *data)
{
        char                  *p = buf;
        p+=sprintf(p, "version = %s\n\n", DRIVER_VERSION);
	return (p - buf);
}
#endif     
                                                                                                                     
int proc_info_read(char *buf, char **start,
                        off_t off, int count, int *eof, void *data)
{
	struct net_device *net_dev;
	char *p = buf;
	net_dev = (struct net_device *)data;

	p+=sprintf(p,"Version = %s\nMacAddress = %02X:%02X:%02X:%02X:%02X:%02X\n",DRIVER_VERSION,net_dev->dev_addr[0],net_dev->dev_addr[1],net_dev->dev_addr[2],net_dev->dev_addr[3],net_dev->dev_addr[4],net_dev->dev_addr[5]);
	return (p - buf);

}

void init_rt61ap_proc(void *param)
{
	struct proc_dir_entry *entry;
	struct net_device* net_dev;
	net_dev = (struct net_device *)param;	
	
	rt61ap_dir = proc_mkdir("rt61ap",NULL);
	if (rt61ap_dir == NULL)
		return;
	entry = create_proc_read_entry("info",0,rt61ap_dir, proc_info_read, net_dev); 
        //entry = create_proc_read_entry("version", 0, rt61ap_dir, proc_version_read, NULL);
}


void remove_rt61ap_proc(void)
{

	if( rt61ap_dir == NULL )
		return;
	
	remove_proc_entry("info",rt61ap_dir);
	rt61ap_dir = NULL;
}
#endif
