#ifndef _TC3162IOCTL_
#define _TC3162IOCTL_




/*
 * Ioctl definitions.
 */
/* reserved SIOCDEVPRIVATE */
enum {
    SIOCSVLANPORT = SIOCDEVPRIVATE + 1,
    SIOCGVLANPORT,
    SIOCLAST
};


enum IP175C_vlan_ioctl_cmds {
	Set_VLAN_Port=1,
	Enable_IGMP_Snoop,
        	Disable_VLAN,
        	Switch_Reset,
        	Set_Lan_Mii,
        	Get_Lan_Mii,
	VODX,
	Set_EWAN_Port,
/***Merlin add***************/
	Reset_VLAN,
	UnSet_VLAN_Port,
	Set_VID,
	UnSet_VID        		
/*************************/
};

struct IP175C_vlan_ioctl_args {
        unsigned int request_cmd;
        unsigned int portmask;
        unsigned int phyaddr;
        unsigned int regid;
        unsigned int regvalue;
	/* KenWang modified 2005/12/27 for vlan tag -- begin -- */
	unsigned int tagmask;
	unsigned int VID[8];
/***Merlin add***************/
	unsigned int regids[8];
	int argcindex;
/*************************/
	/* KenWang modified 2005/12/27 for vlan tag -- end -- */
//      short vlan_qos;   
};
static void soft_reset(void);
//#define ICPLUS_PORTBASE_VLAN 0x8080
//#define ICPLUS_PORTBASE_VLAN_0 (0x01<<8) | ICPLUS_PORTBASE_VLAN
//#define ICPLUS_PORTBASE_VLAN_1 (0x02) | ICPLUS_PORTBASE_VLAN
//#define ICPLUS_PORTBASE_VLAN_2 (0x04<<8) | ICPLUS_PORTBASE_VLAN
//#define ICPLUS_PORTBASE_VLAN_3 (0x08) | ICPLUS_PORTBASE_VLAN
/***Merlin add***************/
#define VLAN_IOCTL_RESET  (SIOCDEVPRIVATE+4)
#define VLAN_IOCTL_SET  (SIOCDEVPRIVATE+5)
#define VLAN_IOCTL_GET  (SIOCDEVPRIVATE+6)
/*************************/
#endif 
