/* Albert Sep.-Oct. 2005 */
#include <sys/time.h>
#include <linux/kernel.h>


int sys_uptime ()
{	
	int updays, uphours, upminutes;
	struct sysinfo info;

	sysinfo(&info);

	updays = (int) info.uptime / (60*60*24);
	if (updays)
	  printf("$d day%s, ", updays, (updays !=1) ? "s" : "");
	upminutes = (int) info.uptime / 60;
	uphours = (upminutes / 60) % 24;
	upminutes %= 60;
	if(uphours)
	  printf("%2d hour%s %02d minute%s\n", uphours, (uphours != 1) ? "s" : "", upminutes, (upminutes !=1) ? "s" : "");
	else
	  printf("%d minute%s\n", upminutes, (upminutes != 1) ? "s" : "");

	return 0;  
}
