/* Robert Wu, Billion Co. */
/* This is sip alg workaround, you shouldn't use it when no unlianged kernel instruction occured */
/* People should find out why more than 16 bytes offset occured when using expectation in sip alg */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <setjmp.h>
#include <fcntl.h>		/* open */
#include <sys/ioctl.h>		/* ioctl */
#include <ctype.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
//int save_globe_config(char *filename, char *arg1, char *arg2);
static int waiting;
static sigjmp_buf sigjmp;
static int usr2_flag = 0;
extern void run_task (char *cmd, ...);
#define REG_LINENO 17
#define AUTH1_LINENO 38
#define AUTH2_LINENO 42
#define DPRINTF printf
#define NULL 0

#undef LIBVER
#ifdef LIBVER
#define MAINFUNC sip_alg_wk_main
#else
#define MAINFUNC main
#endif

#define VAR_SYS_STATUS_FILE 		"/var/etc/status"
#define READ_BUF_SIZE	50
static void
handle_usr2 (int sig)
{
  usr2_flag = 1;
  if (waiting)
    siglongjmp (sigjmp, 1);
}

typedef struct URI
{
  char reg[64];
  char auth1[64];
  char auth2[64];
} Uri;


char *tmpbuf;
char buf[256];
char dest_ip[20];
char str_wanip[20];
char buf1[50];
char buf2[50];
char dest_port[20];
char dest_port1[20];
char dest_port2[20];

typedef struct RULES_QUEUE
{
  char dest_ip[20];
  char dest_port[20];
  char str_wanip[20];
  int timer;
} Rules_Queue;

Rules_Queue rq[5];
int rq_idx = 0;

int
MAINFUNC (int argc, char *argv[])
{
  FILE *fp;
  FILE *fp1;
  int count = 0;
  usr2_flag = 0;
  //sigset (SIGUSR2, handle_usr2);
  struct sigaction sa;
  sigset_t mask;
  sigset_t mask1;
  int pid = 0;
  int i = 0;
  int j = 0;
  int uport = 0;
  Uri uri, uri_old;
  memset (&uri, 0, sizeof (Uri));
  memset (&uri_old, 0, sizeof (Uri));

  sigemptyset (&mask);
  sigaddset (&mask, SIGUSR2);
#define SIGNAL(s, handler)	do { \
	sa.sa_handler = handler; \
	if (sigaction(s, &sa, NULL) < 0) \
	    printf("Couldn't establish signal handler (%d): %m", s); \
    } while (0)

  sa.sa_mask = mask;
  sa.sa_flags = 0;

  SIGNAL (SIGUSR2, handle_usr2);
  SIGNAL (SIGCHLD, SIG_IGN);
  waiting = 0;

  pid = getpid () & 0xFFFF;
  printf ("pid=%d\n", pid);

  fp = fopen ("/proc/net/ip_sip_apid", "w");
  if (fp != 0)
    {
      fprintf (fp, "%d\n", (pid));
      fclose (fp);
    }

  while (1)
    {

      if (sigsetjmp (sigjmp, 1) == 0)
	{
	  if (usr2_flag)
	    {
	      sigprocmask (SIG_BLOCK, &mask1, NULL);
	    start_loop:
#if 1
	      fp = fopen ("/proc/net/ip_sip_conntrack", "r");
	      if (fp == 0)
		{
		  DPRINTF ("read file error!\n");
//                sleep (1);
		  goto start_loop;
//            exit (1);
		}
	      tmpbuf = fgets (buf, 256, fp);
	      DPRINTF ("%s\n", buf);
	      tmpbuf = fgets (buf, 256, fp);
	      DPRINTF ("%s\n", buf);
	      fclose (fp);
#endif
#if 1
	      if (tmpbuf != 0)
		{
		  sscanf (tmpbuf, "%64[^:]:%s\n", dest_ip, dest_port);
		  memset (str_wanip, 0, 20);
		  strcpy (str_wanip,
			  (char *) read_file_para_value (VAR_SYS_STATUS_FILE,
							 "WAN_IP=", buf1));
#if 0
		  memset (buf2, 0, sizeof (buf2));
		  sprintf (buf2, "/tmp/test%d.sh", count);
		  fopen (buf2, "w");
		  uport = atoi (dest_port);

		  fprintf (fp,
			   "/usr/sbin/iptables -I PREROUTING -t nat -d %s -p udp --dport %d -j DNAT --to-destination %s\n",
			   str_wanip, uport - 1, dest_ip);
		  fprintf (fp,
			   "/usr/sbin/iptables -I PREROUTING -t nat -d %s -p udp --dport %d -j DNAT --to-destination %s\n",
			   str_wanip, uport, dest_ip);
		  fprintf (fp,
			   "/usr/sbin/iptables -I PREROUTING -t nat -d %s -p udp --dport %d -j DNAT --to-destination %s\n",
			   str_wanip, uport + 1, dest_ip);
		  fprintf (fp, "sleep 7\n");
		  fprintf (fp,
			   "/usr/sbin/iptables -D PREROUTING -t nat -d %s -p udp --dport %d -j DNAT --to-destination %s\n",
			   str_wanip, uport - 1, dest_ip);
		  fprintf (fp,
			   "/usr/sbin/iptables -D PREROUTING -t nat -d %s -p udp --dport %d -j DNAT --to-destination %s\n",
			   str_wanip, uport, dest_ip);
		  fprintf (fp,
			   "/usr/sbin/iptables -D PREROUTING -t nat -d %s -p udp --dport %d -j DNAT --to-destination %s\n",
			   str_wanip, uport + 1, dest_ip);
		  fclose (fp);
		  run_task ("/bin/sh", "/bin/sh", buf2, NULL);
		  unlink (buf2);
#else
		  memset (&rq[rq_idx], 0, sizeof (Rules_Queue));
		  memset (dest_port1, 0, sizeof (dest_port1));
		  memset (dest_port2, 0, sizeof (dest_port2));
		  memcpy (rq[rq_idx].dest_ip, dest_ip, sizeof (dest_ip));
		  memcpy (rq[rq_idx].str_wanip, str_wanip,
			  sizeof (str_wanip));
		  memcpy (rq[rq_idx].dest_port, dest_port,
			  sizeof (dest_port));
		  uport = atoi (rq[rq_idx].dest_port);
		  sprintf (dest_port1, "%d", uport - 1);
		  sprintf (dest_port2, "%d", uport + 1);
		  run_task ("/usr/sbin/iptables", "/usr/sbin/iptables", "-I",
			    "PREROUTING", "-t", "nat", "-d",
			    rq[rq_idx].str_wanip, "-p", "udp", "--dport",
			    rq[rq_idx].dest_port, "-j", "DNAT",
			    "--to-destination", rq[rq_idx].dest_ip, NULL);
		  run_task ("/usr/sbin/iptables", "/usr/sbin/iptables", "-I",
			    "PREROUTING", "-t", "nat", "-d",
			    rq[rq_idx].str_wanip, "-p", "udp", "--dport",
			    dest_port1, "-j", "DNAT", "--to-destination",
			    rq[rq_idx].dest_ip, NULL);
		  run_task ("/usr/sbin/iptables", "/usr/sbin/iptables", "-I",
			    "PREROUTING", "-t", "nat", "-d",
			    rq[rq_idx].str_wanip, "-p", "udp", "--dport",
			    dest_port2, "-j", "DNAT", "--to-destination",
			    rq[rq_idx].dest_ip, NULL);
		  rq[rq_idx].timer = ((count + 7) % 200000);
		  if (!rq[rq_idx].timer)
		    rq[rq_idx].timer++;

		  rq_idx++;
		  if (!(rq_idx % 5))
		    rq_idx = 0;

#endif


		}
#endif
	      sigprocmask (SIG_UNBLOCK, &mask1, NULL);
	      waiting = 0;
	      usr2_flag = 0;
	    }
	}
#if 1
      sleep (1);
      //check if any rules need to be deleted
      for (i = rq_idx; i < rq_idx + 5; i++)
	{
	  if (rq[(i % 5)].timer && rq[(i % 5)].timer < count)
	    {
	      rq[(i % 5)].timer = 0;
	      memset (dest_port1, 0, sizeof (dest_port1));
	      memset (dest_port2, 0, sizeof (dest_port2));
	      uport = atoi (rq[(i % 5)].dest_port);
	      sprintf (dest_port1, "%d", uport - 1);
	      sprintf (dest_port2, "%d", uport + 1);
	      run_task ("/usr/sbin/iptables", "/usr/sbin/iptables", "-D",
			"PREROUTING", "-t", "nat", "-d",
			rq[(i % 5)].str_wanip, "-p", "udp", "--dport",
			rq[(i % 5)].dest_port, "-j", "DNAT",
			"--to-destination", rq[(i % 5)].dest_ip, NULL);
	      run_task ("/usr/sbin/iptables", "/usr/sbin/iptables", "-D",
			"PREROUTING", "-t", "nat", "-d",
			rq[(i % 5)].str_wanip, "-p", "udp", "--dport",
			dest_port1, "-j", "DNAT", "--to-destination",
			rq[(i % 5)].dest_ip, NULL);
	      run_task ("/usr/sbin/iptables", "/usr/sbin/iptables", "-D",
			"PREROUTING", "-t", "nat", "-d",
			rq[(i % 5)].str_wanip, "-p", "udp", "--dport",
			dest_port2, "-j", "DNAT", "--to-destination",
			rq[(i % 5)].dest_ip, NULL);
	      break;
	    }

	}
#endif

#if 1
      if ((count % 3) == 0)
	{
	  if (count > 200000)
	    count = 0;

	  fp = fopen ("/proc/net/ip_sip_apid", "w");
	  if (fp != 0)
	    {
	      fprintf (fp, "%d\n", (pid));
	      fclose (fp);
	    }

	  fp = fopen ("/flash/xconfig.cfg", "r");
	  if (fp != 0)
	    {
	      memset (&uri, 0, sizeof (Uri));
	      for (i = 0; i < REG_LINENO; i++)
		fgets (buf, 128, fp);
	      j = sscanf (buf, "registrar %s\n", uri.reg);
	      for (i = 0; i < (AUTH1_LINENO - REG_LINENO); i++)
		fgets (buf, 128, fp);
	      j = sscanf (buf, "mreg_uid0 %s\n", uri.auth1);
	      for (i = 0; i < (AUTH2_LINENO - AUTH1_LINENO); i++)
		fgets (buf, 128, fp);
	      j = sscanf (buf, "mreg_uid1 %s\n", uri.auth2);
	      fclose (fp);
	      //debug
//            DPRINTF ("reg=%s\n", uri.reg);
//            DPRINTF ("auth1=%s\n", uri.auth1);
//            DPRINTF ("auth2=%s\n", uri.auth2);
	    }
	  if (memcmp (&uri, &uri_old, sizeof (Uri)))
	    {
	      memcpy (&uri_old, &uri, sizeof (Uri));
	      /* write to /proc/net/ip_sip_line1 and ip_sip_line2 */
	      fp = fopen ("/proc/net/ip_sip_line1", "w");
	      if (fp != 0)
		{
		  fprintf (fp, "%s@%s", uri.auth1, uri.reg);
		  fclose (fp);
		}
	      fp = fopen ("/proc/net/ip_sip_line2", "w");
	      if (fp != 0)
		{
		  fprintf (fp, "%s@%s", uri.auth2, uri.reg);
		  fclose (fp);
		}
	    }

	}
      count++;
#endif

//      sleep (1);
    }
finish_loop:
  exit (0);

}
