/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file   TmVersion.h
 *  @brief  This file is used to indicate the project version number.  It will 
 *          be opened and modified by build script.
 */

/*
 *  Change Log
 *  2004-02-14  Jeremy  initial version
 */

#ifndef __TM_VERSION_H__
#define __TM_VERSION_H__

#include "TmBuild.h"

#define TM_VERSION_SZ		"1.0"
#define TM_MAJOR_VERSION	(1)
#define TM_MINOR_VERSION	(0)

#define TM_VA_VERSION_SZ	"1.0"
#define TM_VA_MAJOR_VERSION        (1)
#define TM_VA_MINOR_VERSION        (0)
#endif // __TM_VERSION_H__
