/************************************************
 $ ScanMail for Microsoft Exchage v3.6
 -----------------------------------------------
 $Project: ESE
 $Date: Sep, 2000
 $Log: Smex36|ESE|SmexDbg.h
 $Author: Roy Shyu
************************************************/

/*
 *****************************************************************************
 *
 *	(C) Copyright 1989-2000 Trend Micro, Inc.
 *	All Rights Reserved.
 *
 *	This program is an unpublished copyrighted work which is proprietary
 *	to Trend Micro, Inc. and contains confidential information that is not
 *	to be reproduced or disclosed to any other person or entity without
 *	prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *	WARNING:  Unauthorized reproduction of this program as well as
 *	unauthorized preparation of derivative works based upon the
 *	program or distribution of copies by sale, rental, lease or
 *	lending are violations of federal copyright laws and state trade
 *	secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************
 */
// SmexDbg.h
#ifndef INCLUDE_SMEXDBG_inc
#define INCLUDE_SMEXDBG_inc

#undef  assert
//#undef  _NO_ASSERTION // Always turn on assert() during testing

#if defined(_NO_ASSERTION)

#define assert(exp)     ((void)0)

#else

#define assert(exp) (void)( (exp) || (_assert_log(#exp, __FILE__, __LINE__), 0) )
void __cdecl _assert_log ( void *expr, char *filename, unsigned lineno );

//#define assert(exp) (void)( (exp) || (_assert(#exp, __FILE__, __LINE__), 0) )
//void __cdecl _assert ( void *expr, char *filename, unsigned lineno );

#endif  /* NDEBUG */

#include "SMEXDBGWrapper.h"

extern CSMEXDBGESEWrapper _MSG_ESE;

#define SMXESE_DBG_GENERIC		0x00000001
#define SMXESE_DBG_ESEAPI		0x00000002
#define SMXESE_DBG_SOCKET		0x00000004
#define SMXESE_DBG_SESSION		0x00000008
#define SMXESE_DBG_LIST			0x00000010

#define SMXESE_ASSERT			0x10000000
#define SMXESE_EXCEPTION		0x20000000

#define SMXESE_DBG_SEVERE_ERROR(flag)	( (flag & 0xF0000000) )

#define SMX30_DEBUG_KEY _T("SOFTWARE\\TrendMicro\\ScanMail for Exchange\\Tools\\Debug")

// Remove old debug log functions.
/*
BOOL SmxDebugInit(HANDLE hModule);
BOOL SmxMonitorDebugOption(HANDLE hEvent);
BOOL SmxDebugGetRegistrySetting();
void SmxDebugTerm();

void _MSG_ESE(UINT nLevel, UINT nCategory, TCHAR* szFormat, ...);
void _MSG_BUFFER_PRINT_ESE(UINT nLevel, UINT nCategory, char* lpszBuffer, int cbBuffer);
*/

#endif