// TrackerReport.h : main header file for the Tracker Report application
//

// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#if !defined(AFX_TRACKERREPORT_H__A14ECE90_E24D_11D0_8286_00C04FD73634__INCLUDED_)
#define AFX_TRACKERREPORT_H__A14ECE90_E24D_11D0_8286_00C04FD73634__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols


/////////////////////////////////////////////////////////////////////////////
// CTrackerReportApp:
// See TrackerReport.cpp for the implementation of this class
//

class CTrackerReportApp : public CWinApp
{
public:
	CTrackerReportApp();
	void PrepareDRM(char *szBuff, int nLen);
	void SetStatusMsg(CString szMsg);
	BOOL SplitFileName(LPCTSTR lpszPath, LPTSTR lpszDir, LPTSTR lpszFile);
	BOOL GetAppPath(LPTSTR szPath, DWORD nSize, HINSTANCE hInst);
	int DB(char *lpszFormat, ...);
	int ParseDRM(char *szBuff);
	void CTrackerReportApp::BUFFER_PRINT(char* lpszBuffer, int cbBuffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTrackerReportApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CTrackerReportApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRACKERREPORT_H__A14ECE90_E24D_11D0_8286_00C04FD73634__INCLUDED_)
