/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @ht_mstring.h
 *  @
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */


#ifndef _MSTRING_H_
#define _MSTRING_H_

#ifdef  __cplusplus
extern "C"
{
#endif

    extern int      mstrstr(const char *s1, int l1, const char *s2, int l2);
    extern int      mstrcasestr(const char *s1, int l1, const char *s2, int l2);
    extern int      mstrcmp(const char *s1, int l1, const char *s2, int l2);
    extern int      mstrcasecmp(const char *s1, int l1, const char *s2, int l2);
    extern int      mstrncmp(const char *s1, int l1, const char *s2, int l2, int CompareLen);
    extern int      mstrncasecmp(const char *s1, int l1, const char *s2, int l2, int CompareLen);
    extern char *   mstrdupsz( const char *p, const char *e );
    extern int      mstrdup( const char *p, const char *e, char **np, char **ne );
    extern int      trimleft(char *szInput, const char *szTrimChar);
    extern int      trimright(char *szInput, const char *szTrimChar);
    extern const char * mstrchr_nqs( const char *pBegin, const char *pEnd, const char *szQuoteBegin, const char *szQuoteEnd, const char ch );
    extern char *   mstripqs(const char *pBegin, const char *pEnd);

#ifdef  __cplusplus
}
#endif

#endif

