/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file  tmException.h
 *  @brief TMOG AVEnforcer Module - Exception List
 */

/*
 *  Change Log
 *  2004-02-18 Eric Li Initialization version
 */

#ifndef EXCEPTION_H
#define EXCEPTION_H

#ifdef __cplusplus
extern "C" {
#endif 

#define TMSS_EXCEPTION_CONFSHMKEY              ((key_t)1954)
#define TMSS_EXCEPTION_CONFSEMLOCKKEY          ((key_t)1955)

void tmexp_LoadSettings(const char *file);
int  tmexp_IsDstException(uint32_t ip);

#ifdef __cplusplus
} /* extern "C" */
#endif 

#endif
