/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmFunction.h
 *  @brief TMOG Special Functions for Porting
 */

/*
 *  Change Log
 *  2004-02-19 Henry Lin    Initialization version
 */


#ifndef __TMFUNCTION_H__
#define __TMFUNCTION_H__

#include <sys/types.h> /* struct hostent */
#include <netdb.h>     /* struct hostent */

/*
* ------------------------------------------------------------------------------
* Type Definitions
* ------------------------------------------------------------------------------
*/


/*
* ------------------------------------------------------------------------------
* Function Prototypes Section.
* ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

struct hostent *tmGethostbyname(const char *name);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
