/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @tmcfg_st.h
 *  @TMSS configuration Module
 */

/*
 *  Change Log
 *  xxxx-xx-xx Name    Description
 */

#ifndef __TMCFG_ST_H__
#define __TMCFG_ST_H__

struct tag_module_st;
struct tag_param_st;

struct tag_module_st {
	char *name;

	/* param list */
	struct tag_param_st *params;

	struct tag_module_st *prev;
	struct tag_module_st *next;
};

struct tag_param_st {
	char *name;
	char *value;
	char *option;

	struct tag_param_st *prev;
	struct tag_param_st *next;
};

struct tmcfg_st {
	int file_lock;
	tmcfg_open_mode_t mode;
	char *filename;
	FILE *file;
	struct tag_module_st *modules;
	int modified;
};

#endif /* __TMCFG_ST_H__ */
