#ifndef __RESTGART_AFFECTED_H__
#define __RESTGART_AFFECTED_H__
#define TYPE_NONE   0x00
#define TYPE_LAN    0x01
#define TYPE_WAN    0x02

#define TYPE_TIMEZONE  0x10
#define TYPE_DDNS  0x20
#define TYPE_ROUTE  0x40
#define TYPE_URL_FILTER  0x80
#define TYPE_MAC_FILTER  0x100
#define TYPE_IP_QOS  0x200
#define TYPE_BLOCK_WAN  0x400
#define TYPE_HACK_ATTACK  0x800
#define TYPE_REMOTE_CONTORL  0x1000
#define TYPE_UPNP  0x2000
#define TYPE_SNMP  0x4000
#define TYPE_RIP  0x8000
#define TYPE_VLAN  0x10000
#define TYPE_VIRTURL_SERVER  0x20000
#define TYPE_DMZ  0x40000
#define TYPE_PACKET_FILTER  0x80000
#define TYPE_TMSS  0x100000
#define TYPE_SIP  0x200000

//Note for those affected IPtables rules, the VS, DMZ, Packet Filter and SIP order shall be constants. That is
// they are last 4.
void restartAffectedFunctions(int type_sum);

#define PACKET_FILTER_AFFECTED_FUNC (TYPE_TMSS|TYPE_SIP)
#endif /* __RESTGART_AFFECTED_H__ */
