#include "webs.h"
#include "save.h"
#include "lan_conf.h"
#include "dhcp.h"
extern void Load_Dhcpd_Config (DHCPD_CONFIG_DATA  *d,LAN_CONFIG_DATA *l);
extern void Save_Lan_Config (LAN_CONFIG_DATA *d);
extern void Save_Dhcpd_Config (int i,DHCPD_CONFIG_DATA  *d);
extern void Load_Lan_Config (LAN_CONFIG_DATA *d);
static OLD_PEPT_LAN_INFO keptli;
static LAN_CONFIG_DATA temp_lan_config,*tlc=&temp_lan_config;
static DHCPD_CONFIG_DATA temp_dhcpd_config,*tdc=&temp_dhcpd_config;
static void 	form_save_conf(webs_t wp, char_t *path, char_t *query)
{
    FILE           *fp;
	// need to check if we need to restore the old 
    if((fp=fopen(TEMP_LAN_INFO,"r"))!=NULL)
	{
		Load_Lan_Config(tlc);
		Load_Dhcpd_Config(tdc,tlc);

		// backup the newest one
		strcpy(keptli.HostAddress,tlc->HostAddress);
		strcpy(keptli.HostAddress,tlc->HostNetmask);
		keptli.dhcp_enable=tdc->Enable;
		strcpy(keptli.Subnet,tdc->Subnet);
		strcpy(keptli.Netmask,tdc->Netmask);
		strcpy(keptli.Router,tdc->Router);
		strcpy(keptli.Broadcast_address,tdc->Broadcast_address);
		strcpy(keptli.Range_start, tdc->Range_start);
		strcpy(keptli.Range_end,tdc->Range_end);
 
 		fscanf(fp, "%s %s\n",tlc->HostAddress,tlc->HostNetmask);
		Save_Lan_Config(tlc);
		////save_globe_config("/var/etc/status", "LAN_IP=", tlc->HostAddress); No Need since it is not written to flash
		save_globe_config("/flash/config", "LAN_IP=", tlc->HostAddress);
 
 		fscanf(fp,"%d\n",&tdc->Enable);
		fscanf(fp, "%s %s %s %s %s %s\n",tdc->Subnet,tdc->Netmask,tdc->Router,
			tdc->Broadcast_address, tdc->Range_start,tdc->Range_end);
		fclose(fp);		
		unlink(TEMP_LAN_INFO);
		Save_Dhcpd_Config (tdc->Enable, tdc);
	
		// Now we write to flash.
		flash_write();
		
		// Shall we wait for a couple of seconds???
				
		// after write, we shall restore the kept ones.
 		// backup the newest one
		// Before we restore, do we need to check if WAN IP address has been reassigned during the flash write???
		// since we think this is a blocked IO flash write operation, so, the PPP task shall only be up after our this
	    // task finished.
		strcpy(tlc->HostAddress,keptli.HostAddress);
		strcpy(tlc->HostNetmask,keptli.HostAddress);
		tdc->Enable=keptli.dhcp_enable;
		strcpy(tdc->Subnet,keptli.Subnet);
		strcpy(tdc->Netmask,keptli.Netmask);
		strcpy(tdc->Router,keptli.Router);
		strcpy(tdc->Broadcast_address,keptli.Broadcast_address);
		strcpy(tdc->Range_start,keptli.Range_start);
		strcpy(tdc->Range_end,keptli.Range_end);

		Save_Lan_Config(tlc);
		////save_globe_config("/var/etc/status", "LAN_IP=", tlc->HostAddress); No Need since it is not written to flash
		save_globe_config("/flash/config", "LAN_IP=", tlc->HostAddress);
 		Save_Dhcpd_Config (tdc->Enable, tdc);
	}

	else
	{
		flash_write();
	}
	//
  	websRedirect(wp, T("home.asp"));
}

void DefineWebFunctions_save() 
{
	websFormDefine ( T("save"), form_save_conf);
}
