/*
 *  seclog.h: Security Log
 */
#include "webs.h"
#include "seclog.h"
#define SECURITY_LOG_FILE "/var/log/security"
#define LimitRowNum 500
char_t pSecLog[LimitRowNum][255];
static void form_clear_sec_conf (webs_t wp, char_t* path, char_t* query);
static int read_SecurityLog (int ejid, webs_t wp, int argc, char_t **argv);
static int read_SecurityLog (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t line[255];
	int i,j,k;
	FILE *fp;
	i=0;
	fp=fopen(SECURITY_LOG_FILE,"r");
	if (fp==NULL) return -1;
	while(fgets(line, 255, fp))
	{
		i++;
	}
	fclose(fp);
	
	fp=fopen(SECURITY_LOG_FILE,"r");
	if (fp==NULL) return -1;
	if (i<=LimitRowNum)
	{
		j=0;
		while(fgets(line, 255, fp))
    		{
    			strcpy(pSecLog[j],line);
    			j++;
    		}
	}
	else
	{
		while((i-LimitRowNum)>=0)
		{
			fgets(line, 255, fp);
			i--;
		}
		j=0;
		while(fgets(line, 255, fp))
    		{
    			strcpy(pSecLog[j],line);
    			j++;
    		}
	}
	fclose(fp);
	if (i<LimitRowNum){
	for (k=0;k<i;k++)
		 websWrite(wp, T("%s"), pSecLog[k]);
	}else{
	for (k=0;k<LimitRowNum;k++)
		 websWrite(wp, T("%s"), pSecLog[k]);
	}
	return 0;
}

static void form_clear_sec_conf (webs_t wp, char_t* path, char_t* query)
{
	FILE *fp;
	fp=fopen(SECURITY_LOG_FILE,"w");
	if (fp==NULL) return;
	fclose(fp);
	websRedirect(wp, T("seclog.asp"));
}


void DefineWebFunctions_SecurityLog() {
	websAspDefine ( T("read_Security_Log"), read_SecurityLog);
	websFormDefine ( T("clear_seclog"), form_clear_sec_conf);
}
