/*
 *  setvs.htm: Virtual Server Configuration
 */
#ifndef _VIRTUAL_SERVER_CFG_H_
#define _VIRTUAL_SERVER_CFG_H_
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

void DefineWebFunctions_VirtualServer();

#define MAX_NAT_VIRTUAL_SERVER	30
//#define UINT32  int
//typedef int UINT32;
//ypedef unsigned int STATUS;
//#define STATUS unsigned int
//#define OK 0
//#define ERROR 1
//#define UI32_T uint32_t 
//#define UI16_T uint16_t

typedef struct NAT_VIRTUAL_SERVER_S
{
	struct in_addr host_ip;
	unsigned short	public_port;
	unsigned short	end_public_port;    // Mulder added 4-18-2003 for port range
	unsigned short	private_port;
	unsigned int	proto_type; 
	/* Currently only support:
	IPPROTO_IP = 0, Dummy protocol for TCP(Do not care the protocol. It shall be only UDP and TCP currently)
   IPPROTO_TCP = 6,	
  IPPROTO_UDP = 17, */
 
} NAT_VIRTUAL_SERVER_T;

/* Export Function */
extern int NAT_VS_GetEntry(unsigned int, NAT_VIRTUAL_SERVER_T *);
extern int NAT_VS_AddEntry(NAT_VIRTUAL_SERVER_T);
extern int NAT_VS_DeleteEntry(unsigned int);
extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);

#endif	/* _VIRTUAL_SERVER_CFG_H_ */
