/*
 *  syslog.htm: System Log
 */
#include "webs.h"
#include "syslog.h"


#define SYSTEM_LOG_FILE "/var/log/messages"
#define LimitRowNum 500 
char_t pSystemLog[LimitRowNum][255];
static void form_clear_system_conf (webs_t wp, char_t* path, char_t* query);
static int read_SystemLog (int ejid, webs_t wp, int argc, char_t **argv);
static int read_SystemLog (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t line[255];
	int i,j,k;
	FILE *fp;
	i=0;
	fp=fopen(SYSTEM_LOG_FILE,"r");
	if (fp==NULL) return -1;
	while(fgets(line, 255, fp))
	{
		i++;
	}
	fclose(fp);
	
	fp=fopen(SYSTEM_LOG_FILE,"r");
	if (fp==NULL) return -1;
	if (i<=LimitRowNum)
	{
		j=0;
		while(fgets(line, 255, fp))
    		{
    			strcpy(pSystemLog[j],line);
    			j++;
    		}
	}
	else
	{
		while((i-LimitRowNum)>=0)
		{
			fgets(line, 255, fp);
			i--;
		}
		j=0;
		while(fgets(line, 255, fp))
    		{
    			strcpy(pSystemLog[j],line);
    			j++;
    		}
	}
	fclose(fp);	
	if (i<LimitRowNum){
	for (k=0;k<i;k++)
		 websWrite(wp, T("%s"), pSystemLog[k]);
	}else{
	for (k=0;k<LimitRowNum;k++)
		 websWrite(wp, T("%s"), pSystemLog[k]);
	}

	return 0;
}
static void form_clear_system_conf (webs_t wp, char_t* path, char_t* query)
{
	FILE *fp;
	fp=fopen(SYSTEM_LOG_FILE,"w");
	if (fp==NULL) return;
	fclose(fp);
	websRedirect(wp, T("syslog.asp"));
}


void DefineWebFunctions_SystemLog() {
	websAspDefine ( T("read_System_Log"), read_SystemLog);
	websFormDefine ( T("clear_systemlog"), form_clear_system_conf);
}
