#ifndef __DVD_INTERRUPT_H
#define __DVD_INTERRUPT_H

#define RISC_INT0		0
#define RISC_INT1		1
#define RISC_INT2		2
#define RISC_INT3		3
#define R_UNMAP			4
#define X_UNMAP			5
#define UART2_INTR		6
#define UART1_INTR		7
#define H_PIOFREE_INT		8
#define H_DEVICE_INT		9
#define O_FIELD_END		10
#define V_PIC_END_INT		11
#define TIMER0_INTR		12
#define TIMER1_INTR		13
#define EXCEPTION_FLAG		14
#define V_ERR			15

#ifdef NR_IRQS
#undef NR_IRQS
#define NR_IRQS			16
#endif

#define RISC_INT0_BIT		1<<0
#define RISC_INT1_BIT		1<<1
#define RISC_INT2_BIT		1<<2
#define RISC_INT3_BIT		1<<3
#define R_UNMAP_BIT		1<<4
#define X_UNMAP_BIT             1<<5
#define UART2_INTR_BIT		1<<6
#define UART1_INTR_BIT          1<<7
#define H_PIOFREE_INT_BIT	1<<8
#define H_DEVICE_INT_BIT	1<<9
#define O_FIELD_END_BIT		1<<10
#define V_PIC_END_INT_BIT	1<<11
#define TIMER0_INTR_BIT		1<<12
#define TIMER1_INTR_BIT		1<<13
#define EXCEPTION_FLAG_BIT	1<<14
#define V_ERR_BIT		1<<15
#endif