
/*  
 * Definitions used to for memory interface module.
 *
 * Copyright (C) 2002 Viosoft Corp.
 * Support for TrendChip TC3160
 */

#ifndef __TC3160_MI_H__ 
#define __TC3160_MI_H__ 

#include <asm/addrspace.h>

#define TC3160_MI_BASE		(KSEG1 + 0x12000000)
#define TC3160_SMCR1_REG	(TC3160_MI_BASE + 0x0)
#define TC3160_SMCR2_REG	(TC3160_MI_BASE + 0x4)
#define TC3160_SMCR3_REG	(TC3160_MI_BASE + 0x8)
#define TC3160_SMCR4_REG	(TC3160_MI_BASE + 0xc)
#define TC3160_SDRAMCR_REG	(TC3160_MI_BASE + 0x10)

#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3160_MI_H__ */

