/*  
 * Definitions used for Flash Controller Operation register.
 *
 * Written by Robert Wu, Billion Co.
 * Support for TrendChip TC3162
 */

#ifndef __TC3162_SMC_H__ 
#define __TC3162_SMC_H__ 

#include <asm/addrspace.h>

#define TC3162_SMC_BASE		(KSEG1 + 0x1FB10000)
#define TC3162_SMCBCR0_REG		(TC3162_SMC_BASE + 0x0)
#define TC3162_SMCBCR1_REG		(TC3162_SMC_BASE + 0x1)
#define TC3162_SMCBCR2_REG		(TC3162_SMC_BASE + 0x2)
#define TC3162_SMCBCR3_REG		(TC3162_SMC_BASE + 0x3)
#define TC3162_SMCBCR4_REG		(TC3162_SMC_BASE + 0x4)
#define TC3162_SMCBCR5_REG		(TC3162_SMC_BASE + 0x5)


#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3162_SMC_H__ */


