unsigned char* skb_pull(struct sk_buff*  skb,int len){
        skb->len   -=len;
        skb->data += len;
         if (skb->data + skb->len > skb->head + skb->nb_blen)
                {
                printf("//exceed!!0x%08x 0x%08x %d\n",skb,skb->data,len);
                 return NULL;
                }
        return  (unsigned char*)skb->data;

};
unsigned char* skb_put(struct sk_buff*  skb,int len){
        skb->len+=len;
        //which means skb has no enough room to put
        if( (skb->data + skb->len) >(skb->head + skb->nb_blen)) {
                //skb_over_panic(skb, len, current_text_addr());
                printf("Not Enough Room to put!0x%08x %d %d %d %d\n",skb->head,skb->data-skb->head,len,skb->nb_blen,skb->len);
                return NULL;
         }
        return (unsigned char*)(skb->data+skb->len);
};

unsigned char* skb_push(struct sk_buff*  skb,int len){
         skb->data-=len;
         skb->len+=len;
         if(skb->data<skb->head) {
                 //skb_under_panic(skb, len, current_text_addr());
                 printf("SKB push Under\n!");
                 return NULL;
         }
        return (unsigned char*)skb->data;
};
